from pypdevs.DEVS import *
from pypdevs.infinity import INFINITY

class Attributer:
	def __init__(self, att=None):
		self.att = att


	def __str__(self):
		s = ""
		s += "state.att = " + str(self.att) + "\n"
		return s


class Activity_Delay_Attribute_test(CoupledDEVS):
	def __init__(self, name = "Activity_Delay_Attribute_test", gen1_generator_value = {"delay" : 0.5, "value" : "test"}, gen2_generator_value = Attributer(att=0.66), delay2_attribute_name = "att"):
		CoupledDEVS.__init__(self, name)

		self.my_ports = {}
		self.submodels = {}

		self.my_ports = {}

		self.submodels["delay1"] = self.addSubModel(Activity_Delay_Attribute(name = "delay1"))
		self.submodels["delay2"] = self.addSubModel(Activity_Delay_Attribute(name = "delay2", attribute_name = delay2_attribute_name))
		self.submodels["gen1"] = self.addSubModel(Generator(name = "gen1", generator_value = gen1_generator_value))
		self.submodels["gen2"] = self.addSubModel(Generator(name = "gen2", generator_value = gen2_generator_value))
		self.connectPorts(self.submodels["gen1"].my_ports["generated"], self.submodels["delay1"].my_ports["input"])
		self.connectPorts(self.submodels["gen2"].my_ports["generated"], self.submodels["delay2"].my_ports["input"])

	def select(self, imm):
		for i, val in enumerate(imm):
			if isinstance(val, AtomicDEVS) or isinstance(val, CoupledDEVS):
				if val.getModelName() == "delay1":
					return val
		for i, val in enumerate(imm):
			if isinstance(val, AtomicDEVS) or isinstance(val, CoupledDEVS):
				if val.getModelName() == "delay2":
					return val
		for i, val in enumerate(imm):
			if isinstance(val, AtomicDEVS) or isinstance(val, CoupledDEVS):
				if val.getModelName() == "gen1":
					return val
		for i, val in enumerate(imm):
			if isinstance(val, AtomicDEVS) or isinstance(val, CoupledDEVS):
				if val.getModelName() == "gen2":
					return val
		return imm[0]

class Activity_Delay_AttributeState:
	def __init__(self, name="", attribute_name=None, delay_time=None, buffer=None):
		self.name = name
		self.attribute_name = attribute_name
		self.delay_time = delay_time
		self.buffer = buffer


	def __str__(self):
		s = ""
		s += "state.name = " + str(self.name) + "\n"
		s += "state.attribute_name = " + str(self.attribute_name) + "\n"
		s += "state.delay_time = " + str(self.delay_time) + "\n"
		s += "state.buffer = " + str(self.buffer) + "\n"
		return s

class Activity_Delay_Attribute(AtomicDEVS):
	def __init__(self, name = "Activity_Delay_Attribute", attribute_name="delay", delay_time=1.0, buffer=None):
		AtomicDEVS.__init__(self, name)

		self.my_ports = {}

		self.state = Activity_Delay_AttributeState(name="receiving", attribute_name=attribute_name, delay_time=delay_time, buffer=buffer)

		self.my_ports = {"input": self.addInPort("input"), "release": self.addOutPort("release"), "delay": self.addInPort("delay")}

	def timeAdvance(self):
		if self.state.name == "receiving":
			return INFINITY
			
		if self.state.name == "hold_to_release":
			return self.state.delay_time
			
	def outputFnc(self):
		def subfunc(self):
			if self.state.name == "receiving":
				return {"release" : "test"}
				
			if self.state.name == "hold_to_release":
				return {"release" : self.state.buffer}
				
		return {self.my_ports[k]: v for k, v in subfunc(self).iteritems()}
	def intTransition(self):
		def cond_int_hold_to_release_to_receiving():
			return True
			
		def action_int_hold_to_release_to_receiving():
			return {"buffer" : self.state.buffer, "delay_time" : self.state.delay_time, "attribute_name" : self.state.attribute_name}
			
		if self.state.name == "hold_to_release" and cond_int_hold_to_release_to_receiving():
			return Activity_Delay_AttributeState(name="receiving", **action_int_hold_to_release_to_receiving())

		else:
			return AtomicDEVS.intTransition(self)
	def extTransition(self, my_inputs):
		inputs = {k.getPortName(): v for k, v in my_inputs.iteritems()}
		def cond_ext_hold_to_release_to_hold_to_release():
			if 'delay' in inputs.keys():
				return True
			return False
			
		def action_ext_hold_to_release_to_hold_to_release():
			return {"buffer" : self.state.buffer, "delay_time" : inputs['delay'], "attribute_name" : self.state.attribute_name}
			
		def cond_ext_receiving_to_receiving():
			if 'delay' in inputs.keys():
				return True
			return False
			
		def action_ext_receiving_to_receiving():
			return {"buffer" : self.state.buffer, "delay_time" : inputs['delay'], "attribute_name" : self.state.attribute_name}
			
		def cond_ext_receiving_to_hold_to_release():
			if 'input' in inputs.keys() and 'delay' in inputs.keys():
				return False
			if 'input' in inputs.keys():
				return True
			return False
			
		def action_ext_receiving_to_hold_to_release():
			input = inputs['input']
			try:
				dele = getattr(input, self.state.attribute_name)
			except Exception:
				dele = None
			if dele == None:
				try:
					dele = input.get(self.state.attribute_name, None)
				except Exception:
					dele = None
			if dele == None:
				dele = self.state.delay_time
			return {"buffer" : input, "delay_time" : dele, "attribute_name" : self.state.attribute_name}
			
		if self.state.name == "hold_to_release" and cond_ext_hold_to_release_to_hold_to_release():
			return Activity_Delay_AttributeState(name="hold_to_release", **action_ext_hold_to_release_to_hold_to_release())


		if self.state.name == "receiving" and cond_ext_receiving_to_receiving():
			return Activity_Delay_AttributeState(name="receiving", **action_ext_receiving_to_receiving())


		if self.state.name == "receiving" and cond_ext_receiving_to_hold_to_release():
			return Activity_Delay_AttributeState(name="hold_to_release", **action_ext_receiving_to_hold_to_release())


		else:
			return AtomicDEVS.extTransition(self, my_inputs)


class atomic_generatorState:
	def __init__(self, name="", period=None, value=None):
		self.name = name
		self.period = period
		self.value = value


	def __str__(self):
		s = ""
		s += "state.name = " + str(self.name) + "\n"
		s += "state.period = " + str(self.period) + "\n"
		s += "state.value = " + str(self.value) + "\n"
		return s

class atomic_generator(AtomicDEVS):
	def __init__(self, name = "atomic_generator", period=1, value=1):
		AtomicDEVS.__init__(self, name)

		self.my_ports = {}

		self.state = atomic_generatorState(name="generating", period=period, value=value)

		self.my_ports = {"generated": self.addOutPort("generated")}

	def timeAdvance(self):
		if self.state.name == "generating":
			return self.state.period
			
	def outputFnc(self):
		def subfunc(self):
			if self.state.name == "generating":
				return {'generated' : self.state.value}
				
		return {self.my_ports[k]: v for k, v in subfunc(self).iteritems()}
	def intTransition(self):
		def cond_int_generating_to_generating():
			return True
			
		def action_int_generating_to_generating():
			return {"value" : self.state.value, "period" : self.state.period}
			
		if self.state.name == "generating" and cond_int_generating_to_generating():
			return atomic_generatorState(name="generating", **action_int_generating_to_generating())

		else:
			return AtomicDEVS.intTransition(self)
	def extTransition(self, my_inputs):
		inputs = {k.getPortName(): v for k, v in my_inputs.iteritems()}
		return AtomicDEVS.extTransition(self, my_inputs)

class Generator(CoupledDEVS):
	def __init__(self, name = "Generator", generator_value = 1, generator_period = 1):
		CoupledDEVS.__init__(self, name)

		self.my_ports = {}
		self.submodels = {}

		self.my_ports = {"generated": self.addOutPort("generated")}

		self.submodels["generator"] = self.addSubModel(atomic_generator(name = "generator", value = generator_value, period = generator_period))
		self.connectPorts(self.submodels["generator"].my_ports["generated"], self.my_ports["generated"])

	def select(self, imm):
		for i, val in enumerate(imm):
			if isinstance(val, AtomicDEVS) or isinstance(val, CoupledDEVS):
				if val.getModelName() == "atomic_generator":
					return val
		for i, val in enumerate(imm):
			if isinstance(val, AtomicDEVS) or isinstance(val, CoupledDEVS):
				if val.getModelName() == "generator":
					return val
		return imm[0]

