from pypdevs.DEVS import *
from pypdevs.infinity import INFINITY

class Activity_Delay_AttributeState:
	def __init__(self, name="", attribute_name=None, delay_time=None, buffer=None):
		self.name = name
		self.attribute_name = attribute_name
		self.delay_time = delay_time
		self.buffer = buffer


	def __str__(self):
		s = ""
		s += "state.name = " + str(self.name) + "\n"
		s += "state.attribute_name = " + str(self.attribute_name) + "\n"
		s += "state.delay_time = " + str(self.delay_time) + "\n"
		s += "state.buffer = " + str(self.buffer) + "\n"
		return s

class Activity_Delay_Attribute(AtomicDEVS):
	def __init__(self, name = "Activity_Delay_Attribute", attribute_name="delay", delay_time=1.0, buffer=None):
		AtomicDEVS.__init__(self, name)

		self.my_ports = {}

		self.state = Activity_Delay_AttributeState(name="receiving", attribute_name=attribute_name, delay_time=delay_time, buffer=buffer)

		self.my_ports = {"input": self.addInPort("input"), "release": self.addOutPort("release"), "delay": self.addInPort("delay")}

	def timeAdvance(self):
		if self.state.name == "receiving":
			return INFINITY
			
		if self.state.name == "hold_to_release":
			return self.state.delay_time - self.elapsed
			
	def outputFnc(self):
		def subfunc(self):
			if self.state.name == "receiving":
				return {"release" : "test"}
				
			if self.state.name == "hold_to_release":
				return {"release" : self.state.buffer}
				
		return {self.my_ports[k]: v for k, v in subfunc(self).iteritems()}
	def intTransition(self):
		def cond_int_hold_to_release_to_receiving():
			return True
			
		def action_int_hold_to_release_to_receiving():
			return {"buffer" : self.state.buffer, "delay_time" : self.state.delay_time, "attribute_name" : self.state.attribute_name}
			
		if self.state.name == "hold_to_release" and cond_int_hold_to_release_to_receiving():
			return Activity_Delay_AttributeState(name="receiving", **action_int_hold_to_release_to_receiving())

		else:
			return AtomicDEVS.intTransition(self)
	def extTransition(self, my_inputs):
		inputs = {k.getPortName(): v for k, v in my_inputs.iteritems()}
		def cond_ext_hold_to_release_to_hold_to_release():
			if 'delay' in inputs.keys():
				return True
			return False
			
		def action_ext_hold_to_release_to_hold_to_release():
			return {"buffer" : self.state.buffer, "delay_time" : inputs['delay'], "attribute_name" : self.state.attribute_name}
			
		def cond_ext_receiving_to_receiving():
			if 'delay' in inputs.keys():
				return True
			return False
			
		def action_ext_receiving_to_receiving():
			return {"buffer" : self.state.buffer, "delay_time" : inputs['delay'], "attribute_name" : self.state.attribute_name}
			
		def cond_ext_receiving_to_hold_to_release():
			if 'input' in inputs.keys() and 'delay' in inputs.keys():
				return False
			if 'input' in inputs.keys():
				return True
			return False
			
		def action_ext_receiving_to_hold_to_release():
			self.elapsed = 0
			input = inputs['input']
			try:
				dele = getattr(input, self.state.attribute_name)
			except Exception:
				dele = None
			if dele == None:
				try:
					dele = input.get(self.state.attribute_name, None)
				except Exception:
					dele = None
			if dele == None:
				dele = self.state.delay_time
			return {"buffer" : input, "delay_time" : dele, "attribute_name" : self.state.attribute_name}
			
		if self.state.name == "hold_to_release" and cond_ext_hold_to_release_to_hold_to_release():
			return Activity_Delay_AttributeState(name="hold_to_release", **action_ext_hold_to_release_to_hold_to_release())


		if self.state.name == "receiving" and cond_ext_receiving_to_receiving():
			return Activity_Delay_AttributeState(name="receiving", **action_ext_receiving_to_receiving())


		if self.state.name == "receiving" and cond_ext_receiving_to_hold_to_release():
			return Activity_Delay_AttributeState(name="hold_to_release", **action_ext_receiving_to_hold_to_release())


		else:
			return AtomicDEVS.extTransition(self, my_inputs)


