from pypdevs.DEVS import *
from pypdevs.infinity import INFINITY

class BatchState:
	def __init__(self, name="", auto_send=None, buffer3=None, buffer2=None, buffer1=None, incoming3_amount=None, incoming2_amount=None, incoming1_amount=None):
		self.name = name
		self.auto_send = auto_send
		self.buffer3 = buffer3
		self.buffer2 = buffer2
		self.buffer1 = buffer1
		self.incoming3_amount = incoming3_amount
		self.incoming2_amount = incoming2_amount
		self.incoming1_amount = incoming1_amount


	def __str__(self):
		s = ""
		s += "state.name = " + str(self.name) + "\n"
		s += "state.auto_send = " + str(self.auto_send) + "\n"
		s += "state.buffer3 = " + str(self.buffer3) + "\n"
		s += "state.buffer2 = " + str(self.buffer2) + "\n"
		s += "state.buffer1 = " + str(self.buffer1) + "\n"
		s += "state.incoming3_amount = " + str(self.incoming3_amount) + "\n"
		s += "state.incoming2_amount = " + str(self.incoming2_amount) + "\n"
		s += "state.incoming1_amount = " + str(self.incoming1_amount) + "\n"
		return s

class Batch(AtomicDEVS):
	def __init__(self, name = "Batch", auto_send=True, buffer3=[], buffer2=[], buffer1=[], incoming3_amount=1, incoming2_amount=1, incoming1_amount=1):
		AtomicDEVS.__init__(self, name)

		self.my_ports = {}

		self.state = BatchState(name="receiving", auto_send=auto_send, buffer3=buffer3, buffer2=buffer2, buffer1=buffer1, incoming3_amount=incoming3_amount, incoming2_amount=incoming2_amount, incoming1_amount=incoming1_amount)

		self.my_ports = {"incoming1": self.addInPort("incoming1"), "incoming2": self.addInPort("incoming2"), "incoming3": self.addInPort("incoming3"), "outgoing": self.addOutPort("outgoing"), "demand": self.addInPort("demand")}

	def timeAdvance(self):
		if self.state.name == "receiving":
			return INFINITY
			
		if self.state.name == "sending":
			return 0
			
	def outputFnc(self):
		def subfunc(self):
			if self.state.name == "receiving":
				return {}
				
			if self.state.name == "sending":
				result = []
				result1 = []
				result2 = []
				result3 = []
				for x in range(0, self.state.incoming1_amount):
					result1.insert(0, self.state.buffer1.pop())
				for x in range(0, self.state.incoming2_amount):
					result2.insert(0, self.state.buffer2.pop())
				for x in range(0, self.state.incoming3_amount):
					result3.insert(0, self.state.buffer3.pop())
				result.append(result1)
				result.append(result2)
				result.append(result3)
				return {'outgoing' : result}
				
		return {self.my_ports[k]: v for k, v in subfunc(self).iteritems()}
	def intTransition(self):
		def cond_int_sending_to_receiving():
			return True
			
		def action_int_sending_to_receiving():
			return {'incoming1_amount' : self.state.incoming1_amount, 'incoming2_amount' : self.state.incoming2_amount, 'incoming3_amount' : self.state.incoming3_amount, 'buffer1' : self.state.buffer1, 'buffer2' : self.state.buffer2, 'buffer3' : self.state.buffer3, 'auto_send' : self.state.auto_send}
			
		if self.state.name == "sending" and cond_int_sending_to_receiving():
			return BatchState(name="receiving", **action_int_sending_to_receiving())

		else:
			return AtomicDEVS.intTransition(self)
	def extTransition(self, my_inputs):
		inputs = {k.getPortName(): v for k, v in my_inputs.iteritems()}
		def cond_ext_receiving_to_receiving():
			if 'incoming1' in inputs.keys():
				if len(self.state.buffer1) < (self.state.incoming1_amount - 1) or len(self.state.buffer2) < self.state.incoming2_amount or len(self.state.buffer3) < self.state.incoming3_amount or self.state.auto_send == False:
					return True
			if 'incoming2' in inputs.keys():
				if len(self.state.buffer2) < (self.state.incoming2_amount - 1) or len(self.state.buffer1) < self.state.incoming1_amount or len(self.state.buffer3) < self.state.incoming3_amount or self.state.auto_send == False:
					return True
			if 'incoming3' in inputs.keys():
				if len(self.state.buffer3) < (self.state.incoming3_amount - 1) or len(self.state.buffer2) < self.state.incoming2_amount or len(self.state.buffer1) < self.state.incoming1_amount or self.state.auto_send == False:
					return True
			return False
			
		def action_ext_receiving_to_receiving():
			if 'incoming1' in inputs.keys():
				self.state.buffer1.insert(0, inputs['incoming1'])
			if 'incoming2' in inputs.keys():
				self.state.buffer2.insert(0, inputs['incoming2'])
			if 'incoming3' in inputs.keys():
				self.state.buffer3.insert(0, inputs['incoming3'])
			return {'incoming1_amount' : self.state.incoming1_amount, 'incoming2_amount' : self.state.incoming2_amount, 'incoming3_amount' : self.state.incoming3_amount, 'buffer1' : self.state.buffer1, 'buffer2' : self.state.buffer2, 'buffer3' : self.state.buffer3,  'auto_send' : self.state.auto_send}
			
		def cond_ext_receiving_to_sending():
			if 'incoming1' in inputs.keys():
				if len(self.state.buffer1) == (self.state.incoming1_amount - 1) and len(self.state.buffer2) >= self.state.incoming2_amount and len(self.state.buffer3) >= self.state.incoming3_amount and self.state.auto_send:
					return True
			if 'incoming2' in inputs.keys():
				if len(self.state.buffer2) == (self.state.incoming2_amount - 1) and len(self.state.buffer1) >= self.state.incoming1_amount and len(self.state.buffer3) >= self.state.incoming3_amount and self.state.auto_send:
					return True
			if 'incoming3' in inputs.keys():
				if len(self.state.buffer3) == (self.state.incoming3_amount - 1) and len(self.state.buffer2) >= self.state.incoming2_amount and len(self.state.buffer1) >= self.state.incoming1_amount and self.state.auto_send:
					return True
			if 'demand' in inputs.keys():
				return True
			return False
			
		def action_ext_receiving_to_sending():
			if 'incoming1' in inputs.keys():
				self.state.buffer1.insert(0, inputs['incoming1'])
			if 'incoming2' in inputs.keys():
				self.state.buffer2.insert(0, inputs['incoming2'])
			if 'incoming3' in inputs.keys():
				self.state.buffer3.insert(0, inputs['incoming3'])
			return {'incoming1_amount' : self.state.incoming1_amount, 'incoming2_amount' : self.state.incoming2_amount, 'incoming3_amount' : self.state.incoming3_amount, 'buffer1' : self.state.buffer1, 'buffer2' : self.state.buffer2, 'buffer3' : self.state.buffer3,  'auto_send' : self.state.auto_send}
			
		if self.state.name == "receiving" and cond_ext_receiving_to_receiving():
			return BatchState(name="receiving", **action_ext_receiving_to_receiving())


		if self.state.name == "receiving" and cond_ext_receiving_to_sending():
			return BatchState(name="sending", **action_ext_receiving_to_sending())


		else:
			return AtomicDEVS.extTransition(self, my_inputs)


