from pypdevs.DEVS import *
from pypdevs.infinity import INFINITY

class Attributer:
	def __init__(self, att=None):
		self.att = att


	def __str__(self):
		s = ""
		s += "state.att = " + str(self.att) + "\n"
		return s


class Change_Attribute_test(CoupledDEVS):
	def __init__(self, name = "Change_Attribute_test", change_operation = "/", change_mod_value = 2, gen_generator_value = Attributer(att = 6), change_attribute_name = "att"):
		CoupledDEVS.__init__(self, name)

		self.my_ports = {}
		self.submodels = {}

		self.my_ports = {}

		self.submodels["change"] = self.addSubModel(Change_Attribute(name = "change", operation = change_operation, mod_value = change_mod_value, attribute_name = change_attribute_name))
		self.submodels["gen"] = self.addSubModel(Generator(name = "gen", generator_value = gen_generator_value))
		self.connectPorts(self.submodels["gen"].my_ports["generated"], self.submodels["change"].my_ports["incoming"])

	def select(self, imm):
		for i, val in enumerate(imm):
			if isinstance(val, AtomicDEVS) or isinstance(val, CoupledDEVS):
				if val.getModelName() == "change":
					return val
		for i, val in enumerate(imm):
			if isinstance(val, AtomicDEVS) or isinstance(val, CoupledDEVS):
				if val.getModelName() == "gen":
					return val
		return imm[0]

class Change_AttributeState:
	def __init__(self, name="", buffer=None, attribute_name=None, operation=None, mod_value=None):
		self.name = name
		self.buffer = buffer
		self.attribute_name = attribute_name
		self.operation = operation
		self.mod_value = mod_value


	def __str__(self):
		s = ""
		s += "state.name = " + str(self.name) + "\n"
		s += "state.buffer = " + str(self.buffer) + "\n"
		s += "state.attribute_name = " + str(self.attribute_name) + "\n"
		s += "state.operation = " + str(self.operation) + "\n"
		s += "state.mod_value = " + str(self.mod_value) + "\n"
		return s

class Change_Attribute(AtomicDEVS):
	def __init__(self, name = "Change_Attribute", buffer=None, attribute_name=None, operation="+", mod_value=1):
		AtomicDEVS.__init__(self, name)

		self.my_ports = {}

		self.state = Change_AttributeState(name="incoming", buffer=buffer, attribute_name=attribute_name, operation=operation, mod_value=mod_value)

		self.my_ports = {"incoming": self.addInPort("incoming"), "outgoing": self.addOutPort("outgoing"), "value": self.addInPort("value")}

	def timeAdvance(self):
		if self.state.name == "incoming":
			return INFINITY
			
		if self.state.name == "outgoing":
			return 0
			
	def outputFnc(self):
		def subfunc(self):
			if self.state.name == "incoming":
				return {}
				
			if self.state.name == "outgoing":
				return {"outgoing": self.state.buffer}
				
		return {self.my_ports[k]: v for k, v in subfunc(self).iteritems()}
	def intTransition(self):
		def cond_int_outgoing_to_incoming():
			return True
			
		def action_int_outgoing_to_incoming():
			return {"buffer" : self.state.buffer, "operation" : self.state.operation, "attribute_name" : self.state.attribute_name, "mod_value" : self.state.mod_value}
			
		if self.state.name == "outgoing" and cond_int_outgoing_to_incoming():
			return Change_AttributeState(name="incoming", **action_int_outgoing_to_incoming())

		else:
			return AtomicDEVS.intTransition(self)
	def extTransition(self, my_inputs):
		inputs = {k.getPortName(): v for k, v in my_inputs.iteritems()}
		def cond_ext_incoming_to_incoming():
			if 'value' in inputs.keys():
				return True
			return False
			
		def action_ext_incoming_to_incoming():
			return {"buffer" : self.state.buffer, "operation" : self.state.operation, "attribute_name" : self.state.attribute_name, "mod_value" : inputs[value]}
			
		def cond_ext_incoming_to_outgoing():
			if 'incoming' in inputs.keys():
				return True
			return False
			
		def action_ext_incoming_to_outgoing():
			input = inputs['incoming']
			import operator
			ops = {"+": operator.add, "-": operator.sub, "*": operator.mul, "/": operator.div}
			op_func = ops[self.state.operation]
			try:
				dele = getattr(input, self.state.attribute_name)
				if isinstance(dele, (int, float, long)):
					result = op_func(dele, self.state.mod_value)
					setattr(input, self.state.attribute_name, result)
				return {"buffer" : input, "operation" : self.state.operation, "attribute_name" : self.state.attribute_name, "mod_value" : self.state.mod_value}
			except Exception:
				dele = None
			if dele == None:
				try:
					dele = input.get(self.state.attribute_name, None)
					if isinstance(dele, (int, float, long)):
						result = op_func(dele, self.state.mod_value)
						input[self.state.attribute_name] = result
					return {"buffer" : input, "operation" : self.state.operation, "attribute_name" : self.state.attribute_name, "mod_value" : self.state.mod_value}
				except Exception:
					dele = None
			if dele == None:
				dele = input
			if isinstance(dele, (int, float, long)):
				result = op_func(dele, self.state.mod_value)
				return {"buffer" : result, "operation" : self.state.operation, "attribute_name" : self.state.attribute_name, "mod_value" : self.state.mod_value}
			return {"buffer" : input, "operation" : self.state.operation, "attribute_name" : self.state.attribute_name, "mod_value" : self.state.mod_value}
			
		if self.state.name == "incoming" and cond_ext_incoming_to_incoming():
			return Change_AttributeState(name="incoming", **action_ext_incoming_to_incoming())


		if self.state.name == "incoming" and cond_ext_incoming_to_outgoing():
			return Change_AttributeState(name="outgoing", **action_ext_incoming_to_outgoing())


		else:
			return AtomicDEVS.extTransition(self, my_inputs)


class atomic_generatorState:
	def __init__(self, name="", period=None, value=None):
		self.name = name
		self.period = period
		self.value = value


	def __str__(self):
		s = ""
		s += "state.name = " + str(self.name) + "\n"
		s += "state.period = " + str(self.period) + "\n"
		s += "state.value = " + str(self.value) + "\n"
		return s

class atomic_generator(AtomicDEVS):
	def __init__(self, name = "atomic_generator", period=1, value=1):
		AtomicDEVS.__init__(self, name)

		self.my_ports = {}

		self.state = atomic_generatorState(name="generating", period=period, value=value)

		self.my_ports = {"generated": self.addOutPort("generated")}

	def timeAdvance(self):
		if self.state.name == "generating":
			return self.state.period
			
	def outputFnc(self):
		def subfunc(self):
			if self.state.name == "generating":
				return {'generated' : self.state.value}
				
		return {self.my_ports[k]: v for k, v in subfunc(self).iteritems()}
	def intTransition(self):
		def cond_int_generating_to_generating():
			return True
			
		def action_int_generating_to_generating():
			return {"value" : self.state.value, "period" : self.state.period}
			
		if self.state.name == "generating" and cond_int_generating_to_generating():
			return atomic_generatorState(name="generating", **action_int_generating_to_generating())

		else:
			return AtomicDEVS.intTransition(self)
	def extTransition(self, my_inputs):
		inputs = {k.getPortName(): v for k, v in my_inputs.iteritems()}
		return AtomicDEVS.extTransition(self, my_inputs)

class Generator(CoupledDEVS):
	def __init__(self, name = "Generator", generator_value = 1, generator_period = 1):
		CoupledDEVS.__init__(self, name)

		self.my_ports = {}
		self.submodels = {}

		self.my_ports = {"generated": self.addOutPort("generated")}

		self.submodels["generator"] = self.addSubModel(atomic_generator(name = "generator", value = generator_value, period = generator_period))
		self.connectPorts(self.submodels["generator"].my_ports["generated"], self.my_ports["generated"])

	def select(self, imm):
		for i, val in enumerate(imm):
			if isinstance(val, AtomicDEVS) or isinstance(val, CoupledDEVS):
				if val.getModelName() == "atomic_generator":
					return val
		for i, val in enumerate(imm):
			if isinstance(val, AtomicDEVS) or isinstance(val, CoupledDEVS):
				if val.getModelName() == "generator":
					return val
		return imm[0]

