from pypdevs.DEVS import *
from pypdevs.infinity import INFINITY

class Change_AttributeState:
	def __init__(self, name="", buffer=None, attribute_name=None, operation=None, mod_value=None):
		self.name = name
		self.buffer = buffer
		self.attribute_name = attribute_name
		self.operation = operation
		self.mod_value = mod_value


	def __str__(self):
		s = ""
		s += "state.name = " + str(self.name) + "\n"
		s += "state.buffer = " + str(self.buffer) + "\n"
		s += "state.attribute_name = " + str(self.attribute_name) + "\n"
		s += "state.operation = " + str(self.operation) + "\n"
		s += "state.mod_value = " + str(self.mod_value) + "\n"
		return s

class Change_Attribute(AtomicDEVS):
	def __init__(self, name = "Change_Attribute", buffer=None, attribute_name=None, operation="+", mod_value=1):
		AtomicDEVS.__init__(self, name)

		self.my_ports = {}

		self.state = Change_AttributeState(name="incoming", buffer=buffer, attribute_name=attribute_name, operation=operation, mod_value=mod_value)

		self.my_ports = {"incoming": self.addInPort("incoming"), "outgoing": self.addOutPort("outgoing"), "value": self.addInPort("value")}

	def timeAdvance(self):
		if self.state.name == "incoming":
			return INFINITY
			
		if self.state.name == "outgoing":
			return 0
			
	def outputFnc(self):
		def subfunc(self):
			if self.state.name == "incoming":
				return {}
				
			if self.state.name == "outgoing":
				return {"outgoing": self.state.buffer}
				
		return {self.my_ports[k]: v for k, v in subfunc(self).iteritems()}
	def intTransition(self):
		def cond_int_outgoing_to_incoming():
			return True
			
		def action_int_outgoing_to_incoming():
			return {"buffer" : self.state.buffer, "operation" : self.state.operation, "attribute_name" : self.state.attribute_name, "mod_value" : self.state.mod_value}
			
		if self.state.name == "outgoing" and cond_int_outgoing_to_incoming():
			return Change_AttributeState(name="incoming", **action_int_outgoing_to_incoming())

		else:
			return AtomicDEVS.intTransition(self)
	def extTransition(self, my_inputs):
		inputs = {k.getPortName(): v for k, v in my_inputs.iteritems()}
		def cond_ext_incoming_to_incoming():
			if 'value' in inputs.keys():
				return True
			return False
			
		def action_ext_incoming_to_incoming():
			return {"buffer" : self.state.buffer, "operation" : self.state.operation, "attribute_name" : self.state.attribute_name, "mod_value" : inputs[value]}
			
		def cond_ext_incoming_to_outgoing():
			if 'incoming' in inputs.keys():
				return True
			return False
			
		def action_ext_incoming_to_outgoing():
			input = inputs['incoming']
			import operator
			ops = {"+": operator.add, "-": operator.sub, "*": operator.mul, "/": operator.div}
			op_func = ops[self.state.operation]
			try:
				dele = getattr(input, self.state.attribute_name)
				if isinstance(dele, (int, float, long)):
					result = op_func(dele, self.state.mod_value)
					setattr(input, self.state.attribute_name, result)
				return {"buffer" : input, "operation" : self.state.operation, "attribute_name" : self.state.attribute_name, "mod_value" : self.state.mod_value}
			except Exception:
				dele = None
			if dele == None:
				try:
					dele = input.get(self.state.attribute_name, None)
					if isinstance(dele, (int, float, long)):
						result = op_func(dele, self.state.mod_value)
						input[self.state.attribute_name] = result
					return {"buffer" : input, "operation" : self.state.operation, "attribute_name" : self.state.attribute_name, "mod_value" : self.state.mod_value}
				except Exception:
					dele = None
			if dele == None:
				dele = input
			if isinstance(dele, (int, float, long)):
				result = op_func(dele, self.state.mod_value)
				return {"buffer" : result, "operation" : self.state.operation, "attribute_name" : self.state.attribute_name, "mod_value" : self.state.mod_value}
			return {"buffer" : input, "operation" : self.state.operation, "attribute_name" : self.state.attribute_name, "mod_value" : self.state.mod_value}
			
		if self.state.name == "incoming" and cond_ext_incoming_to_incoming():
			return Change_AttributeState(name="incoming", **action_ext_incoming_to_incoming())


		if self.state.name == "incoming" and cond_ext_incoming_to_outgoing():
			return Change_AttributeState(name="outgoing", **action_ext_incoming_to_outgoing())


		else:
			return AtomicDEVS.extTransition(self, my_inputs)


