from pypdevs.DEVS import *
from pypdevs.infinity import INFINITY

class Queue_LIFOState:
	def __init__(self, name="", max_size=None, buffer=None):
		self.name = name
		self.max_size = max_size
		self.buffer = buffer


	def __str__(self):
		s = ""
		s += "state.name = " + str(self.name) + "\n"
		s += "state.max_size = " + str(self.max_size) + "\n"
		s += "state.buffer = " + str(self.buffer) + "\n"
		return s

class Queue_LIFO(AtomicDEVS):
	def __init__(self, name = "Queue_LIFO", max_size=INFINITY, buffer=[]):
		AtomicDEVS.__init__(self, name)

		self.my_ports = {}

		self.state = Queue_LIFOState(name="receiving", max_size=max_size, buffer=buffer)

		self.my_ports = {"add": self.addInPort("add"), "get": self.addInPort("get"), "release": self.addOutPort("release"), "av_queue_length": self.addOutPort("av_queue_length"), "av_wait_time": self.addOutPort("av_wait_time"), "utilization": self.addOutPort("utilization"), "request_stat": self.addInPort("request_stat")}

	def timeAdvance(self):
		if self.state.name == "receiving":
			return INFINITY
			
		if self.state.name == "data":
			return 0
			
		if self.state.name == "sending":
			return 0
			
	def outputFnc(self):
		def subfunc(self):
			if self.state.name == "receiving":
				return {}
				
			if self.state.name == "data":
				return {}
				
			if self.state.name == "sending":
				if len(self.state.buffer) != 0:
					result = self.state.buffer.pop(0)
					return {'release' : result}
				return {}
				
		return {self.my_ports[k]: v for k, v in subfunc(self).iteritems()}
	def intTransition(self):
		def cond_int_sending_to_receiving():
			return True
			
		def action_int_sending_to_receiving():
			return {"buffer" : self.state.buffer, "max_size" : self.state.max_size}
			
		if self.state.name == "sending" and cond_int_sending_to_receiving():
			return Queue_LIFOState(name="receiving", **action_int_sending_to_receiving())

		else:
			return AtomicDEVS.intTransition(self)
	def extTransition(self, my_inputs):
		inputs = {k.getPortName(): v for k, v in my_inputs.iteritems()}
		def cond_ext_receiving_to_sending():
			if 'get' in inputs.keys():
				return True
			return False
			
		def action_ext_receiving_to_sending():
			return {"buffer" : self.state.buffer, "max_size" : self.state.max_size}
			
		def cond_ext_receiving_to_receiving():
			if 'add' in inputs.keys():
				return True
			return False
			
		def action_ext_receiving_to_receiving():
			if len(self.state.buffer) < self.state.max_size:
				self.state.buffer.insert(0, inputs['add'])
			return {"buffer" : self.state.buffer, "max_size" : self.state.max_size}
			
		if self.state.name == "receiving" and cond_ext_receiving_to_sending():
			return Queue_LIFOState(name="sending", **action_ext_receiving_to_sending())


		if self.state.name == "receiving" and cond_ext_receiving_to_receiving():
			return Queue_LIFOState(name="receiving", **action_ext_receiving_to_receiving())


		else:
			return AtomicDEVS.extTransition(self, my_inputs)


