from pypdevs.DEVS import *
from pypdevs.infinity import INFINITY

class UnbatchState:
	def __init__(self, name="", buffer=None):
		self.name = name
		self.buffer = buffer


	def __str__(self):
		s = ""
		s += "state.name = " + str(self.name) + "\n"
		s += "state.buffer = " + str(self.buffer) + "\n"
		return s

class Unbatch(AtomicDEVS):
	def __init__(self, name = "Unbatch", buffer=[]):
		AtomicDEVS.__init__(self, name)

		self.my_ports = {}

		self.state = UnbatchState(name="receiving", buffer=buffer)

		self.my_ports = {"incoming": self.addInPort("incoming"), "outgoing1": self.addOutPort("outgoing1"), "outgoing2": self.addOutPort("outgoing2"), "outgoing3": self.addOutPort("outgoing3"), "demand": self.addInPort("demand")}

	def timeAdvance(self):
		if self.state.name == "receiving":
			return INFINITY
			
		if self.state.name == "sending":
			return 0
			
	def outputFnc(self):
		def subfunc(self):
			if self.state.name == "receiving":
				return {}
				
			if self.state.name == "sending":
				if len(self.state.buffer) == 0:
					return {}
				buf = self.state.buffer[0]
				sen1 = None
				sen2 = None
				sen3 = None
				ret = {}
				if len(buf[0]) > 0:
					sen1 = buf[0].pop()
					ret['outgoing1'] = sen1
				if len(buf[1]) > 0:
					sen2 = buf[1].pop()
					ret['outgoing2'] = sen2
				if len(buf[2]) > 0:
					sen3 = buf[2].pop()
					ret['outgoing3'] = sen3
				if len(buf[0]) == 0 and len(buf[1]) == 0 and len(buf[2]) == 0:
					self.state.buffer.pop(0)
				return ret
				
		return {self.my_ports[k]: v for k, v in subfunc(self).iteritems()}
	def intTransition(self):
		def cond_int_sending_to_receiving():
			return True
			
		def action_int_sending_to_receiving():
			return {'buffer' : self.state.buffer}
			
		if self.state.name == "sending" and cond_int_sending_to_receiving():
			return UnbatchState(name="receiving", **action_int_sending_to_receiving())

		else:
			return AtomicDEVS.intTransition(self)
	def extTransition(self, my_inputs):
		inputs = {k.getPortName(): v for k, v in my_inputs.iteritems()}
		def cond_ext_receiving_to_sending():
			if 'demand' in inputs.keys():
				return True
			return False
			
		def action_ext_receiving_to_sending():
			return {'buffer' : self.state.buffer}
			
		def cond_ext_receiving_to_receiving():
			if 'incoming' in inputs.keys():
				valu = inputs['incoming']
				try:
					if len(valu) != 3:
						return False
					if not isinstance(valu[0], list):
						return False
					if not isinstance(valu[1], list):
						return False
					if not isinstance(valu[2], list):
						return False
					return True
				except  Exception:
					return False
			return False
			
		def action_ext_receiving_to_receiving():
			self.state.buffer.append(inputs['incoming'])
			return {'buffer' : self.state.buffer}
			
		if self.state.name == "receiving" and cond_ext_receiving_to_sending():
			return UnbatchState(name="sending", **action_ext_receiving_to_sending())


		if self.state.name == "receiving" and cond_ext_receiving_to_receiving():
			return UnbatchState(name="receiving", **action_ext_receiving_to_receiving())


		else:
			return AtomicDEVS.extTransition(self, my_inputs)


