from pypdevs.DEVS import *
from pypdevs.infinity import INFINITY

class NOTState:
	def __init__(self, name="", buffer=None):
		self.name = name
		self.buffer = buffer


	def __str__(self):
		s = ""
		s += "state.name = " + str(self.name) + "\n"
		s += "state.buffer = " + str(self.buffer) + "\n"
		return s

class NOT(AtomicDEVS):
	def __init__(self, name = "NOT", buffer=0.0):
		AtomicDEVS.__init__(self, name)

		self.my_ports = {}

		self.state = NOTState(name="receiving", buffer=buffer)

		self.my_ports = {"value": self.addInPort("value"), "result": self.addOutPort("result")}

	def timeAdvance(self):
		if self.state.name == "receiving":
			return INFINITY
			
		if self.state.name == "received_inverse":
			return 0
			
	def outputFnc(self):
		def subfunc(self):
			if self.state.name == "receiving":
				return {}
				
			if self.state.name == "received_inverse":
				if self.state.buffer > 0:
					return {'result' : 0}
				return {'result' : 1}
				
		return {self.my_ports[k]: v for k, v in subfunc(self).iteritems()}
	def intTransition(self):
		def cond_int_received_inverse_to_receiving():
			return True
			
		def action_int_received_inverse_to_receiving():
			return {"buffer" : self.state.buffer}
			
		if self.state.name == "received_inverse" and cond_int_received_inverse_to_receiving():
			return NOTState(name="receiving", **action_int_received_inverse_to_receiving())

		else:
			return AtomicDEVS.intTransition(self)
	def extTransition(self, my_inputs):
		inputs = {k.getPortName(): v for k, v in my_inputs.iteritems()}
		def cond_ext_receiving_to_received_inverse():
			return isinstance(inputs['value'], (int, long, float))
			
		def action_ext_receiving_to_received_inverse():
			return {"buffer" :  inputs['value']}
			
		if self.state.name == "receiving" and cond_ext_receiving_to_received_inverse():
			return NOTState(name="received_inverse", **action_ext_receiving_to_received_inverse())


		else:
			return AtomicDEVS.extTransition(self, my_inputs)


