from pypdevs.DEVS import *
from pypdevs.infinity import INFINITY

class XORState:
	def __init__(self, name="", buf2=None, buf1=None):
		self.name = name
		self.buf2 = buf2
		self.buf1 = buf1


	def __str__(self):
		s = ""
		s += "state.name = " + str(self.name) + "\n"
		s += "state.buf2 = " + str(self.buf2) + "\n"
		s += "state.buf1 = " + str(self.buf1) + "\n"
		return s

class XOR(AtomicDEVS):
	def __init__(self, name = "XOR", buf2=None, buf1=None):
		AtomicDEVS.__init__(self, name)

		self.my_ports = {}

		self.state = XORState(name="zero", buf2=buf2, buf1=buf1)

		self.my_ports = {"incoming1": self.addInPort("incoming1"), "incoming2": self.addInPort("incoming2"), "outgoing": self.addOutPort("outgoing")}

	def timeAdvance(self):
		if self.state.name == "zero":
			return INFINITY
			
		if self.state.name == "one":
			return INFINITY
			
		if self.state.name == "two":
			return INFINITY
			
		if self.state.name == "send":
			return 0
			
	def outputFnc(self):
		def subfunc(self):
			if self.state.name == "zero":
				return {}
				
			if self.state.name == "one":
				return {}
				
			if self.state.name == "two":
				return {}
				
			if self.state.name == "send":
				if self.state.buf1 > 0 or self.state.buf2 > 0:
					if self.state.buf1 > 0 and self.state.buf2 > 0:
						return {'outgoing' : 0}
					return {'outgoing' : 1}
				return {'outgoing' : 0}
				
		return {self.my_ports[k]: v for k, v in subfunc(self).iteritems()}
	def intTransition(self):
		def cond_int_send_to_zero():
			return True
			
		def action_int_send_to_zero():
			return {'buf1' : self.state.buf1, 'buf2' : self.state.buf2}
			
		if self.state.name == "send" and cond_int_send_to_zero():
			return XORState(name="zero", **action_int_send_to_zero())

		else:
			return AtomicDEVS.intTransition(self)
	def extTransition(self, my_inputs):
		inputs = {k.getPortName(): v for k, v in my_inputs.iteritems()}
		def cond_ext_two_to_send():
			if 'incoming1' in inputs.keys():
				if isinstance(inputs['incoming1'], (int, long, float, complex)):
					return True
			return False
			
		def action_ext_two_to_send():
			return {'buf1' : inputs['incoming1'], 'buf2' : self.state.buf2}
			
		def cond_ext_zero_to_two():
			if 'incoming2' in inputs.keys():
				if isinstance(inputs['incoming2'], (int, long, float, complex)):
					return True
			return False
			
		def action_ext_zero_to_two():
			return {'buf2' : inputs['incoming2'], 'buf1' : self.state.buf1}
			
		def cond_ext_zero_to_one():
			if 'incoming1' in inputs.keys():
				if isinstance(inputs['incoming1'], (int, long, float, complex)):
					return True
			return False
			
		def action_ext_zero_to_one():
			return {'buf1' : inputs['incoming1'], 'buf2' : self.state.buf2}
			
		def cond_ext_one_to_send():
			if 'incoming2' in inputs.keys():
				if isinstance(inputs['incoming2'], (int, long, float, complex)):
					return True
			return False
			
		def action_ext_one_to_send():
			return {'buf2' : inputs['incoming2'], 'buf1' : self.state.buf1}
			
		if self.state.name == "two" and cond_ext_two_to_send():
			return XORState(name="send", **action_ext_two_to_send())


		if self.state.name == "zero" and cond_ext_zero_to_two():
			return XORState(name="two", **action_ext_zero_to_two())


		if self.state.name == "zero" and cond_ext_zero_to_one():
			return XORState(name="one", **action_ext_zero_to_one())


		if self.state.name == "one" and cond_ext_one_to_send():
			return XORState(name="send", **action_ext_one_to_send())


		else:
			return AtomicDEVS.extTransition(self, my_inputs)


