from pypdevs.DEVS import *
from pypdevs.infinity import INFINITY

class CircularQueueState:
	def __init__(self, name="", queue=None, front=None, rear=None, override=None):
		self.name = name
		self.queue = queue
		self.front = front
		self.rear = rear
		self.override = override


	def __str__(self):
		s = ""
		s += "state.name = " + str(self.name) + "\n"
		s += "state.queue = " + str(self.queue) + "\n"
		s += "state.front = " + str(self.front) + "\n"
		s += "state.rear = " + str(self.rear) + "\n"
		s += "state.override = " + str(self.override) + "\n"
		return s

class CircularQueue(AtomicDEVS):
	def __init__(self, name = "CircularQueue", queue=[None] * 6, front=-1, rear=-1, override=False):
		AtomicDEVS.__init__(self, name)

		self.my_ports = {}

		self.state = CircularQueueState(name="receiving", queue=queue, front=front, rear=rear, override=override)

		self.my_ports = {"incoming": self.addInPort("incoming"), "get": self.addInPort("get"), "outgoing": self.addOutPort("outgoing")}

	def timeAdvance(self):
		if self.state.name == "receiving":
			return INFINITY
			
		if self.state.name == "sending":
			return 0
			
	def outputFnc(self):
		def subfunc(self):
			if self.state.name == "receiving":
				return {}
				
			if self.state.name == "sending":
				size = len(self.state.queue)
				if self.state.front == -1 and self.state.rear == -1:
					return {}
				retval = self.state.queue[self.state.front]
				self.state.front = self.state.front + 1
				if self.state.front == size:
					self.state.front = 0
				if self.state.front - 1 == self.state.rear:
					self.state.front = -1
					self.state.rear = -1
				return {'outgoing' : retval}
				
		return {self.my_ports[k]: v for k, v in subfunc(self).iteritems()}
	def intTransition(self):
		def cond_int_sending_to_receiving():
			return True
			
		def action_int_sending_to_receiving():
			return {'override' : self.state.override, 'rear' : self.state.rear, 'front' : self.state.front, 'queue' : self.state.queue}
			
		if self.state.name == "sending" and cond_int_sending_to_receiving():
			return CircularQueueState(name="receiving", **action_int_sending_to_receiving())

		else:
			return AtomicDEVS.intTransition(self)
	def extTransition(self, my_inputs):
		inputs = {k.getPortName(): v for k, v in my_inputs.iteritems()}
		def cond_ext_receiving_to_sending():
			if 'get' in inputs.keys():
				return True
			return False
			
		def action_ext_receiving_to_sending():
			return {'override' : self.state.override, 'rear' : self.state.rear, 'front' : self.state.front, 'queue' : self.state.queue}
			
		def cond_ext_receiving_to_receiving():
			if 'incoming' in inputs.keys():
				return True
			return False
			
		def action_ext_receiving_to_receiving():
			size = len(self.state.queue)
			if self.state.override == False and ((self.state.rear == size-1 and self.state.front == 0) or (self.state.front == self.state.rear + 1)):
				print('queue is full')
				return {'override' : self.state.override, 'rear' : self.state.rear, 'front' : self.state.front, 'queue' : self.state.queue}
			else:
				if self.state.rear == size-1 and self.state.front != 0:
					self.state.rear = -1
			self.state.rear = self.state.rear + 1
			self.state.queue[self.state.rear] = inputs['incoming']
			if self.state.override == True and self.state.front == self.state.rear:
				self.state.front = self.state.front + 1
				if self.state.front == size:
					self.state.front = 0
			if self.state.front == -1:
				self.state.front = 0
			return {'override' : self.state.override, 'rear' : self.state.rear, 'front' : self.state.front, 'queue' : self.state.queue}
			
		if self.state.name == "receiving" and cond_ext_receiving_to_sending():
			return CircularQueueState(name="sending", **action_ext_receiving_to_sending())


		if self.state.name == "receiving" and cond_ext_receiving_to_receiving():
			return CircularQueueState(name="receiving", **action_ext_receiving_to_receiving())


		else:
			return AtomicDEVS.extTransition(self, my_inputs)


