from pypdevs.DEVS import *
from pypdevs.infinity import INFINITY

class ListSizeState:
	def __init__(self, name="", buffer=None):
		self.name = name
		self.buffer = buffer


	def __str__(self):
		s = ""
		s += "state.name = " + str(self.name) + "\n"
		s += "state.buffer = " + str(self.buffer) + "\n"
		return s

class ListSize(AtomicDEVS):
	def __init__(self, name = "ListSize", buffer=None):
		AtomicDEVS.__init__(self, name)

		self.my_ports = {}

		self.state = ListSizeState(name="receiving", buffer=buffer)

		self.my_ports = {"incoming": self.addInPort("incoming"), "passthrough": self.addOutPort("passthrough"), "size": self.addOutPort("size")}

	def timeAdvance(self):
		if self.state.name == "receiving":
			return INFINITY
			
		if self.state.name == "sending":
			return 0
			
	def outputFnc(self):
		def subfunc(self):
			if self.state.name == "receiving":
				return {}
				
			if self.state.name == "sending":
				try:
					return {'passthrough' : self.state.buffer, 'size' : len(self.state.buffer)}
				except Exception:
					return {'passthrough': self.state.buffer}
				
		return {self.my_ports[k]: v for k, v in subfunc(self).iteritems()}
	def intTransition(self):
		def cond_int_sending_to_receiving():
			return True
			
		def action_int_sending_to_receiving():
			return {'buffer' : self.state.buffer}
			
		if self.state.name == "sending" and cond_int_sending_to_receiving():
			return ListSizeState(name="receiving", **action_int_sending_to_receiving())


		else:
			return AtomicDEVS.intTransition(self, my_inputs)

	def extTransition(self, my_inputs):
		inputs = {k.getPortName(): v for k, v in my_inputs.iteritems()}
		def cond_ext_receiving_to_sending():
			return 'incoming' in inputs.keys()
			
		def action_ext_receiving_to_sending():
			return {'buffer' : inputs['incoming']}
			
		if self.state.name == "receiving" and cond_ext_receiving_to_sending():
			return ListSizeState(name="sending", **action_ext_receiving_to_sending())


		else:
			return AtomicDEVS.extTransition(self, my_inputs)


