from pypdevs.DEVS import *
from pypdevs.infinity import INFINITY

class AbsoluteState:
	def __init__(self, name="", buffer=None):
		self.name = name
		self.buffer = buffer


	def __str__(self):
		s = ""
		s += "state.name = " + str(self.name) + "\n"
		s += "state.buffer = " + str(self.buffer) + "\n"
		return s

class Absolute(AtomicDEVS):
	def __init__(self, parameters={"name" : "Absolute"}):
		AtomicDEVS.__init__(self, parameters["name"])

		self.my_ports = {}

		self.state = AbsoluteState(name="receiving", buffer=0.0)

		self.my_ports = {"value": self.addInPort("value"), "result": self.addOutPort("result")}

	def timeAdvance(self):
		if self.state.name == "receiving":
			return INFINITY
			
		if self.state.name == "received_absolute":
			return 0
			
	def outputFnc(self):
		def subfunc(self):
			if self.state.name == "receiving":
				return {}
				
			if self.state.name == "received_absolute":
				return {"result" : self.state.buffer}
				
		return {self.my_ports[k]: v for k, v in subfunc(self).iteritems()}
	def intTransition(self):
		def cond_int_received_absolute_to_receiving():
			return True
			
		def action_int_received_absolute_to_receiving():
			return {"buffer" : self.state.buffer}
			
		if self.state.name == "received_absolute" and cond_int_received_absolute_to_receiving():
			return AbsoluteState(name="receiving", **action_int_received_absolute_to_receiving())

		else:
			return AtomicDEVS.intTransition(self)
	def extTransition(self, my_inputs):
		inputs = {k.getPortName(): v for k, v in my_inputs.iteritems()}
		def cond_ext_receiving_to_received_absolute():
			return isinstance(inputs['value'], (int, long, float))
			
		def action_ext_receiving_to_received_absolute():
			if inputs['value'] < 0:
				return {"buffer" : inputs['value'] * -1}
			else:
				return {"buffer" : inputs['value']}
			
		if self.state.name == "receiving" and cond_ext_receiving_to_received_absolute():
			return AbsoluteState(name="received_absolute", **action_ext_receiving_to_received_absolute())


		else:
			return AtomicDEVS.extTransition(self, my_inputs)


