from pypdevs.DEVS import *
from pypdevs.infinity import INFINITY

class GainState:
	def __init__(self, name="", factor=None, buffer=None):
		self.name = name
		self.factor = factor
		self.buffer = buffer


	def __str__(self):
		s = ""
		s += "state.name = " + str(self.name) + "\n"
		s += "state.factor = " + str(self.factor) + "\n"
		s += "state.buffer = " + str(self.buffer) + "\n"
		return s

class Gain(AtomicDEVS):
	def __init__(self, parameters={"name" : "Gain"}):
		AtomicDEVS.__init__(self, parameters["name"])

		self.my_ports = {}

		self.state = GainState(name="receive", factor=parameters['gain_factor'], buffer=0.0)

		self.my_ports = {"input_factor": self.addInPort("input_factor"), "result": self.addOutPort("result")}

	def timeAdvance(self):
		if self.state.name == "receive":
			return INFINITY
			
		if self.state.name == "do_gain":
			return 0
			
	def outputFnc(self):
		def subfunc(self):
			if self.state.name == "receive":
				return {}
				
			if self.state.name == "do_gain":
				return {"result" : self.state.buffer * self.state.factor}
				
		return {self.my_ports[k]: v for k, v in subfunc(self).iteritems()}
	def intTransition(self):
		def cond_int_do_gain_to_receive():
			return True
			
		def action_int_do_gain_to_receive():
			return {"buffer" : 0.0, "factor" : self.state.factor}
			
		if self.state.name == "do_gain" and cond_int_do_gain_to_receive():
			return GainState(name="receive", **action_int_do_gain_to_receive())

		else:
			return AtomicDEVS.intTransition(self)
	def extTransition(self, my_inputs):
		inputs = {k.getPortName(): v for k, v in my_inputs.iteritems()}
		def cond_ext_receive_to_do_gain():
			return isinstance(inputs['input_factor'], (int, long, float))
			
		def action_ext_receive_to_do_gain():
			return {"buffer" : inputs['input_factor'], "factor" : self.state.factor}
			
		if self.state.name == "receive" and cond_ext_receive_to_do_gain():
			return GainState(name="do_gain", **action_ext_receive_to_do_gain())


		else:
			return AtomicDEVS.extTransition(self, my_inputs)


