from pypdevs.DEVS import *
from pypdevs.infinity import INFINITY

class Generator_single_instantState:
	def __init__(self, name="", hold=None, value=None):
		self.name = name
		self.hold = hold
		self.value = value


	def __str__(self):
		s = ""
		s += "state.name = " + str(self.name) + "\n"
		s += "state.hold = " + str(self.hold) + "\n"
		s += "state.value = " + str(self.value) + "\n"
		return s

class Generator_single_instant(AtomicDEVS):
	def __init__(self, parameters={"name" : "Generator_single_instant"}):
		AtomicDEVS.__init__(self, parameters["name"])

		self.my_ports = {}

		self.state = Generator_single_instantState(name="generating", hold=0, value=parameters["value"])

		self.my_ports = {"generated": self.addOutPort("generated")}

	def timeAdvance(self):
		if self.state.name == "generating":
			return self.state.hold
			
	def outputFnc(self):
		def subfunc(self):
			if self.state.name == "generating":
				return {'generated' : self.state.value}
				
		return {self.my_ports[k]: v for k, v in subfunc(self).iteritems()}
	def intTransition(self):
		def cond_int_generating_to_generating():
			return True
			
		def action_int_generating_to_generating():
			return {"value" : self.state.value, "hold" : INFINITY}
			
		if self.state.name == "generating" and cond_int_generating_to_generating():
			return Generator_single_instantState(name="generating", **action_int_generating_to_generating())

		else:
			return AtomicDEVS.intTransition(self)
	def extTransition(self, my_inputs):
		inputs = {k.getPortName(): v for k, v in my_inputs.iteritems()}
		return AtomicDEVS.extTransition(self, my_inputs)

