from pypdevs.DEVS import *
from pypdevs.infinity import INFINITY

class RoundState:
	def __init__(self, name="", decimals=None, buffer=None):
		self.name = name
		self.decimals = decimals
		self.buffer = buffer


	def __str__(self):
		s = ""
		s += "state.name = " + str(self.name) + "\n"
		s += "state.decimals = " + str(self.decimals) + "\n"
		s += "state.buffer = " + str(self.buffer) + "\n"
		return s

class Round(AtomicDEVS):
	def __init__(self, name = "Round", decimals=0, buffer=None):
		AtomicDEVS.__init__(self, name)

		self.my_ports = {}

		self.state = RoundState(name="receiving", decimals=decimals, buffer=buffer)

		self.my_ports = {"incoming": self.addInPort("incoming"), "outgoing": self.addOutPort("outgoing")}

	def timeAdvance(self):
		if self.state.name == "receiving":
			return INFINITY
			
		if self.state.name == "sending":
			return 0
			
	def outputFnc(self):
		def subfunc(self):
			if self.state.name == "receiving":
				return {}
				
			if self.state.name == "sending":
				return {'outgoing' : round(self.state.buffer, self.state.decimals)}
				
		return {self.my_ports[k]: v for k, v in subfunc(self).iteritems()}
	def intTransition(self):
		def cond_int_sending_to_receiving():
			return True
			
		def action_int_sending_to_receiving():
			return {'buffer' : self.state.buffer, 'decimals' : self.state.decimals}
			
		if self.state.name == "sending" and cond_int_sending_to_receiving():
			return RoundState(name="receiving", **action_int_sending_to_receiving())

		else:
			return AtomicDEVS.intTransition(self)
	def extTransition(self, my_inputs):
		inputs = {k.getPortName(): v for k, v in my_inputs.iteritems()}
		def cond_ext_receiving_to_sending():
			if 'incoming' in inputs.keys() and isinstance(inputs['incoming'], (int, float, long)):
				return True
			return False
			
		def action_ext_receiving_to_sending():
			return {'buffer' : inputs['incoming'], 'decimals' : self.state.decimals}
			
		if self.state.name == "receiving" and cond_ext_receiving_to_sending():
			return RoundState(name="sending", **action_ext_receiving_to_sending())


		else:
			return AtomicDEVS.extTransition(self, my_inputs)


