from pypdevs.DEVS import *
from pypdevs.infinity import INFINITY

class SQRTState:
	def __init__(self, name="", buffer=None):
		self.name = name
		self.buffer = buffer


	def __str__(self):
		s = ""
		s += "state.name = " + str(self.name) + "\n"
		s += "state.buffer = " + str(self.buffer) + "\n"
		return s

class SQRT(AtomicDEVS):
	def __init__(self, parameters={"name" : "SQRT"}):
		AtomicDEVS.__init__(self, parameters["name"])

		self.my_ports = {}

		self.state = SQRTState(name="receiving", buffer=1)

		self.my_ports = {"input_value": self.addInPort("input_value"), "result": self.addOutPort("result")}

	def timeAdvance(self):
		if self.state.name == "receiving":
			return INFINITY
			
		if self.state.name == "calculating_sqrt":
			return 0
			
	def outputFnc(self):
		def subfunc(self):
			if self.state.name == "receiving":
				return {}
				
			if self.state.name == "calculating_sqrt":
				return {"result", self.state.buffer}
				
		return {self.my_ports[k]: v for k, v in subfunc(self).iteritems()}
	def intTransition(self):
		def cond_int_calculating_sqrt_to_receiving():
			return True
			
		def action_int_calculating_sqrt_to_receiving():
			return {"buffer" : 1}
			
		if self.state.name == "calculating_sqrt" and cond_int_calculating_sqrt_to_receiving():
			return SQRTState(name="receiving", **action_int_calculating_sqrt_to_receiving())

		else:
			return AtomicDEVS.intTransition(self)
	def extTransition(self, my_inputs):
		inputs = {k.getPortName(): v for k, v in my_inputs.iteritems()}
		def cond_ext_receiving_to_calculating_sqrt():
			return isinstance(inputs['input_value'], (int, long, float))
			
		def action_ext_receiving_to_calculating_sqrt():
			if inputs['input_value'] < 0:
				print("SQRT cannot take the square root of a negative number, return value = 0")
				return {"buffer" : 0}
			else:
				from math import sqrt
				return {"buffer" : sqrt(inputs['input_value'])}
			
		if self.state.name == "receiving" and cond_ext_receiving_to_calculating_sqrt():
			return SQRTState(name="calculating_sqrt", **action_ext_receiving_to_calculating_sqrt())


		else:
			return AtomicDEVS.extTransition(self, my_inputs)


