from pypdevs.DEVS import *
from pypdevs.infinity import INFINITY

class SquareState:
	def __init__(self, name="", buffer=None):
		self.name = name
		self.buffer = buffer


	def __str__(self):
		s = ""
		s += "state.name = " + str(self.name) + "\n"
		s += "state.buffer = " + str(self.buffer) + "\n"
		return s

class Square(AtomicDEVS):
	def __init__(self, parameters={"name" : "Square"}):
		AtomicDEVS.__init__(self, parameters["name"])

		self.my_ports = {}

		self.state = SquareState(name="receiving", buffer=1)

		self.my_ports = {"input_value": self.addInPort("input_value"), "result": self.addOutPort("result")}

	def timeAdvance(self):
		if self.state.name == "receiving":
			return INFINITY
			
		if self.state.name == "calculating_square":
			return 0
			
	def outputFnc(self):
		def subfunc(self):
			if self.state.name == "receiving":
				return {}
				
			if self.state.name == "calculating_square":
				return {"result" : self.state.buffer ** 2}
				
		return {self.my_ports[k]: v for k, v in subfunc(self).iteritems()}
	def intTransition(self):
		def cond_int_calculating_square_to_receiving():
			return True
			
		def action_int_calculating_square_to_receiving():
			return {"buffer" : 1}
			
		if self.state.name == "calculating_square" and cond_int_calculating_square_to_receiving():
			return SquareState(name="receiving", **action_int_calculating_square_to_receiving())

		else:
			return AtomicDEVS.intTransition(self)
	def extTransition(self, my_inputs):
		inputs = {k.getPortName(): v for k, v in my_inputs.iteritems()}
		def cond_ext_receiving_to_calculating_square():
			return isinstance(inputs['input_value'], (int, long, float))
			
		def action_ext_receiving_to_calculating_square():
			return {"buffer" : inputs['input_value']}
			
		if self.state.name == "receiving" and cond_ext_receiving_to_calculating_square():
			return SquareState(name="calculating_square", **action_ext_receiving_to_calculating_square())


		else:
			return AtomicDEVS.extTransition(self, my_inputs)


