/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package mdeckers.thesis.uantwerp.compiler;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.Scanner;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author Michael
 */
public class ADEVStoPyPDEVSClasses {
    
    public static String inputType = "IN";
    public static String outputType = "OUT";
    
    private final ArrayList<String> newLines;
    private final ArrayList<String> ports;
    private final ArrayList<String> parametersLines;
    private final ArrayList<String> parametersNames;
    private final ArrayList<String> states;
    private String DEVSname;
    /**
     * type:
     * 1 = state parameters
     * 2 = ports
     * 3 = states
     * 4 = time advance
     * 5 = output function
     * 6 = internal transition
     * 7 = external transition
     */
    private int type;
    
    private int of_number;
    private boolean addedET;
    private boolean addedIT;
    
    public ADEVStoPyPDEVSClasses(){
        newLines = new ArrayList();
        ports = new ArrayList();
        parametersLines = new ArrayList();
        parametersNames = new ArrayList();
        states = new ArrayList();
        afterAdder = new ArrayList();
    }
    
    public String treat(File file) {
        newLines.clear();
        ports.clear();
        parametersLines.clear();
        parametersNames.clear();
        states.clear();
        afterAdder.clear();
        type = 0;
        of_number = 0;
        String result = "";
        activateBufferIT = false;
        activateBufferET = false;
        addedET = false;
        addedIT = false;
        set = 0;
        buffersize = 0;
        
        ArrayList<String> lines = readFromFile(file);
        if (lines == null)
            return null;
        
        for (int i = 0; i < lines.size(); i++){
            treatLine(lines.get(i));
        }
        
        //newLines.add(1, "\tdef __init__(self, parameters={\"name\" : \"" + DEVSname + "\"" + setupParam() + "}):");
        newLines.add(1, "\tdef __init__(self, name = \"" + DEVSname + "\"" + setupParam() + "):");
        newLines.add(4, stateParameterLine() + "\n");
        newLines.add(5, portLine() + "\n");
        
        createState();
        
        for (int i = 0; i < newLines.size(); i++){
            result = result.concat(newLines.get(i));
            result = result.concat("\n");
        }
        result = result.concat("\n");
        
        return result;
    }
    
    private ArrayList<String> readFromFile(File file){
        try {
            Scanner scanner = new Scanner(file);
            ArrayList<String> list = new ArrayList<>();
            while (scanner.hasNextLine()){
                list.add(scanner.nextLine());
            }
            scanner.close();
            return list;
        } catch (FileNotFoundException ex) {
            Logger.getLogger(ADEVStoPyPDEVSClasses.class.getName()).log(Level.SEVERE, null, ex);
        }
        return null;
    }
    
    private void treatLine(String line){
        if (line.contains("[name")){
            DEVSname = line.substring(line.indexOf("=")+1, line.lastIndexOf("]")).trim();
            newLines.add("class " + DEVSname + "(AtomicDEVS):");
            //newLines.add("\tdef __init__(self, parameters={\"name\" : \"" + DEVSname + "\"}):");
            //newLines.add("\t\tAtomicDEVS.__init__(self, parameters[\"name\"])\n");
            newLines.add("\t\tAtomicDEVS.__init__(self, name)\n");
            newLines.add("\t\tself.my_ports = {}\n");
        } else if (line.contains("[state parameters]")){
            type = 1;
        } else if (line.contains("[ports]")){
            type = 2;
        } else if (line.contains("[states]")){
            type = 3;
        } else if (line.contains("[time advance]")){
            newLines.add("\tdef timeAdvance(self):");
            type = 4;
        } else if (line.contains("[output function]")){
            newLines.add("\tdef outputFnc(self):\n\t\tdef subfunc(self):");
            newLines.add("\t\treturn {self.my_ports[k]: v for k, v in subfunc(self).iteritems()}");
            type = 5;
        } else if (line.contains("[internal transition]")){
            afterAdder.clear();
            readingCondition = false;
            readingAction = false;
            buffersize = 0;
            fromIT = null;
            toIT = null;
            newLines.add("\tdef intTransition(self):");
            
            newLines.add("\t\treturn AtomicDEVS.intTransition(self)");
            addedIT = true;
            type = 6;
        } else if (line.contains("[external transition")){
            afterAdder.clear();
            readingCondition = false;
            readingAction = false;
            buffersize = 0;
            fromET = null;
            toET = null;
            newLines.add("\tdef extTransition(self, my_inputs):");
            newLines.add("\t\tinputs = {k.getPortName(): v for k, v in my_inputs.iteritems()}");
            
            newLines.add("\t\treturn AtomicDEVS.extTransition(self, my_inputs)");
            addedET = true;
            type = 7;
        } else {
            switch (type) {
                case 1:
                    handleStateParameters(line);
                    break;
                case 2:
                    handlePort(line);
                    break;
                case 3:
                    handleStates(line);
                    break;
                case 4:
                    handleTA(line);
                    break;
                case 5:
                    handleOF(line);
                    break;
                case 6: 
                    handleIT(line);
                    break;
                case 7:
                    handleET(line);
                    break;
                default:
                    break;
            }
        }
        
    }

    private void handlePort(String line) {
        if (line.trim().length() == 0)
            return;
        String type, name;
        type = line.substring(0, line.indexOf(":")).trim();
        name = line.substring(line.indexOf(":")+1).trim();
        
        if (type.equals(inputType)){
            ports.add("\"" + name + "\": self.addInPort(\"" + name + "\")");
        } else if (type.equals(outputType)){
            ports.add("\"" + name + "\": self.addOutPort(\"" + name + "\")");
        }
    }

    private String portLine() {
        String line = "\t\tself.my_ports = {";
        
        for (int i = 0; i < ports.size(); i++){
            line = line.concat(ports.get(i));
            if (i != (ports.size() - 1))
                line = line.concat(", ");
        }
        
        line = line.concat("}");
        return line;        
    }

    private void handleStateParameters(String line) {
        if (line.trim().length() == 0)
            return;
        String name, value;
        name = line.substring(0, line.indexOf("=")).trim();
        value = line.substring(line.indexOf("=")+1).trim();
        
        parametersNames.add(0, name);
        parametersLines.add(0, name + "=" + value);
    }
    
    private String setupParam(){
        String res = "";
        
        for (String p : parametersLines){
            if (p.length() <= 3 || (p.length() > 3 && !p.substring(0, 4).contains("name"))){
                res = res.concat(", " + p);
            }
        }
        
        return res;
    }

    private String stateParameterLine() {
        String line = "\t\tself.state = " + DEVSname + "State(";
        
        for (String p : parametersLines){
            if (p.length() > 4 && p.substring(0, 5).contains("name=")){
                line = line.concat(p.replace("name:", "name=") + ", ");
                break;
            }
        }
        for (String p : parametersNames) {
            if (p.length() <= 3 || (p.length() > 3 && !p.substring(0, 4).contains("name"))){
                //line = line.concat(p + "=parameters[\"" + p + "\"], ");
                line = line.concat(p + "=" + p + ", ");
            }
        }
        
        line = line.substring(0, line.length()-2);
        line = line.concat(")");
        
        return line;
    }

    public static int TABCOUNTTA = 3;
    
    private void handleTA(String line) {
        /*if (line.trim().length() == 0)
            return;
        String name, value;
        name = line.substring(0, line.indexOf(":")).trim();
        value = line.substring(line.indexOf(":")+1).trim();
        
        if (parametersNames.contains(value))
            newLines.add("\t\tif self.state.name == \"" + name + "\":\n\t\t\treturn self.state." + value);
        else 
            newLines.add("\t\tif self.state.name == \"" + name + "\":\n\t\t\treturn " + value);
        */
        
        if (line.length() == 0)
            return;
        
        if (of_number == 0) {
            String state = line.substring(0, line.indexOf(":")).trim();
            if (state != null && states.contains(state)){
                lowestnumbertabs = Integer.MAX_VALUE;
                of_number = 1;
                newLines.add("\t\tif self.state.name == \"" + state + "\":");
                numberaccolades = count(line, "{");
                numberaccolades -= count(line, "}");
                if (line.trim().indexOf("{") == line.trim().length()-1){
                    return;
                }
                if (line.substring(line.indexOf("{")+1).contains("\t"))
                    lowestnumbertabs = count(line, "\t");
                else
                    lowestnumbertabs = 0;
                String adder = "";
                for (int i = 0; i < lowestnumbertabs + TABCOUNTTA; i++)
                    adder += "\t";
                adder += line.substring(line.indexOf("{")+1).trim();
                adder = replaceStateParameters(adder);
                
                if (numberaccolades == 0){
                    String adderRE = new StringBuilder(adder).reverse().toString();
                    adderRE = adderRE.replaceFirst("}", "");
                    adder = new StringBuilder(adderRE).reverse().toString();
                }
                newLines.add(adder);
                
                if (numberaccolades == 0)
                    of_number = 0;
            }
        } else {
            numberaccolades += count(line, "{");
            numberaccolades -= count(line, "}");
            if (lowestnumbertabs == Integer.MAX_VALUE){
                lowestnumbertabs = count(line, "\t");
            }

            if (line.trim().length() != 0){
                if (numberaccolades != 0){
                    int tabcount = count(line, "\t") - lowestnumbertabs;
                    String adder = "";
                    for (int i = 0; i < tabcount + TABCOUNTTA; i++)
                        adder += "\t";
                    adder += line.trim();
                    adder = replaceStateParameters(adder);
                    newLines.add(adder);
                } else {
                    of_number = 0;
                    int tabcount = count(line, "\t") - lowestnumbertabs;
                    String adder = "";
                    for (int i = 0; i < tabcount + TABCOUNTTA; i++)
                        adder += "\t";
                    adder += line.substring(0, line.lastIndexOf("}")).trim();
                    adder = replaceStateParameters(adder);
                    newLines.add(adder);
                }
            }
        }
        

    }

    private void handleStates(String line) {
        if (line.length() != 0){
            if (line.contains(": starting state")){
                states.add(line.substring(0, line.indexOf(":")).trim());
                parametersLines.add(0, "name=\"" + line.substring(0, line.indexOf(":")).trim() + "\"");
                parametersNames.add(0, "name");
            } else
                states.add(line.trim());
        }
        
    }
    
    private int numberaccolades;
    private int lowestnumbertabs;
    public static final int TABCOUNT = 4;
    

    private void handleOF(String line) {
        if (line.trim().length() == 0)
            return;
        
        String buffer = newLines.remove(newLines.size()-1);
        
        if (of_number == 0) {
            String state = line.substring(0, line.indexOf(":")).trim();
            if (state != null && states.contains(state)){
                lowestnumbertabs = Integer.MAX_VALUE;
                of_number = 1;
                newLines.add("\t\t\tif self.state.name == \"" + state + "\":");
                numberaccolades = count(line, "{");
                numberaccolades -= count(line, "}");
                if (line.trim().indexOf("{") == line.trim().length()-1){
                    newLines.add(buffer);
                    return;
                }
                if (line.substring(line.indexOf("{")+1).contains("\t"))
                    lowestnumbertabs = count(line, "\t");
                else
                    lowestnumbertabs = 0;
                String adder = "";
                for (int i = 0; i < lowestnumbertabs + TABCOUNT; i++)
                    adder += "\t";
                adder += line.substring(line.indexOf("{")+1).trim();
                adder = replaceStateParameters(adder);
                
                if (numberaccolades == 0){
                    String adderRE = new StringBuilder(adder).reverse().toString();
                    adderRE = adderRE.replaceFirst("}", "");
                    adder = new StringBuilder(adderRE).reverse().toString();
                }
                
                newLines.add(adder);
                
                if (numberaccolades == 0)
                    of_number = 0;
            }
        } else {
            numberaccolades += count(line, "{");
            numberaccolades -= count(line, "}");
            if (lowestnumbertabs == Integer.MAX_VALUE){
                lowestnumbertabs = count(line, "\t");
            }
            if (line.trim().length() != 0){
                if (numberaccolades != 0){
                    int tabcount = count(line, "\t") - lowestnumbertabs;
                    String adder = "";
                    for (int i = 0; i < tabcount + TABCOUNT; i++)
                        adder += "\t";
                    adder += line.trim();
                    adder = replaceStateParameters(adder);
                    newLines.add(adder);
                } else {
                    of_number = 0;
                    int tabcount = count(line, "\t") - lowestnumbertabs;
                    String adder = "";
                    for (int i = 0; i < tabcount + TABCOUNT; i++)
                        adder += "\t";
                    adder += line.substring(0, line.lastIndexOf("}")).trim();
                    adder = replaceStateParameters(adder);
                    newLines.add(adder);
                }
            }
        }
        
        newLines.add(buffer);
    }
    
    private int count(String line, String needle){
        return line.length() - line.replace(needle, "").length();
    }
        
    private String replaceStateParameters(String line){
        for (String s : parametersNames){
            int start = 0;
            while (line.substring(start).contains(s)){  
                int newstart = line.substring(start).indexOf(s)+s.length();
                if (((count(line.substring(0, start + line.substring(start).indexOf(s)), "\"") + 
                        count(line.substring(0, start + line.substring(start).indexOf(s)), "\'") - 
                        count(line.substring(0, start + line.substring(start).indexOf(s)), "\\\'") - 
                        count(line.substring(0, start + line.substring(start).indexOf(s)), "\\\"")) % 2) == 0){
                    
                    
                    if (isCompleteWord(line.substring(start), s) && 
                            line.substring(start).charAt(line.substring(start).indexOf(s)-1) != '.'){
                        line = line.substring(0, start) + line.substring(start).replaceFirst(s, "self.state." + s);
                        newstart += "self.state.".length();
                    }
                }
                start += newstart;
            }
        }
        return line;
    }
    
    private boolean isCompleteWord(String line, String needle){
        int characterBefore = line.indexOf(needle) - 1;
        int characterAfter = line.indexOf(needle) + needle.length();
        boolean beforeOK = false;
        boolean afterOK = false;
        
        if (characterBefore < 0)
            beforeOK = true;
        if (characterAfter >= line.length())
            afterOK = true;
        
        if (!beforeOK){
            char bef = line.charAt(characterBefore);
            if (!Character.isLetter(bef) && bef != '_')
                beforeOK = true;
        }
        if (!afterOK){
            char bef = line.charAt(characterAfter);
            if (!Character.isLetter(bef) && bef != '_' && !Character.isDigit(bef))
                afterOK = true;
        }
        
        return beforeOK && afterOK;
    }

    private boolean activateBufferIT = false;
    private boolean readingCondition = false;
    private boolean readingAction = false;
    public static final int TABCOUNTIT = 3;
    private String fromIT;
    private String toIT;
    
    private void handleIT(String line) {
        if (line.trim().length() == 0){
            return;
        }
        
        if (addedIT){
            newLines.remove(newLines.size()-1);
            addedIT = false;
        }
        
        int size = afterAdder.size();
        afterAdder = new ArrayList();
        if (activateBufferIT){
            for (int i = 0; i < size; i++){
                afterAdder.add(0, newLines.remove(newLines.size()-1));
            }
        }
        
        if (!readingCondition && !readingAction){
            if (line.contains("from_state") || line.contains("to_state")){
                if (line.contains("from_state")){
                    fromIT = line.substring(line.indexOf(":")+1).trim();
                    set++;
                } else {
                    toIT = line.substring(line.indexOf(":")+1).trim();
                    set++;
                }
                if (fromIT != null && toIT != null && set == 2){
                    String adder = "";
                    adder += ("\t\tif self.state.name == \"" + fromIT + "\" and cond_int_" + fromIT + "_to_" + toIT + "():\n");
                    adder += "\t\t\treturn " + DEVSname + "State(name=\"" + toIT + "\", **action_int_" + fromIT + "_to_" + toIT + "())\n\n";
                    afterAdder.add(adder);
                    
                    adder = "";
                    adder += "\t\telse:\n";
                    adder += "\t\t\treturn AtomicDEVS.intTransition(self, my_inputs)\n";
                    
                    if (afterAdder.contains(adder)){
                        afterAdder.remove(adder);
                        afterAdder.add(adder);
                    } else {
                        afterAdder.add(adder);
                    }
                    
                    activateBufferIT = true;
                    set = 0;
                    buffersize++;
                    newLines.addAll(afterAdder);
                    return;
                }
            } else if (line.contains("condition")) {
                readingCondition = true;
                
                lowestnumbertabs = Integer.MAX_VALUE;
                newLines.add("\t\tdef cond_int_" + fromIT + "_to_" + toIT + "():");
                numberaccolades = count(line, "{");
                numberaccolades -= count(line, "}");
                if (line.trim().indexOf("{") == line.trim().length()-1){
                    if (activateBufferIT){
                        newLines.addAll(afterAdder);
                    }
                    return;
                }
                if (line.substring(line.indexOf("{")+1).contains("\t"))
                    lowestnumbertabs = count(line, "\t");
                else
                    lowestnumbertabs = 0;
                String adder = "";
                for (int i = 0; i < lowestnumbertabs + TABCOUNTIT; i++)
                    adder += "\t";
                adder += line.substring(line.indexOf("{")+1).trim();
                adder = replaceStateParameters(adder);
                
                if (numberaccolades == 0){
                    String adderRE = new StringBuilder(adder).reverse().toString();
                    adderRE = adderRE.replaceFirst("}", "");
                    adder = new StringBuilder(adderRE).reverse().toString();
                }
                
                newLines.add(adder);

                if (numberaccolades == 0)
                    readingCondition = false;

            } else if (line.contains("action")) {
                readingAction = true;
                
                lowestnumbertabs = Integer.MAX_VALUE;
                newLines.add("\t\tdef action_int_" + fromIT + "_to_" + toIT + "():");
                numberaccolades = count(line, "{");
                numberaccolades -= count(line, "}");
                if (line.trim().indexOf("{") == line.trim().length()-1){
                    if (activateBufferIT){
                        newLines.addAll(afterAdder);
                    }
                    return;
                }
                if (line.substring(line.indexOf("{")+1).contains("\t"))
                    lowestnumbertabs = count(line, "\t");
                else
                    lowestnumbertabs = 0;
                String adder = "";
                for (int i = 0; i < lowestnumbertabs + TABCOUNTIT; i++)
                    adder += "\t";
                adder += line.substring(line.indexOf("{")+1).trim();
                adder = replaceStateParameters(adder);
                newLines.add(adder);

                if (numberaccolades == 0)
                    readingAction = false;
            } 
        } else if (readingCondition) {
            
            numberaccolades += count(line, "{");
            numberaccolades -= count(line, "}");
            if (numberaccolades == 0)
                readingCondition = false;
            if (lowestnumbertabs == Integer.MAX_VALUE){
                lowestnumbertabs = count(line, "\t");
            }
            if (line.trim().length() != 0){
                if (numberaccolades != 0){
                    int tabcount = count(line, "\t") - lowestnumbertabs;
                    String adder = "";
                    for (int i = 0; i < tabcount + TABCOUNTIT; i++)
                        adder += "\t";
                    adder += line.trim();
                    adder = replaceStateParameters(adder);
                    newLines.add(adder);
                } else {
                    readingCondition = false;
                    int tabcount = count(line, "\t") - lowestnumbertabs;
                    String adder = "";
                    for (int i = 0; i < tabcount + TABCOUNTIT; i++)
                        adder += "\t";
                    adder += line.substring(0, line.lastIndexOf("}")).trim();
                    adder = replaceStateParameters(adder);
                    newLines.add(adder);
                }
            }
            
        } else if (readingAction) {
            
            numberaccolades += count(line, "{");
            numberaccolades -= count(line, "}");
            
            if (numberaccolades == 0)
                readingAction = false;
            
            if (lowestnumbertabs == Integer.MAX_VALUE){
                lowestnumbertabs = count(line, "\t");
            }
            if (line.trim().length() != 0){
                if (numberaccolades != 0){
                    int tabcount = count(line, "\t") - lowestnumbertabs;
                    String adder = "";
                    for (int i = 0; i < tabcount + TABCOUNTIT; i++)
                        adder += "\t";
                    adder += line.trim();
                    adder = replaceStateParameters(adder);
                    newLines.add(adder);
                } else {
                    readingAction = false;
                    int tabcount = count(line, "\t") - lowestnumbertabs;
                    String adder = "";
                    for (int i = 0; i < tabcount + TABCOUNTIT; i++)
                        adder += "\t";
                    adder += line.substring(0, line.lastIndexOf("}")).trim();
                    adder = replaceStateParameters(adder);
                    newLines.add(adder);
                }
            }
            
        }
        if (activateBufferIT){
            newLines.addAll(afterAdder);
        }
    }
    
    private void handleIT2(String line) {
        if (line.trim().length() == 0){
            return;
        }
        
        if (addedIT){
            newLines.remove(newLines.size()-1);
            addedIT = false;
        }
        
        String buffer = null;
        if (activateBufferIT){
            buffer = newLines.remove(newLines.size()-1);
        }
        if (!readingCondition && !readingAction){
            if (line.contains("from_state") || line.contains("to_state")){
                if (line.contains("from_state")){
                    fromIT = line.substring(line.indexOf(":")+1).trim();
                } else {
                    toIT = line.substring(line.indexOf(":")+1).trim();
                }
                if (fromIT != null && toIT != null){
                    String adder = "";
                    adder += ("\t\tif self.state.name == \"" + fromIT + "\" and cond_int_" + fromIT + "_to_" + toIT + "():\n");
                    adder += "\t\t\treturn " + DEVSname + "State(name=\"" + toIT + "\", **action_int_" + fromIT + "_to_" + toIT + "())\n\n";
                    adder += "\t\telse:\n";
                    adder += "\t\t\treturn AtomicDEVS.intTransition(self)";
                    newLines.add(adder);
                    activateBufferIT = true;
                    return;
                }
            } else if (line.contains("condition")) {
                readingCondition = true;
                
                lowestnumbertabs = Integer.MAX_VALUE;
                newLines.add("\t\tdef cond_int_" + fromIT + "_to_" + toIT + "():");
                numberaccolades = count(line, "{");
                numberaccolades -= count(line, "}");
                if (line.trim().indexOf("{") == line.trim().length()-1){
                    if (activateBufferIT && buffer != null){
                        newLines.add(buffer);
                    }
                    return;
                }
                if (line.substring(line.indexOf("{")+1).contains("\t"))
                    lowestnumbertabs = count(line, "\t");
                else
                    lowestnumbertabs = 0;
                String adder = "";
                for (int i = 0; i < lowestnumbertabs + TABCOUNTIT; i++)
                    adder += "\t";
                adder += line.substring(line.indexOf("{")+1).trim();
                adder = replaceStateParameters(adder);
                
                if (numberaccolades == 0){
                    String adderRE = new StringBuilder(adder).reverse().toString();
                    adderRE = adderRE.replaceFirst("}", "");
                    adder = new StringBuilder(adderRE).reverse().toString();
                }
                
                newLines.add(adder);

                if (numberaccolades == 0)
                    readingCondition = false;

            } else if (line.contains("action")) {
                readingAction = true;
                
                lowestnumbertabs = Integer.MAX_VALUE;
                newLines.add("\t\tdef action_int_" + fromIT + "_to_" + toIT + "():");
                numberaccolades = count(line, "{");
                numberaccolades -= count(line, "}");
                if (line.trim().indexOf("{") == line.trim().length()-1){
                    if (activateBufferIT && buffer != null){
                        newLines.add(buffer);
                    }
                    return;
                }
                if (line.substring(line.indexOf("{")+1).contains("\t"))
                    lowestnumbertabs = count(line, "\t");
                else
                    lowestnumbertabs = 0;
                String adder = "";
                for (int i = 0; i < lowestnumbertabs + TABCOUNTIT; i++)
                    adder += "\t";
                adder += line.substring(line.indexOf("{")+1).trim();
                adder = replaceStateParameters(adder);
                newLines.add(adder);

                if (numberaccolades == 0)
                    readingAction = false;
            } else {
                if (activateBufferIT && buffer != null){
                    newLines.add(buffer);
                }
            }
        } else if (readingCondition) {
            
            numberaccolades += count(line, "{");
            numberaccolades -= count(line, "}");
            if (numberaccolades == 0)
                readingCondition = false;
            if (lowestnumbertabs == Integer.MAX_VALUE){
                lowestnumbertabs = count(line, "\t");
            }
            if (line.trim().length() != 0){
                if (numberaccolades != 0){
                    int tabcount = count(line, "\t") - lowestnumbertabs;
                    String adder = "";
                    for (int i = 0; i < tabcount + TABCOUNTIT; i++)
                        adder += "\t";
                    adder += line.trim();
                    adder = replaceStateParameters(adder);
                    newLines.add(adder);
                } else {
                    readingCondition = false;
                    int tabcount = count(line, "\t") - lowestnumbertabs;
                    String adder = "";
                    for (int i = 0; i < tabcount + TABCOUNTIT; i++)
                        adder += "\t";
                    adder += line.substring(0, line.lastIndexOf("}")).trim();
                    adder = replaceStateParameters(adder);
                    newLines.add(adder);
                }
            }
            
        } else if (readingAction) {
            
            numberaccolades += count(line, "{");
            numberaccolades -= count(line, "}");
            
            if (numberaccolades == 0)
                readingAction = false;
            
            if (lowestnumbertabs == Integer.MAX_VALUE){
                lowestnumbertabs = count(line, "\t");
            }
            if (line.trim().length() != 0){
                if (numberaccolades != 0){
                    int tabcount = count(line, "\t") - lowestnumbertabs;
                    String adder = "";
                    for (int i = 0; i < tabcount + TABCOUNTIT; i++)
                        adder += "\t";
                    adder += line.trim();
                    adder = replaceStateParameters(adder);
                    newLines.add(adder);
                } else {
                    readingAction = false;
                    int tabcount = count(line, "\t") - lowestnumbertabs;
                    String adder = "";
                    for (int i = 0; i < tabcount + TABCOUNTIT; i++)
                        adder += "\t";
                    adder += line.substring(0, line.lastIndexOf("}")).trim();
                    adder = replaceStateParameters(adder);
                    newLines.add(adder);
                }
            }
            
        }
        
        
        if (activateBufferIT && buffer != null){
            newLines.add(buffer);
        }
    }

    
    private boolean activateBufferET = false;

    public static final int TABCOUNTET = 3;
    private String fromET;
    private String toET;
    private int set;
    private int buffersize;
    private ArrayList<String> afterAdder;
    
    
    private void handleET(String line) {
        if (line.trim().length() == 0){
            return;
        }
        
        if (addedET){
            newLines.remove(newLines.size()-1);
            addedET = false;
        }
        
        int size = afterAdder.size();
        afterAdder = new ArrayList();
        if (activateBufferET){
            for (int i = 0; i < size; i++){
                afterAdder.add(0, newLines.remove(newLines.size()-1));
            }
        }
        
        if (!readingCondition && !readingAction){
            if (line.contains("from_state") || line.contains("to_state")){
                if (line.contains("from_state")){
                    fromET = line.substring(line.indexOf(":")+1).trim();
                    set++;
                } else {
                    toET = line.substring(line.indexOf(":")+1).trim();
                    set++;
                }
                if (fromET != null && toET != null && set == 2){
                    String adder = "";
                    adder += ("\t\tif self.state.name == \"" + fromET + "\" and cond_ext_" + fromET + "_to_" + toET + "():\n");
                    adder += "\t\t\treturn " + DEVSname + "State(name=\"" + toET + "\", **action_ext_" + fromET + "_to_" + toET + "())\n\n";
                    afterAdder.add(adder);
                    
                    adder = "";
                    adder += "\t\telse:\n";
                    adder += "\t\t\treturn AtomicDEVS.extTransition(self, my_inputs)\n";
                    
                    if (afterAdder.contains(adder)){
                        afterAdder.remove(adder);
                        afterAdder.add(adder);
                    } else {
                        afterAdder.add(adder);
                    }
                    
                    activateBufferET = true;
                    set = 0;
                    buffersize++;
                    newLines.addAll(afterAdder);
                    return;
                }
            } else if (line.contains("condition")) {
                readingCondition = true;
                
                lowestnumbertabs = Integer.MAX_VALUE;
                newLines.add("\t\tdef cond_ext_" + fromET + "_to_" + toET + "():");
                numberaccolades = count(line, "{");
                numberaccolades -= count(line, "}");
                if (line.trim().indexOf("{") == line.trim().length()-1){
                    if (activateBufferET){
                        newLines.addAll(afterAdder);
                    }
                    return;
                }
                if (line.substring(line.indexOf("{")+1).contains("\t"))
                    lowestnumbertabs = count(line, "\t");
                else
                    lowestnumbertabs = 0;
                String adder = "";
                for (int i = 0; i < lowestnumbertabs + TABCOUNTET; i++)
                    adder += "\t";
                adder += line.substring(line.indexOf("{")+1).trim();
                adder = replaceStateParameters(adder);
                
                if (numberaccolades == 0){
                    String adderRE = new StringBuilder(adder).reverse().toString();
                    adderRE = adderRE.replaceFirst("}", "");
                    adder = new StringBuilder(adderRE).reverse().toString();
                }
                
                newLines.add(adder);

                if (numberaccolades == 0)
                    readingCondition = false;

            } else if (line.contains("action")) {
                readingAction = true;
                
                lowestnumbertabs = Integer.MAX_VALUE;
                newLines.add("\t\tdef action_ext_" + fromET + "_to_" + toET + "():");
                numberaccolades = count(line, "{");
                numberaccolades -= count(line, "}");
                if (line.trim().indexOf("{") == line.trim().length()-1){
                    if (activateBufferET){
                        newLines.addAll(afterAdder);
                    }
                    return;
                }
                if (line.substring(line.indexOf("{")+1).contains("\t"))
                    lowestnumbertabs = count(line, "\t");
                else
                    lowestnumbertabs = 0;
                String adder = "";
                for (int i = 0; i < lowestnumbertabs + TABCOUNTET; i++)
                    adder += "\t";
                adder += line.substring(line.indexOf("{")+1).trim();
                adder = replaceStateParameters(adder);
                newLines.add(adder);

                if (numberaccolades == 0)
                    readingAction = false;
            } 
        } else if (readingCondition) {
            
            numberaccolades += count(line, "{");
            numberaccolades -= count(line, "}");
            if (numberaccolades == 0)
                readingCondition = false;
            if (lowestnumbertabs == Integer.MAX_VALUE){
                lowestnumbertabs = count(line, "\t");
            }
            if (line.trim().length() != 0){
                if (numberaccolades != 0){
                    int tabcount = count(line, "\t") - lowestnumbertabs;
                    String adder = "";
                    for (int i = 0; i < tabcount + TABCOUNTET; i++)
                        adder += "\t";
                    adder += line.trim();
                    adder = replaceStateParameters(adder);
                    newLines.add(adder);
                } else {
                    readingCondition = false;
                    int tabcount = count(line, "\t") - lowestnumbertabs;
                    String adder = "";
                    for (int i = 0; i < tabcount + TABCOUNTET; i++)
                        adder += "\t";
                    adder += line.substring(0, line.lastIndexOf("}")).trim();
                    adder = replaceStateParameters(adder);
                    newLines.add(adder);
                }
            }
            
        } else if (readingAction) {
            
            numberaccolades += count(line, "{");
            numberaccolades -= count(line, "}");
            
            if (numberaccolades == 0)
                readingAction = false;
            
            if (lowestnumbertabs == Integer.MAX_VALUE){
                lowestnumbertabs = count(line, "\t");
            }
            if (line.trim().length() != 0){
                if (numberaccolades != 0){
                    int tabcount = count(line, "\t") - lowestnumbertabs;
                    String adder = "";
                    for (int i = 0; i < tabcount + TABCOUNTET; i++)
                        adder += "\t";
                    adder += line.trim();
                    adder = replaceStateParameters(adder);
                    newLines.add(adder);
                } else {
                    readingAction = false;
                    int tabcount = count(line, "\t") - lowestnumbertabs;
                    String adder = "";
                    for (int i = 0; i < tabcount + TABCOUNTET; i++)
                        adder += "\t";
                    adder += line.substring(0, line.lastIndexOf("}")).trim();
                    adder = replaceStateParameters(adder);
                    newLines.add(adder);
                }
            }
            
        }
        if (activateBufferET){
            newLines.addAll(afterAdder);
        }
    }
    
    private void createState() {
        ArrayList<String> stateLines = new ArrayList();
        ArrayList<String> param = new ArrayList();
        
        stateLines.add("class ".concat(DEVSname).concat("State:"));
        
        for (int i = 0; i < parametersNames.size(); i++){
            //param.add(parametersLines.get(i).substring(0, parametersLines.get(i).indexOf("=")));
            param.add(parametersNames.get(i));
        }
        
        String init = "\tdef __init__(self";
        Iterator<String> it = param.iterator();
        while(it.hasNext()){
            String entry = it.next();
            init = init.concat(", ");
            init = init.concat(entry);
            if (entry.equals("name"))
                init = init.concat("=\"\"");
            else 
                init = init.concat("=None");
        }
        init = init.concat("):");
        
        stateLines.add(init);
        
        it = param.iterator();
        while(it.hasNext()){
            String setterLine = "\t\tself.";
            String entry = it.next();
            setterLine = setterLine.concat(entry + " = " + entry);
            stateLines.add(setterLine);
        }
        
        stateLines.add("\n");
        stateLines.add("\tdef __str__(self):");
        stateLines.add("\t\ts = \"\"");
        
        it = param.iterator();
        while(it.hasNext()){
            String strLine = "\t\ts += \"state.";
            String entry = it.next();
            strLine = strLine.concat(entry + " = \" + str(self." + entry + ") + \"\\n\"");
            stateLines.add(strLine);
        }
        stateLines.add("\t\treturn s\n");
        
        newLines.addAll(0, stateLines);
    }
}
