/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package mdeckers.thesis.uantwerp.compiler;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.ArrayList;
import java.util.Scanner;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author Michael
 */
public class CDEVStoPyPDEVSClasses {
    
    public static String inputType = "IN";
    public static String outputType = "OUT";
    
    private final ArrayList<String> newLines;
    private final ArrayList<String> ports;
    private String DEVSname;
    private String select;
    private ArrayList<String> priorities;
    /**
     * type:
     * 1 = components
     * 2 = ports
     * 3 = connections
     */
    private int type;
    
    public CDEVStoPyPDEVSClasses(){
        newLines = new ArrayList();
        ports = new ArrayList();
        priorities = new ArrayList();
    }
    
    public String treat(File file) {
        newLines.clear();
        ports.clear();
        params = new ArrayList();
        priorities = new ArrayList();
        type = 0;
        String result = "";
        
        ArrayList<String> lines = readFromFile(file);
        if (lines == null)
            return null;
        
        for (int i = 0; i < lines.size(); i++){
            treatLine(lines.get(i));
        }
        
        newLines.add(1, "\tdef __init__(self, name = \"" + DEVSname + "\"" + params() + "):");
        newLines.add(5, portLine() + "\n");
        
        for (int i = 0; i < newLines.size(); i++){
            result = result.concat(newLines.get(i));
            result = result.concat("\n");
        }
        result = result.concat("\n");
        
        result = result.concat("\tdef select(self, imm):\n");
        result = result.concat(select());
        //result = result.concat("\tdef select(self, imm):\n");
        //result = result.concat("\t\treturn imm[0]\n");
        
        return result;
    }
    
    private String params(){
        String line = "";
        
        for (String s : params){
            String type, value, target;
            target = s.substring(0, s.indexOf(":")).trim();
            type = s.substring(s.indexOf(":")+1, s.indexOf("=")).trim();
            value = s.substring(s.indexOf("=")+1).trim();
                //dict += ", \"" + type + "\" : parameters[\"" + target + "_" + type + "\"]";
            line += ", " + target + "_" + type + " = " + value;
        }
        
        return line;
    }
    
    private String select(){
        select = "";
        
        for (String s : priorities){
            select += "\t\tfor i, val in enumerate(imm):\n";
            select += "\t\t\tif isinstance(val, AtomicDEVS) or isinstance(val, CoupledDEVS):\n";
            select += "\t\t\t\tif val.getModelName() == \"" + s + "\":\n";
            select += "\t\t\t\t\treturn val\n";
        }
        select += "\t\treturn imm[0]\n\n";
        return select;
    }
    
    private ArrayList<String> readFromFile(File file){
        try {
            Scanner scanner = new Scanner(file);
            ArrayList<String> list = new ArrayList<>();
            while (scanner.hasNextLine()){
                list.add(scanner.nextLine());
            }
            scanner.close();
            return list;
        } catch (FileNotFoundException ex) {
            Logger.getLogger(CDEVStoPyPDEVSClasses.class.getName()).log(Level.SEVERE, null, ex);
        }
        return null;
    }
    
    private void treatLine(String line){
        if (line.contains("[name")){
            DEVSname = line.substring(line.indexOf("=")+1, line.lastIndexOf("]")).trim();
            newLines.add("class " + DEVSname + "(CoupledDEVS):");
            //newLines.add("\tdef __init__(self, name = \"" + DEVSname + "\"):");
            //newLines.add("\tdef __init__(self, parameters={\"name\" : \"" + DEVSname + "\"}):");
            //newLines.add("\t\tCoupledDEVS.__init__(self, parameters[\"name\"])\n");
            newLines.add("\t\tCoupledDEVS.__init__(self, name)\n");
            newLines.add("\t\tself.my_ports = {}");
            newLines.add("\t\tself.submodels = {}\n");
        } else if (line.contains("[components]")){
            type = 1;
        } else if (line.contains("[ports]")){
            type = 2;
        } else if (line.contains("[connections]")){
            type = 3;
        } else if (line.contains("[priorities]")){
            type = 4;
        } else if (line.contains("[parameters]")){
            type = 5;
        } else {
            switch (type) {
                case 1:
                    handleComponent(line);
                    break;
                case 2:
                    handlePort(line);
                    break;
                case 3:
                    handleConnection(line);
                    break;
                case 4: 
                    handleSelect(line);
                    break;
                case 5:
                    handleParams(line);
                    break;
                default:
                    break;
            }
        }
        
    }

    private void handleComponent(String line) {
        if (line.length() == 0)
            return;
        String type, name;
        type = line.substring(0, line.indexOf(":")).trim();
        name = line.substring(line.indexOf(":")+1).trim();
        
        String adder = "";
        //adder += "\t\t" + fillDict(name) + "\n";
        //adder += ("\t\tself.submodels[\"" + name + "\"] = self.addSubModel(" + type + "(parameters=" + fillDict2(name) + "))");
        adder += ("\t\tself.submodels[\"" + name + "\"] = self.addSubModel(" + type + "(" + fillDict2(name) + "))");
        newLines.add(adder);
        //newLines.add("\t\tself.submodels[\"" + name + "\"] = self.addSubModel(" + type + "(" + fillDict(name) + "))");
        //newLines.add("\t\tself.submodels[\"" + name + "\"] = self.addSubModel(" + type + "(name=\"" + name + "\"))");
        
    }
    
    private String fillDict(String name){
        String dict = "";
        dict += "parameters.update({\"name\" : \"" + name + "\"";
        /*for (String s : params){
            String type, value;
            type = s.substring(0, s.indexOf("=")).trim();
            value = s.substring(s.indexOf("=")+1).trim();
            dict += ", \"" + type + "\" : " + type + "";
        }*/
        dict += "})";
        return dict;
    }
    
    private String fillDict2(String name){
        String dict = "";
        //dict += "{\"name\" : \"" + name + "\"";
        dict += "name = \"" + name + "\"";
        for (String s : params){
            if (s.substring(0, s.indexOf(":")).contains(name)){
                String type, value, target;
                target = s.substring(0, s.indexOf(":")).trim();
                type = s.substring(s.indexOf(":")+1, s.indexOf("=")).trim();
                value = s.substring(s.indexOf("=")+1).trim();
                if (value.contains("parameters[")){
                    dict += ", \"" + type + "\" : " + value;
                } else {
                    //dict += ", \"" + type + "\" : parameters[\"" + target + "_" + type + "\"]";
                    dict += ", " + type + " = " + target + "_" + type;
                }
            }
        }
        //dict += "}";
        return dict;
    }

    private void handlePort(String line) {
        if (line.length() == 0)
            return;
        String type, name;
        type = line.substring(0, line.indexOf(":")).trim();
        name = line.substring(line.indexOf(":")+1).trim();
        
        if (type.equals(inputType)){
            ports.add("\"" + name + "\": self.addInPort(\"" + name + "\")");
        } else if (type.equals(outputType)){
            ports.add("\"" + name + "\": self.addOutPort(\"" + name + "\")");
        }
    }

    private String buffer1;
    private String buffer2;
    private String func;
    
    private void handleConnection(String line) {
        if (line.length() == 0)
            return;
        if (line.contains("->")){
            String from, to, fromName, fromPort, toName, toPort;
            from = line.substring(0, line.indexOf("->")).trim();
            to = line.substring(line.indexOf("->")+2).trim();

            buffer1 = from;
            buffer2 = to;
            
            if (!from.contains(".") && !to.contains(".")){
                newLines.add("\t\tself.connectPorts(self.my_ports[\"" + from + "\"], self.my_ports[\"" + to + "\"])");
                return;
            } else if (!from.contains(".")) {
                toName = to.substring(0, to.indexOf(".")).trim();
                toPort = to.substring(to.indexOf(".")+1).trim();
                newLines.add("\t\tself.connectPorts(self.my_ports[\"" + from + "\"], self.submodels[\"" + toName + "\"].my_ports[\"" + toPort + "\"])");
            } else if (!to.contains(".")){
                fromName = from.substring(0, from.indexOf(".")).trim();
                fromPort = from.substring(from.indexOf(".")+1).trim();
                newLines.add("\t\tself.connectPorts(self.submodels[\"" + fromName + "\"].my_ports[\"" + fromPort + "\"], self.my_ports[\"" + to + "\"])");
            } else {
                fromName = from.substring(0, from.indexOf(".")).trim();
                fromPort = from.substring(from.indexOf(".")+1).trim();

                toName = to.substring(0, to.indexOf(".")).trim();
                toPort = to.substring(to.indexOf(".")+1).trim();

                newLines.add("\t\tself.connectPorts(self.submodels[\"" + fromName + "\"].my_ports[\"" + fromPort + "\"], self.submodels[\"" + toName + "\"].my_ports[\"" + toPort + "\"])");
            }
        } else if (line.contains("transfer function {")){
            func = "\n";
            func += "\t\tdef transfer_" + buffer1 + "_to_" + buffer2 + "(event):\n";
            func = func.replace(".", "_");
        } else if (line.trim().equals("}")) { 
            String old = newLines.remove(newLines.size()-1);
            old = old.substring(0, old.lastIndexOf(")"));
            old += (", transfer_" + buffer1 + "_to_" + buffer2 + ")").replace(".", "_");
            newLines.add(old);
            newLines.add(newLines.size()-1, func);
        } else {
            func += "\t\t\t" + line + "\n";
        }
    }

    private String portLine() {
        String line = "\t\tself.my_ports = {";
        
        for (int i = 0; i < ports.size(); i++){
            line = line.concat(ports.get(i));
            if (i != (ports.size() - 1))
                line = line.concat(", ");
        }
        
        line = line.concat("}");
        return line;        
    }

    private void handleSelect(String line) {
        if (line.trim().length() == 0)
            return;
        priorities.add(line.trim());
    }

    private ArrayList<String> params;
    
    private void handleParams(String line) {
        if (line.trim().length() == 0)
            return;
        
        if (params == null){
            params = new ArrayList();
        }
        params.add(line);
        /*String old = newLines.remove(1);
        old = old.substring(0, old.lastIndexOf("):"));
        old += ", " + line + "):";
        newLines.add(1, old);*/
    }
        
        
}
