/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package mdeckers.thesis.uantwerp.compiler;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.ArrayList;
import java.util.Scanner;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author Michael
 */
public class MessageToPyPDEVSClasses {
    private String messageName;
    private ArrayList<String> newLines;
    private ArrayList<String> parameters;
    private int params;
    
    public MessageToPyPDEVSClasses() {
        newLines = new ArrayList();
        parameters = new ArrayList();
    }
    
    public String treat(File file){
        newLines.clear();
        parameters.clear();
        String result = "";
        params = 0;
        
        ArrayList<String> lines = readFromFile(file);
        if (lines == null)
            return null;
        
        for (int i = 0; i < lines.size(); i++){
            treatLine(lines.get(i));
        }
        
        treatParameters();
        
        for (int i = 0; i < newLines.size(); i++){
            result = result.concat(newLines.get(i));
            result = result.concat("\n");
        }
        
        result = result.concat("\n\n");
        
        return result;
    }

    private ArrayList<String> readFromFile(File file) {
        try {
            Scanner scanner = new Scanner(file);
            ArrayList<String> list = new ArrayList<>();
            while (scanner.hasNextLine()){
                list.add(scanner.nextLine());
            }
            scanner.close();
            return list;
        } catch (FileNotFoundException ex) {
            Logger.getLogger(MessageToPyPDEVSClasses.class.getName()).log(Level.SEVERE, null, ex);
        }
        return null;
    }

    private void treatLine(String line) {
        if (line.contains("[name")){
            messageName = line.substring(line.indexOf("=")+1, line.lastIndexOf("]")).trim();
            newLines.add("class " + messageName + ":");
        } else if (line.contains("[parameters]")){
            params = 1;
        } else if (params == 1) {
            parameters.add(line.trim());
        }
    }

    private void treatParameters() {
        if (parameters.size() <= 0)
            return;
        String line = "\tdef __init__(self";
        String str = "\tdef __str__(self):\n\t\ts = \"\"\n";
        ArrayList<String> lines = new ArrayList();
        for (int i = 0; i < parameters.size(); i++){
            String s = parameters.get(i);
            line = line.concat(", " + s + "=None");
            lines.add("\t\tself." + s + " = " + s);
            str = str.concat("\t\ts += \"state." + s + " = \" + str(self." + s + ") + \"\\n\"\n");
        }
        str = str.concat("\t\treturn s");
        line = line.concat("):");
        
        newLines.add(line);
        for (int i = 0; i < lines.size(); i++){
            newLines.add(lines.get(i));
        }
        newLines.add("\n\n" + str);
    }
    
}
