/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package mdeckers.thesis.uantwerp.compiler;

import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.util.ArrayList;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author Michael
 */
public class PyPDEVSCreator {
    
    private ByteArrayOutputStream outputModel;
    private String name;
    private ADEVStoPyPDEVSClasses adevs;
    private CDEVStoPyPDEVSClasses cdevs;
    private MessageToPyPDEVSClasses mdevs;
    
    public PyPDEVSCreator() {
        name = "./files/compiled/" + "output.py";
        
        init();
    }
    
    public PyPDEVSCreator(String name){
        this.name = name;
        
        init();
    }
    
    private void init(){
        outputModel = new ByteArrayOutputStream();
        adevs = new ADEVStoPyPDEVSClasses();
        cdevs = new CDEVStoPyPDEVSClasses();
        mdevs = new MessageToPyPDEVSClasses();
    }
    
    private void write(String content){
        try {
            outputModel.write(content.getBytes());
        } catch (IOException ex) {
            Logger.getLogger(PyPDEVSCreator.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    private void writeHeader() {
        String header = "from pypdevs.DEVS import *\nfrom pypdevs.infinity import INFINITY\n\n";
        write(header);
    }

    public void create(ArrayList<File> files) {
        writeHeader();
        for (int i = 0; i < files.size(); i++){
            if (FileGetter.getExtension(files.get(i).getName()).equals(FileGetter.messageExtension)){
                write(mdevs.treat(files.get(i)));
            }
        } 
        
        for (int i = 0; i < files.size(); i++){
            if (FileGetter.getExtension(files.get(i).getName()).equals(FileGetter.atomicExtension)){
                write(adevs.treat(files.get(i)));
            } else if (FileGetter.getExtension(files.get(i).getName()).equals(FileGetter.coupledExtension)){
                write(cdevs.treat(files.get(i)));
            }
        } 
        
        //System.out.println(outputModel.toString());
        createFile();
        
    }
    
    private void createFile(){
        OutputStream outputStream = null;
        try {
            File outputFile = new File(name);
            File parentDir = outputFile.getParentFile();
            if(! parentDir.exists()) 
                parentDir.mkdirs();
            outputStream = new FileOutputStream (outputFile);
            outputModel.writeTo(outputStream);
        } catch (FileNotFoundException ex) {
            Logger.getLogger(PyPDEVSCreator.class.getName()).log(Level.SEVERE, null, ex);
        } catch (IOException ex) {
            Logger.getLogger(PyPDEVSCreator.class.getName()).log(Level.SEVERE, null, ex);
        } finally {
            try {
                outputStream.close();
            } catch (IOException ex) {
                Logger.getLogger(PyPDEVSCreator.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
    }
    
}
