/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package mdeckers.thesis.uantwerp.gui.editor;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.util.ArrayList;
import javax.swing.DefaultListModel;
import javax.swing.JDialog;
import javax.swing.JOptionPane;
import javax.swing.ListSelectionModel;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import mdeckers.thesis.uantwerp.gui.graph.CoupledDEVSGraph;
import mdeckers.thesis.uantwerp.gui.main.Log;
import mdeckers.thesis.uantwerp.model.AtomicDEVS;
import mdeckers.thesis.uantwerp.model.CoupledDEVS;
import mdeckers.thesis.uantwerp.model.Settings;

/**
 *
 * @author Michael
 */
public class CoupledDEVSPanel extends javax.swing.JPanel implements AbstractComponentView {

    CoupledDEVS cdevs;
    Settings settings;
    ArrayList<ArrayList<String>> transferCopy;
    
    /**
     * Creates new form MessagePanel
     */
    public CoupledDEVSPanel(CoupledDEVS cdevs, Settings settings) {
        initComponents();
        this.cdevs = cdevs;
        this.settings = settings;
        reset();
        
        setupListeners();
        
        if (cdevs.isLibary() != 0){
            disableAll();
        }
        
    }
    
    private void disableAll(){
        this.modelList.setEnabled(false);
        this.newNameField.setEnabled(false);
        this.addDEVSButton.setEnabled(false);
        this.componentsField.setEnabled(false);
        this.outputRadioButton.setEnabled(false);
        this.inputRadioButton.setEnabled(false);
        this.newPortButton.setEnabled(false);
        this.newPortNameField.setEnabled(false);
        this.portsPane.setEnabled(false);
        this.connectionsPane.setEnabled(false);
        this.fromModelComboBox.setEnabled(false);
        this.fromPortList.setEnabled(false);
        this.toModelComboBox.setEnabled(false);
        this.toPortList.setEnabled(false);
        this.addConnectionButton.setEnabled(false);
        this.prioList.setEnabled(false);
        this.prioDownButton.setEnabled(false);
        this.prioUpButton.setEnabled(false);
        this.paramPane.setEnabled(false);
        this.newParamField.setEnabled(false);
        this.newParamValueField.setEnabled(false);
        this.newParamButton.setEnabled(false);
        this.transferFunctionPane.setEnabled(false);
        this.nameField.setEnabled(false);
        this.saveButton.setEnabled(false);
        this.discardChanges.setEnabled(false);
    }
    
    public void reset(){
        if (cdevs != null){
            componentsField.setText("");
            portsPane.setText("");
            connectionsPane.setText("");
            
            nameField.setText(cdevs.getName());
            componentsField.setText("");
            for (String s : cdevs.getComponents()){
                componentsField.setText(componentsField.getText() + s + "\n");
            }
            
            paramPane.setText("");
            for (String s : cdevs.getParameters()){
                paramPane.setText(paramPane.getText() + s + "\n");
            }
            
            DefaultListModel listModel = new DefaultListModel();
            for (CoupledDEVS c : settings.getCdevs()){
                if (c.isLibary() != 2){
                    if (!c.equals(cdevs)){
                        listModel.addElement(c.getName());
                    }
                }
            }
            for (AtomicDEVS c : settings.getAdevs()){
                if (c.isLibary() != 2){
                    listModel.addElement(c.getName());
                }
            }
            modelList.setModel(listModel);
            modelList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
            
            setupPrios();
            
            for (String s : cdevs.getPorts()){
                portsPane.setText(portsPane.getText() + s + "\n");
            }
            
            for (String s : cdevs.getConnections()){
                connectionsPane.setText(connectionsPane.getText() + s + "\n");
            }
            
            String[] list = new String[cdevs.getConnections().size()];
            list = cdevs.getConnections().toArray(list);
            transferFunctionCombo.setModel(new javax.swing.DefaultComboBoxModel<>(list));
            
            transferCopy = cdevs.getTransferFunctions();
            transferSelectionChanged(null);
            
            setupConnectionMaker();
            
            setupParamComboBox();
        }
    }
    
    private void setupParamComboBox(){
        ArrayList<String> outs = new ArrayList();
        
        String comps = componentsField.getText();
        String[] lines = comps.concat("\n").split("\\n");
        for (String line : lines){
            if (line.trim().length() > 0){
                outs.add(line.substring(line.indexOf(":")+1).trim());
            }
        }
        String[] list = new String[outs.size()];
        list = outs.toArray(list);
        paramComboBox.setModel(new javax.swing.DefaultComboBoxModel<>(list));
    }
    
    private void setupPrios(){
        DefaultListModel listModel = new DefaultListModel();
        for (String s : cdevs.getPriorities()){
            listModel.addElement(s);
        }
        /*for (CoupledDEVS c : settings.getCdevs()){
            if (componentsField.getText().contains(c.getName())){
                if (!listModel.contains(c.getName())){
                    listModel.addElement(c.getName());
                }
            }
        }
        for (AtomicDEVS c : settings.getAdevs()){
            if (componentsField.getText().contains(c.getName())){
                if (!listModel.contains(c.getName())){
                    listModel.addElement(c.getName());
                }
            }
        }*/
        String comps = componentsField.getText();
        String[] lines = comps.concat("\n").split("\\n");
        for (String line : lines){
            if (line.trim().length() > 0){
                if (!listModel.contains(line.substring(line.indexOf(":")+1).trim())){
                    listModel.addElement(line.substring(line.indexOf(":")+1).trim());
                }
            }
        }
        prioList.setModel(listModel);
        prioList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
    }
    
    private void transferSelectionChanged(String previous){
        String storeText = transferFunctionPane.getText();
        if (previous != null && !storeText.trim().isEmpty()){
            ArrayList<String> params = new ArrayList();
            String[] lines = storeText.concat("\n").split("\\n");
            for (String line : lines){
                params.add(line.trim());
            }
            boolean found = false;
            for (int i = 0; i < transferCopy.size(); i++){
                if (transferCopy.get(i).get(0).equals(previous)){
                    transferCopy.remove(i);
                    params.add(0, previous);
                    transferCopy.add(params);
                    found = true;
                    break;
                }
            }
            if (!found){
                params.add(0, previous);
                transferCopy.add(params);
            }
            
        }
        
        if (previous != null && storeText.trim().isEmpty()){
            for (int i = 0; i < transferCopy.size(); i++){
                if (transferCopy.get(i).get(0).equals(previous)){
                    transferCopy.remove(i);
                    break;
                }
            }
        }
        
        String selected = (String) transferFunctionCombo.getSelectedItem();
        transferFunctionPane.setText("");
        for (ArrayList<String> l : transferCopy){
            if (l.get(0).equals(selected)){
                for (int i = 1; i < l.size(); i++){
                    transferFunctionPane.setText(transferFunctionPane.getText() + l.get(i) + "\n");
                }
            }
        }
        
    }
    
    private void setupConnectionMaker(){
        ArrayList<String> params = new ArrayList();
        String[] lines = componentsField.getText().concat("\n").split("\\n");
        for (String line : lines){
            if (line.trim().length() > 0){
                params.add(line.trim());
            }
        }
        ArrayList<String> ins = new ArrayList();
        ArrayList<String> outs = new ArrayList();
        for (String s : params){
            String type = s.substring(0, s.indexOf(":"));
            for (Object c : settings.getComponentsObjects()){
                boolean _return = false;
                boolean __return = false;
                boolean ___return = false;
                boolean ____return = false;
                if (c instanceof AtomicDEVS){
                    AtomicDEVS a = (AtomicDEVS) c;
                    if (a.getName().equals(type.trim())){
                        for (String b : a.getPorts()){
                            if (!_return && b.contains("OUT")){
                                outs.add(s.substring(s.indexOf(":")+1).trim());
                                _return = true;
                            }
                            if (!__return && b.contains("IN")){
                                ins.add(s.substring(s.indexOf(":")+1).trim());
                                __return = true;
                            }
                        }
                    }
                } else if (c instanceof CoupledDEVS){
                    CoupledDEVS a = (CoupledDEVS) c;
                    if (a.getName().equals(type.trim())){
                        for (String b : a.getPorts()){
                            if (!___return && b.contains("OUT")){
                                outs.add(s.substring(s.indexOf(":")+1).trim());
                                ___return = true;
                            }
                            if (!____return && b.contains("IN")){
                                ins.add(s.substring(s.indexOf(":")+1).trim());
                                ____return = true;
                            }
                        }

                    }
                }
            }
        }
        
        ArrayList<String> params2 = new ArrayList();
        String[] lines2 = portsPane.getText().concat("\n").split("\\n");
        for (String line : lines2){
            if (line.trim().length() > 0){
                params2.add(line.trim());
            }
        }
        
        for (String s : params2){
            if (s.contains("IN")){
                outs.add("this");
                break;
            }
        }
        for (String s : params2){
            if (s.contains("OUT")){
                ins.add("this");
                break;
            }
        }
        String[] list = new String[outs.size()];
        list = outs.toArray(list);
        fromModelComboBox.setModel(new javax.swing.DefaultComboBoxModel<>(list));
        setPortList((String) fromModelComboBox.getSelectedItem(), "OUT");
        list = new String[ins.size()];
        list = ins.toArray(list);
        toModelComboBox.setModel(new javax.swing.DefaultComboBoxModel<>(list));
        setPortList((String) toModelComboBox.getSelectedItem(), "IN");
    }
    
    @Override
    public void save(){
        transferSelectionChanged((String) this.transferFunctionCombo.getSelectedItem());
        
        cdevs.setName(nameField.getText());
        ArrayList<String> params = new ArrayList();
        String[] lines = componentsField.getText().concat("\n").split("\\n");
        for (String line : lines){
            if (line.trim().length() > 0){
                params.add(line.trim());
            }
        }
        cdevs.setComponents(params);
        
        params = new ArrayList();
        lines = portsPane.getText().concat("\n").split("\\n");
        for (String line : lines){
            if (line.trim().length() > 0){
                params.add(line.trim());
            }
        }
        cdevs.setPorts(params);
        
        params = new ArrayList();
        lines = connectionsPane.getText().concat("\n").split("\\n");
        for (String line : lines){
            if (line.trim().length() > 0){
                params.add(line.trim());
            }
        }
        cdevs.setConnections(params);
        
        params = new ArrayList();
        lines = paramPane.getText().concat("\n").split("\\n");
        for (String line : lines){
            if (line.trim().length() > 0){
                params.add(line.trim());
            }
        }
        cdevs.setParameters(params);
        
        params = new ArrayList();
        for (int i = 0; i < prioList.getModel().getSize(); i++){
            params.add(prioList.getModel().getElementAt(i));
        }
        cdevs.setPriorities(params);
        
        cdevs.setTransferFunctions(transferCopy);
        
        cdevs.save();
        Log.message("Save complete.");
    }
    
    
    private void setupListeners(){
        newNameField.getDocument().addDocumentListener(new DocumentListener() {

            public void warn() {
               String text = newNameField.getText();
               if (text.trim().length() == 0 || modelList.getSelectedValue() == null){
                   addDEVSButton.setEnabled(false);
               } else {
                   addDEVSButton.setEnabled(true);
               }
            }

            @Override
            public void insertUpdate(DocumentEvent e) {
                warn();
            }

            @Override
            public void removeUpdate(DocumentEvent e) {
                warn();
            }

            @Override
            public void changedUpdate(DocumentEvent e) {
                warn();
            }
          });
        
        nameField.getDocument().addDocumentListener(new DocumentListener() {

            public void warn() {
               String text = nameField.getText();
               if (text.trim().length() == 0){
                   saveButton.setEnabled(false);
               } else {
                   saveButton.setEnabled(true);
               }
            }

            @Override
            public void insertUpdate(DocumentEvent e) {
                warn();
            }

            @Override
            public void removeUpdate(DocumentEvent e) {
                warn();
            }

            @Override
            public void changedUpdate(DocumentEvent e) {
                warn();
            }
          });
        
        discardChanges.addActionListener(new ActionListener() { 
            @Override
            public void actionPerformed(ActionEvent e) {
                JDialog.setDefaultLookAndFeelDecorated(true);
                int response = JOptionPane.showConfirmDialog(null, "Are you sure you want to discard all changes?", "Confirm",
                    JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE);
                if (response == JOptionPane.YES_OPTION) {
                  reset();
                } 
            }
          } );
        
        saveButton.addActionListener(new ActionListener() { 
            @Override
            public void actionPerformed(ActionEvent e) {
                save();
            }
          } );
        
        addDEVSButton.addActionListener(new ActionListener() { 
            @Override
            public void actionPerformed(ActionEvent e) {
                componentsField.setText(componentsField.getText() + modelList.getSelectedValue() + " : " + newNameField.getText() + "\n");
                newNameField.setText("");
                addDEVSButton.setEnabled(false);
                setupConnectionMaker();
                setupPrios();
                setupParamComboBox();
            }
          } );
        
        modelList.addListSelectionListener(new ListSelectionListener() {
            @Override
            public void valueChanged(ListSelectionEvent e) {
                if (newNameField.getText().trim().length() > 0){
                    addDEVSButton.setEnabled(true);
                } else {
                    addDEVSButton.setEnabled(false);
                }
            }
        });
        
        fromPortList.addListSelectionListener(new ListSelectionListener() {
            @Override
            public void valueChanged(ListSelectionEvent e) {
                if (fromPortList.getSelectedValue() != null && toPortList.getSelectedValue() != null){
                    addConnectionButton.setEnabled(true);
                } else {
                    addConnectionButton.setEnabled(false);
                }
            }
        });
        
        toPortList.addListSelectionListener(new ListSelectionListener() {
            @Override
            public void valueChanged(ListSelectionEvent e) {
                if (fromPortList.getSelectedValue() != null && toPortList.getSelectedValue() != null){
                    addConnectionButton.setEnabled(true);
                } else {
                    addConnectionButton.setEnabled(false);
                }
            }
        });
        
        addConnectionButton.addActionListener(new ActionListener() { 
            @Override
            public void actionPerformed(ActionEvent e) {
                if (fromModelComboBox.getSelectedItem().equals(toModelComboBox.getSelectedItem())){
                    JOptionPane.showMessageDialog(null,
                    "You cannot connect a DEVS block with itself",
                    "Connection Error",
                    JOptionPane.ERROR_MESSAGE);
                } else {
                    if (fromModelComboBox.getSelectedItem().equals("this") && toModelComboBox.getSelectedItem().equals("this")){
                        connectionsPane.setText(connectionsPane.getText() + 
                            fromPortList.getSelectedValue().trim() + 
                            " -> " + toPortList.getSelectedValue().trim()  + "\n");
                    } else if (fromModelComboBox.getSelectedItem().equals("this")) {
                        connectionsPane.setText(connectionsPane.getText() + 
                            fromPortList.getSelectedValue().trim() + 
                            " -> " + ((String) toModelComboBox.getSelectedItem()) + "." + toPortList.getSelectedValue()  + "\n");
                    } else if (toModelComboBox.getSelectedItem().equals("this")) {
                        connectionsPane.setText(connectionsPane.getText() + 
                            ((String) fromModelComboBox.getSelectedItem()) + "." + fromPortList.getSelectedValue() + 
                            " -> " + toPortList.getSelectedValue().trim()  + "\n");
                    } else {
                        connectionsPane.setText(connectionsPane.getText() + 
                            ((String) fromModelComboBox.getSelectedItem()) + "." + fromPortList.getSelectedValue() + 
                            " -> " + ((String) toModelComboBox.getSelectedItem()) + "." + toPortList.getSelectedValue()  + "\n");
                    }
                }
            }
          } );
        
        fromModelComboBox.addActionListener (new ActionListener () {
            @Override
            public void actionPerformed(ActionEvent e) {
                setPortList((String) fromModelComboBox.getSelectedItem(), "OUT");
            }
        });
        
        toModelComboBox.addActionListener (new ActionListener () {
            @Override
            public void actionPerformed(ActionEvent e) {
                setPortList((String) toModelComboBox.getSelectedItem(), "IN");
            }
        });
        
        newParamField.getDocument().addDocumentListener(new DocumentListener() {
            
            public void warn() {
               String text = newParamValueField.getText();
               if (text.trim().length() != 0 && newParamField.getText().trim().length() != 0){
                   newParamButton.setEnabled(true);
               } else {
                   newParamButton.setEnabled(false);
               }
            }
            
            @Override
            public void insertUpdate(DocumentEvent e) {
                warn();
            }

            @Override
            public void removeUpdate(DocumentEvent e) {
                warn();
            }

            @Override
            public void changedUpdate(DocumentEvent e) {
                warn();
            }
            
        });
        
        newParamValueField.getDocument().addDocumentListener(new DocumentListener() {
            
            public void warn() {
               String text = newParamValueField.getText();
               if (text.trim().length() != 0 && newParamField.getText().trim().length() != 0){
                   newParamButton.setEnabled(true);
               } else {
                   newParamButton.setEnabled(false);
               }
            }
            
            @Override
            public void insertUpdate(DocumentEvent e) {
                warn();
            }

            @Override
            public void removeUpdate(DocumentEvent e) {
                warn();
            }

            @Override
            public void changedUpdate(DocumentEvent e) {
                warn();
            }
            
        });
        
        newPortNameField.getDocument().addDocumentListener(new DocumentListener() {

            public void warn() {
               String text = newPortNameField.getText();
               if (text.trim().length() == 0){
                   newPortButton.setEnabled(false);
               } else {
                   newPortButton.setEnabled(true);
               }
            }

            @Override
            public void insertUpdate(DocumentEvent e) {
                warn();
            }

            @Override
            public void removeUpdate(DocumentEvent e) {
                warn();
            }

            @Override
            public void changedUpdate(DocumentEvent e) {
                warn();
            }
          });
        
        newPortButton.addActionListener(new ActionListener() { 
            @Override
            public void actionPerformed(ActionEvent e) {
                if (outputRadioButton.isSelected())
                    portsPane.setText(portsPane.getText() + "OUT : " + newPortNameField.getText() + "\n");
                else 
                    portsPane.setText(portsPane.getText() + "IN : " + newPortNameField.getText() + "\n");
                newPortNameField.setText("");
                newPortButton.setEnabled(false);
                setupConnectionMaker();
            }
          } );
        
        transferFunctionCombo.addItemListener(new ItemListener() {
            @Override
            public void itemStateChanged(ItemEvent e) {
                if (e.getStateChange() == ItemEvent.DESELECTED){
                    transferSelectionChanged((String) e.getItem());
                }
            }
            
        });
    }
    
    private void setPortList(String name, String par){
        DefaultListModel listModel = new DefaultListModel();
        
        if (name == null){
            return;
        }
        
        if (name.equals("this")){
            ArrayList<String> params2 = new ArrayList();
            String[] lines2 = portsPane.getText().concat("\n").split("\\n");
            for (String line : lines2){
                if (line.trim().length() > 0){
                    params2.add(line.trim());
                }
            }
            for (String p : params2){
                if (!p.contains(par)){
                    listModel.addElement(p.substring(p.indexOf(":")+1));
                }
            }
        } else {
            String type = null;
            String[] lines = componentsField.getText().concat("\n").split("\\n");
            for (String line : lines){
                if (line.trim().length() > 0){
                    if (line.contains(name)){
                        type = line.substring(0, line.indexOf(":")).trim();
                        break;
                    }
                }
            }
            for (AtomicDEVS a : settings.getAdevs()){
                if (a.getName().equals(type)){
                    for (String s : a.getPorts()){
                        if (s.contains(par)){
                            listModel.addElement(s.substring(s.indexOf(":")+1).trim());
                        }
                    }
                }
            }
            for (CoupledDEVS a : settings.getCdevs()){
                if (a.getName().equals(type)){
                    for (String s : a.getPorts()){
                        if (s.contains(par)){
                            listModel.addElement(s.substring(s.indexOf(":")+1).trim());
                        }
                    }
                }
            }
        }
        
        if (par.equals("OUT"))
            fromPortList.setModel(listModel);
        else
            toPortList.setModel(listModel);
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        buttonGroup1 = new javax.swing.ButtonGroup();
        nameField = new javax.swing.JTextField();
        jSeparator1 = new javax.swing.JSeparator();
        saveButton = new javax.swing.JButton();
        discardChanges = new javax.swing.JButton();
        jTabbedPane1 = new javax.swing.JTabbedPane();
        jPanel6 = new javax.swing.JPanel();
        jPanel2 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        modelList = new javax.swing.JList<>();
        addDEVSButton = new javax.swing.JButton();
        newNameField = new javax.swing.JTextField();
        jLabel2 = new javax.swing.JLabel();
        jScrollPane2 = new javax.swing.JScrollPane();
        componentsField = new javax.swing.JEditorPane();
        jPanel1 = new javax.swing.JPanel();
        jScrollPane4 = new javax.swing.JScrollPane();
        connectionsPane = new javax.swing.JTextPane();
        jPanel4 = new javax.swing.JPanel();
        fromModelComboBox = new javax.swing.JComboBox<>();
        jScrollPane5 = new javax.swing.JScrollPane();
        fromPortList = new javax.swing.JList<>();
        jPanel5 = new javax.swing.JPanel();
        toModelComboBox = new javax.swing.JComboBox<>();
        jScrollPane6 = new javax.swing.JScrollPane();
        toPortList = new javax.swing.JList<>();
        addConnectionButton = new javax.swing.JButton();
        jPanel3 = new javax.swing.JPanel();
        jScrollPane3 = new javax.swing.JScrollPane();
        portsPane = new javax.swing.JEditorPane();
        inputRadioButton = new javax.swing.JRadioButton();
        outputRadioButton = new javax.swing.JRadioButton();
        jLabel3 = new javax.swing.JLabel();
        newPortNameField = new javax.swing.JTextField();
        newPortButton = new javax.swing.JButton();
        jPanel7 = new javax.swing.JPanel();
        jPanel8 = new javax.swing.JPanel();
        jScrollPane7 = new javax.swing.JScrollPane();
        prioList = new javax.swing.JList<>();
        prioUpButton = new javax.swing.JToggleButton();
        prioDownButton = new javax.swing.JButton();
        jPanel9 = new javax.swing.JPanel();
        jScrollPane8 = new javax.swing.JScrollPane();
        paramPane = new javax.swing.JTextPane();
        jLabel4 = new javax.swing.JLabel();
        newParamField = new javax.swing.JTextField();
        newParamButton = new javax.swing.JButton();
        newParamValueField = new javax.swing.JTextField();
        jLabel5 = new javax.swing.JLabel();
        jLabel1 = new javax.swing.JLabel();
        paramComboBox = new javax.swing.JComboBox<>();
        jPanel10 = new javax.swing.JPanel();
        transferFunctionCombo = new javax.swing.JComboBox<>();
        jScrollPane9 = new javax.swing.JScrollPane();
        transferFunctionPane = new javax.swing.JTextPane();
        jButton1 = new javax.swing.JButton();

        setPreferredSize(new java.awt.Dimension(993, 637));

        nameField.setFont(new java.awt.Font("Courier New", 0, 11)); // NOI18N
        nameField.setBorder(javax.swing.BorderFactory.createTitledBorder("Name"));
        nameField.setCaretColor(new java.awt.Color(255, 255, 255));
        nameField.setMinimumSize(new java.awt.Dimension(6, 50));
        nameField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                nameFieldActionPerformed(evt);
            }
        });

        saveButton.setText("Save changes");
        saveButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                saveButtonActionPerformed(evt);
            }
        });

        discardChanges.setText("Discard changes");

        jPanel2.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        modelList.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Available DEVS", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 0, 11), new java.awt.Color(0, 0, 204))); // NOI18N
        modelList.setModel(new javax.swing.AbstractListModel<String>() {
            String[] strings = { "Item 1", "Item 2", "Item 3", "Item 4", "Item 5" };
            public int getSize() { return strings.length; }
            public String getElementAt(int i) { return strings[i]; }
        });
        jScrollPane1.setViewportView(modelList);

        addDEVSButton.setText(">");
        addDEVSButton.setEnabled(false);
        addDEVSButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                addDEVSButtonActionPerformed(evt);
            }
        });

        newNameField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                newNameFieldActionPerformed(evt);
            }
        });

        jLabel2.setText("Name:");

        componentsField.setBorder(javax.swing.BorderFactory.createTitledBorder("Components"));
        componentsField.setFont(new java.awt.Font("Courier New", 0, 11)); // NOI18N
        jScrollPane2.setViewportView(componentsField);

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(jLabel2)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(newNameField, javax.swing.GroupLayout.PREFERRED_SIZE, 123, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(addDEVSButton))
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 205, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 294, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addComponent(jScrollPane2)
                        .addContainerGap())
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 113, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(addDEVSButton)
                            .addComponent(newNameField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel2))
                        .addGap(0, 15, Short.MAX_VALUE))))
        );

        jPanel1.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        connectionsPane.setBorder(javax.swing.BorderFactory.createTitledBorder("Connections"));
        connectionsPane.setFont(new java.awt.Font("Courier New", 0, 11)); // NOI18N
        jScrollPane4.setViewportView(connectionsPane);

        jPanel4.setBorder(javax.swing.BorderFactory.createTitledBorder("From"));

        fromModelComboBox.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));
        fromModelComboBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                fromModelComboBoxActionPerformed(evt);
            }
        });

        fromPortList.setModel(new javax.swing.AbstractListModel<String>() {
            String[] strings = { "Item 1", "Item 2", "Item 3", "Item 4", "Item 5" };
            public int getSize() { return strings.length; }
            public String getElementAt(int i) { return strings[i]; }
        });
        jScrollPane5.setViewportView(fromPortList);

        javax.swing.GroupLayout jPanel4Layout = new javax.swing.GroupLayout(jPanel4);
        jPanel4.setLayout(jPanel4Layout);
        jPanel4Layout.setHorizontalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(fromModelComboBox, 0, 155, Short.MAX_VALUE)
            .addComponent(jScrollPane5)
        );
        jPanel4Layout.setVerticalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel4Layout.createSequentialGroup()
                .addComponent(fromModelComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane5, javax.swing.GroupLayout.PREFERRED_SIZE, 71, javax.swing.GroupLayout.PREFERRED_SIZE))
        );

        jPanel5.setBorder(javax.swing.BorderFactory.createTitledBorder("To"));

        toModelComboBox.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));

        toPortList.setModel(new javax.swing.AbstractListModel<String>() {
            String[] strings = { "Item 1", "Item 2", "Item 3", "Item 4", "Item 5" };
            public int getSize() { return strings.length; }
            public String getElementAt(int i) { return strings[i]; }
        });
        jScrollPane6.setViewportView(toPortList);

        javax.swing.GroupLayout jPanel5Layout = new javax.swing.GroupLayout(jPanel5);
        jPanel5.setLayout(jPanel5Layout);
        jPanel5Layout.setHorizontalGroup(
            jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(toModelComboBox, 0, 153, Short.MAX_VALUE)
            .addComponent(jScrollPane6)
        );
        jPanel5Layout.setVerticalGroup(
            jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel5Layout.createSequentialGroup()
                .addComponent(toModelComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(jScrollPane6, javax.swing.GroupLayout.PREFERRED_SIZE, 71, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(59, 59, 59))
        );

        addConnectionButton.setText("^ ");
        addConnectionButton.setEnabled(false);
        addConnectionButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                addConnectionButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addComponent(jPanel4, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(addConnectionButton, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jPanel5, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(jScrollPane4))
                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane4, javax.swing.GroupLayout.PREFERRED_SIZE, 237, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(jPanel4, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jPanel5, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, 0, Short.MAX_VALUE)
                    .addComponent(addConnectionButton, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jPanel3.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        portsPane.setBorder(javax.swing.BorderFactory.createTitledBorder("Ports"));
        portsPane.setFont(new java.awt.Font("Courier New", 0, 11)); // NOI18N
        jScrollPane3.setViewportView(portsPane);

        buttonGroup1.add(inputRadioButton);
        inputRadioButton.setSelected(true);
        inputRadioButton.setText("Input");
        inputRadioButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                inputRadioButtonActionPerformed(evt);
            }
        });

        buttonGroup1.add(outputRadioButton);
        outputRadioButton.setText("Output");

        jLabel3.setText("Name:");

        newPortButton.setText(">");
        newPortButton.setEnabled(false);
        newPortButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                newPortButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel3Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(outputRadioButton)
                    .addComponent(inputRadioButton)
                    .addGroup(jPanel3Layout.createSequentialGroup()
                        .addComponent(jLabel3)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(newPortNameField, javax.swing.GroupLayout.PREFERRED_SIZE, 123, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(newPortButton)))
                .addGap(10, 10, 10)
                .addComponent(jScrollPane3, javax.swing.GroupLayout.PREFERRED_SIZE, 294, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel3Layout.createSequentialGroup()
                        .addComponent(outputRadioButton)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(inputRadioButton)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel3)
                            .addComponent(newPortNameField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(newPortButton))
                        .addGap(0, 117, Short.MAX_VALUE))
                    .addGroup(jPanel3Layout.createSequentialGroup()
                        .addComponent(jScrollPane3)
                        .addContainerGap())))
        );

        javax.swing.GroupLayout jPanel6Layout = new javax.swing.GroupLayout(jPanel6);
        jPanel6.setLayout(jPanel6Layout);
        jPanel6Layout.setHorizontalGroup(
            jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel6Layout.createSequentialGroup()
                .addGap(14, 14, 14)
                .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(jPanel2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jPanel3, javax.swing.GroupLayout.PREFERRED_SIZE, 0, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel6Layout.setVerticalGroup(
            jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel6Layout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                    .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, 0, Short.MAX_VALUE)
                    .addGroup(jPanel6Layout.createSequentialGroup()
                        .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jPanel3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );

        jTabbedPane1.addTab("Basic Settings", jPanel6);

        jPanel8.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        prioList.setBorder(javax.swing.BorderFactory.createTitledBorder("Priorities"));
        prioList.setModel(new javax.swing.AbstractListModel<String>() {
            String[] strings = { "Item 1", "Item 2", "Item 3", "Item 4", "Item 5" };
            public int getSize() { return strings.length; }
            public String getElementAt(int i) { return strings[i]; }
        });
        jScrollPane7.setViewportView(prioList);

        prioUpButton.setText("up");
        prioUpButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                prioUpButtonActionPerformed(evt);
            }
        });

        prioDownButton.setText("down");
        prioDownButton.setMaximumSize(new java.awt.Dimension(64, 23));
        prioDownButton.setMinimumSize(new java.awt.Dimension(64, 23));
        prioDownButton.setPreferredSize(new java.awt.Dimension(64, 23));
        prioDownButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                prioDownButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel8Layout = new javax.swing.GroupLayout(jPanel8);
        jPanel8.setLayout(jPanel8Layout);
        jPanel8Layout.setHorizontalGroup(
            jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel8Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane7, javax.swing.GroupLayout.PREFERRED_SIZE, 241, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(prioUpButton, javax.swing.GroupLayout.PREFERRED_SIZE, 65, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(prioDownButton, javax.swing.GroupLayout.PREFERRED_SIZE, 65, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel8Layout.setVerticalGroup(
            jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel8Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane7, javax.swing.GroupLayout.PREFERRED_SIZE, 0, Short.MAX_VALUE)
                    .addGroup(jPanel8Layout.createSequentialGroup()
                        .addComponent(prioUpButton, javax.swing.GroupLayout.PREFERRED_SIZE, 64, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(prioDownButton, javax.swing.GroupLayout.DEFAULT_SIZE, 64, Short.MAX_VALUE)))
                .addContainerGap())
        );

        jPanel9.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        paramPane.setBorder(javax.swing.BorderFactory.createTitledBorder("Parameters"));
        jScrollPane8.setViewportView(paramPane);

        jLabel4.setText("Name:");

        newParamField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                newParamFieldActionPerformed(evt);
            }
        });

        newParamButton.setText("^");
        newParamButton.setEnabled(false);
        newParamButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                newParamButtonActionPerformed(evt);
            }
        });

        newParamValueField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                newParamValueFieldActionPerformed(evt);
            }
        });

        jLabel5.setText("Value:");

        jLabel1.setText("target:");

        paramComboBox.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));

        javax.swing.GroupLayout jPanel9Layout = new javax.swing.GroupLayout(jPanel9);
        jPanel9.setLayout(jPanel9Layout);
        jPanel9Layout.setHorizontalGroup(
            jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel9Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane8)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel9Layout.createSequentialGroup()
                        .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPanel9Layout.createSequentialGroup()
                                .addComponent(jLabel1)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(paramComboBox, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                            .addGroup(jPanel9Layout.createSequentialGroup()
                                .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(jLabel4)
                                    .addComponent(jLabel5))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(newParamValueField, javax.swing.GroupLayout.DEFAULT_SIZE, 220, Short.MAX_VALUE)
                                    .addComponent(newParamField))))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(newParamButton, javax.swing.GroupLayout.PREFERRED_SIZE, 53, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );
        jPanel9Layout.setVerticalGroup(
            jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel9Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane8, javax.swing.GroupLayout.DEFAULT_SIZE, 135, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel9Layout.createSequentialGroup()
                        .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel1)
                            .addComponent(paramComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(newParamField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel4, javax.swing.GroupLayout.Alignment.TRAILING))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(newParamValueField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel5)))
                    .addComponent(newParamButton, javax.swing.GroupLayout.PREFERRED_SIZE, 72, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(11, 11, 11))
        );

        jPanel10.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        transferFunctionCombo.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));
        transferFunctionCombo.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                transferFunctionComboActionPerformed(evt);
            }
        });

        transferFunctionPane.setBorder(javax.swing.BorderFactory.createTitledBorder("Transfer Function"));
        jScrollPane9.setViewportView(transferFunctionPane);

        javax.swing.GroupLayout jPanel10Layout = new javax.swing.GroupLayout(jPanel10);
        jPanel10.setLayout(jPanel10Layout);
        jPanel10Layout.setHorizontalGroup(
            jPanel10Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel10Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel10Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jScrollPane9)
                    .addComponent(transferFunctionCombo, javax.swing.GroupLayout.Alignment.LEADING, 0, 584, Short.MAX_VALUE))
                .addContainerGap())
        );
        jPanel10Layout.setVerticalGroup(
            jPanel10Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel10Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(transferFunctionCombo, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jScrollPane9)
                .addContainerGap())
        );

        javax.swing.GroupLayout jPanel7Layout = new javax.swing.GroupLayout(jPanel7);
        jPanel7.setLayout(jPanel7Layout);
        jPanel7Layout.setHorizontalGroup(
            jPanel7Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel7Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel7Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(jPanel8, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jPanel9, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel10, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );
        jPanel7Layout.setVerticalGroup(
            jPanel7Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel7Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel7Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jPanel10, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addGroup(jPanel7Layout.createSequentialGroup()
                        .addComponent(jPanel8, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jPanel9, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                .addContainerGap())
        );

        jTabbedPane1.addTab("Advanced Settings", jPanel7);
        jPanel7.getAccessibleContext().setAccessibleName("");

        jButton1.setText("Show Visualization");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jSeparator1)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(saveButton)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(discardChanges)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(jButton1))
                    .addComponent(jTabbedPane1)
                    .addComponent(nameField, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(saveButton)
                    .addComponent(discardChanges)
                    .addComponent(jButton1))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jSeparator1, javax.swing.GroupLayout.PREFERRED_SIZE, 10, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(nameField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jTabbedPane1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(80, Short.MAX_VALUE))
        );

        jTabbedPane1.getAccessibleContext().setAccessibleName("Advanced Settings");
    }// </editor-fold>//GEN-END:initComponents

    private void nameFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_nameFieldActionPerformed

    }//GEN-LAST:event_nameFieldActionPerformed

    private void saveButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_saveButtonActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_saveButtonActionPerformed

    private void inputRadioButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_inputRadioButtonActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_inputRadioButtonActionPerformed

    private void newPortButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_newPortButtonActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_newPortButtonActionPerformed

    private void newNameFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_newNameFieldActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_newNameFieldActionPerformed

    private void prioUpButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_prioUpButtonActionPerformed
        int index = prioList.getSelectedIndex();
        
        ArrayList<String> buf = cdevs.getPriorities();
        if (index != 0) {
            String buf2 = buf.remove(index);
            buf.add(index-1, buf2);
        }
        
        DefaultListModel listModel = new DefaultListModel();
        for (String s : buf){
            listModel.addElement(s);
        }
        prioList.setModel(listModel);
        prioList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        if (index != 0) 
            prioList.setSelectedIndex(index-1);
        
    }//GEN-LAST:event_prioUpButtonActionPerformed

    private void newParamFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_newParamFieldActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_newParamFieldActionPerformed

    private void newParamButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_newParamButtonActionPerformed
        paramPane.setText(paramPane.getText() + ((String) paramComboBox.getSelectedItem()) + " : " + newParamField.getText() + " = " + newParamValueField.getText() + "\n");
        
        newParamField.setText("");
        newParamValueField.setText("");
        newParamButton.setEnabled(false);

    }//GEN-LAST:event_newParamButtonActionPerformed

    private void prioDownButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_prioDownButtonActionPerformed
        int index = prioList.getSelectedIndex();
        
        ArrayList<String> buf = cdevs.getPriorities();
        if (index < buf.size()-1) {
            String buf2 = buf.remove(index);
            buf.add(index+1, buf2);
        }
        
        DefaultListModel listModel = new DefaultListModel();
        for (String s : buf){
            listModel.addElement(s);
        }
        prioList.setModel(listModel);
        prioList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        if (index < buf.size()-1)
            prioList.setSelectedIndex(index+1);
    }//GEN-LAST:event_prioDownButtonActionPerformed

    private void fromModelComboBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_fromModelComboBoxActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_fromModelComboBoxActionPerformed

    private void transferFunctionComboActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_transferFunctionComboActionPerformed
        //this.transferSelectionChanged();
    }//GEN-LAST:event_transferFunctionComboActionPerformed

    private void newParamValueFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_newParamValueFieldActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_newParamValueFieldActionPerformed

    private void addConnectionButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_addConnectionButtonActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_addConnectionButtonActionPerformed

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        JOptionPane.showMessageDialog(null,
            "Unsaved changes will not be shown.", "Notice", JOptionPane.PLAIN_MESSAGE);
        CoupledDEVSGraph cdg = new CoupledDEVSGraph(cdevs);
    }//GEN-LAST:event_jButton1ActionPerformed

    private void addDEVSButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_addDEVSButtonActionPerformed

    }//GEN-LAST:event_addDEVSButtonActionPerformed

    

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton addConnectionButton;
    private javax.swing.JButton addDEVSButton;
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.JEditorPane componentsField;
    private javax.swing.JTextPane connectionsPane;
    private javax.swing.JButton discardChanges;
    private javax.swing.JComboBox<String> fromModelComboBox;
    private javax.swing.JList<String> fromPortList;
    private javax.swing.JRadioButton inputRadioButton;
    private javax.swing.JButton jButton1;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel10;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JPanel jPanel6;
    private javax.swing.JPanel jPanel7;
    private javax.swing.JPanel jPanel8;
    private javax.swing.JPanel jPanel9;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JScrollPane jScrollPane4;
    private javax.swing.JScrollPane jScrollPane5;
    private javax.swing.JScrollPane jScrollPane6;
    private javax.swing.JScrollPane jScrollPane7;
    private javax.swing.JScrollPane jScrollPane8;
    private javax.swing.JScrollPane jScrollPane9;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JList<String> modelList;
    private javax.swing.JTextField nameField;
    private javax.swing.JTextField newNameField;
    private javax.swing.JButton newParamButton;
    private javax.swing.JTextField newParamField;
    private javax.swing.JTextField newParamValueField;
    private javax.swing.JButton newPortButton;
    private javax.swing.JTextField newPortNameField;
    private javax.swing.JRadioButton outputRadioButton;
    private javax.swing.JComboBox<String> paramComboBox;
    private javax.swing.JTextPane paramPane;
    private javax.swing.JEditorPane portsPane;
    private javax.swing.JButton prioDownButton;
    private javax.swing.JList<String> prioList;
    private javax.swing.JToggleButton prioUpButton;
    private javax.swing.JButton saveButton;
    private javax.swing.JComboBox<String> toModelComboBox;
    private javax.swing.JList<String> toPortList;
    private javax.swing.JComboBox<String> transferFunctionCombo;
    private javax.swing.JTextPane transferFunctionPane;
    // End of variables declaration//GEN-END:variables

    public void updateComponents() {
        DefaultListModel listModel = new DefaultListModel();
            for (CoupledDEVS c : settings.getCdevs()){
                if (!c.equals(cdevs)){
                    listModel.addElement(c.getName());
                }
            }
            for (AtomicDEVS c : settings.getAdevs()){
                listModel.addElement(c.getName());
            }
            modelList.setModel(listModel);
    }
}
