/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package mdeckers.thesis.uantwerp.gui.editor;

import java.io.File;
import java.util.ArrayList;
import javax.swing.DefaultListModel;
import javax.swing.JFileChooser;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;
import javax.swing.filechooser.FileNameExtensionFilter;
import mdeckers.thesis.uantwerp.gui.main.MainFrame;
import mdeckers.thesis.uantwerp.model.Project;
import mdeckers.thesis.uantwerp.model.Settings;

/**
 *
 * @author Michael
 */
public class NewProject extends javax.swing.JFrame {
    
    private MainFrame callback;
    private String location;
    private String path;
    private String compPath;
    private String simPath;
    
    private boolean name;
    private boolean comp;
    private boolean sim;
    
    private NewProject _this;

    /**
     * Creates new form NewProject
     */
    public NewProject(MainFrame callback, String location) {
        this.callback = callback;
        this.location = location;
        name = false;
        comp = false;
        sim = false;
        
        initComponents();
        
        setNameField();
        
        compPath = path;
        simPath = path;
        
        setList();
        
        checkButton();
        _this = this;
        overrideClose();
    }
    
    private void overrideClose(){
        this.addWindowListener(new java.awt.event.WindowAdapter() {
            @Override
            public void windowClosing(java.awt.event.WindowEvent windowEvent) {
                _this.setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
                _this.setVisible(false);
            }
        });
    }
    
    private void setNameField() {
        int opt1, opt2, opt;
        opt1 = location.lastIndexOf("/");
        opt2 = location.lastIndexOf("\\");
        if (opt1 > opt2){
            opt = opt1 + 1;
        } else {
            opt = opt2 + 1;
        }
        path = location.substring(0, opt);
        this.nameField.setText(location.substring(opt, location.lastIndexOf(".")));
        name = !this.nameField.getText().trim().isEmpty();
        
        nameField.getDocument().addDocumentListener(new DocumentListener() {

            public void warn() {
               String text = nameField.getText();
               name = (text.trim().length() != 0);
               
               checkButton();
            }

            @Override
            public void insertUpdate(DocumentEvent e) {
                warn();
            }

            @Override
            public void removeUpdate(DocumentEvent e) {
                warn();
            }

            @Override
            public void changedUpdate(DocumentEvent e) {
                warn();
            }
          });
    }
    
    private void checkButton(){
        createButton.setEnabled(name && sim && comp);
    }
    
    private void setList() {
        DefaultListModel listModel = new DefaultListModel();
        this.componentsList.setModel(listModel);
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel1 = new javax.swing.JLabel();
        nameField = new javax.swing.JTextField();
        jLabel2 = new javax.swing.JLabel();
        compLocation = new javax.swing.JTextField();
        jSeparator1 = new javax.swing.JSeparator();
        jLabel3 = new javax.swing.JLabel();
        simLocation = new javax.swing.JTextField();
        compLocationButton = new javax.swing.JButton();
        simLocationButton = new javax.swing.JButton();
        jSeparator2 = new javax.swing.JSeparator();
        jScrollPane1 = new javax.swing.JScrollPane();
        componentsList = new javax.swing.JList<>();
        jLabel4 = new javax.swing.JLabel();
        addComponentButton = new javax.swing.JButton();
        removeComponentButton = new javax.swing.JButton();
        jSeparator3 = new javax.swing.JSeparator();
        createButton = new javax.swing.JButton();
        cancelButton = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("Create New Project");

        jLabel1.setText("Name: ");

        jLabel2.setText("Compilation Output Location:");

        compLocation.setEnabled(false);
        compLocation.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                compLocationActionPerformed(evt);
            }
        });

        jLabel3.setText("Simulation Settings File Location:");

        simLocation.setEnabled(false);
        simLocation.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                simLocationActionPerformed(evt);
            }
        });

        compLocationButton.setText("select");
        compLocationButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                compLocationButtonActionPerformed(evt);
            }
        });

        simLocationButton.setText("select");
        simLocationButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                simLocationButtonActionPerformed(evt);
            }
        });

        componentsList.setModel(new javax.swing.AbstractListModel<String>() {
            String[] strings = { "Item 1", "Item 2", "Item 3", "Item 4", "Item 5" };
            public int getSize() { return strings.length; }
            public String getElementAt(int i) { return strings[i]; }
        });
        jScrollPane1.setViewportView(componentsList);

        jLabel4.setText("DEVS Components");

        addComponentButton.setText("+");
        addComponentButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                addComponentButtonActionPerformed(evt);
            }
        });

        removeComponentButton.setText("-");
        removeComponentButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                removeComponentButtonActionPerformed(evt);
            }
        });

        createButton.setText("Create");
        createButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                createButtonActionPerformed(evt);
            }
        });

        cancelButton.setText("Cancel");
        cancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jSeparator1)
            .addComponent(jSeparator2)
            .addComponent(jSeparator3)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jLabel1)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(nameField))
                    .addComponent(compLocation)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jLabel3)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 563, Short.MAX_VALUE)
                        .addComponent(simLocationButton))
                    .addComponent(simLocation)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jLabel2)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(compLocationButton))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jLabel4)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(removeComponentButton)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(addComponentButton))
                    .addComponent(jScrollPane1)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addGap(0, 0, Short.MAX_VALUE)
                        .addComponent(cancelButton)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(createButton)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(nameField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jSeparator1, javax.swing.GroupLayout.PREFERRED_SIZE, 10, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel2)
                    .addComponent(compLocationButton))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(compLocation, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel3)
                    .addComponent(simLocationButton))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(simLocation, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jSeparator2, javax.swing.GroupLayout.PREFERRED_SIZE, 10, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel4)
                    .addComponent(addComponentButton)
                    .addComponent(removeComponentButton))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jSeparator3, javax.swing.GroupLayout.PREFERRED_SIZE, 10, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(createButton)
                    .addComponent(cancelButton))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void compLocationActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_compLocationActionPerformed
        
    }//GEN-LAST:event_compLocationActionPerformed

    private void simLocationActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_simLocationActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_simLocationActionPerformed

    private void compLocationButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_compLocationButtonActionPerformed
        JFileChooser fc = new JFileChooser();
        fc.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
        fc.setCurrentDirectory(new File(compPath));
        
        int returnVal;
        returnVal = fc.showOpenDialog(null);

        if (returnVal == JFileChooser.APPROVE_OPTION) {
            this.compLocation.setText(fc.getSelectedFile().getAbsolutePath());
            compPath = fc.getSelectedFile().getAbsolutePath();
            comp = true;
            checkButton();
        }
    }//GEN-LAST:event_compLocationButtonActionPerformed

    private void simLocationButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_simLocationButtonActionPerformed
        JFileChooser fc = new JFileChooser();
        fc.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
        fc.setCurrentDirectory(new File(simPath));
        
        int returnVal;
        returnVal = fc.showOpenDialog(null);

        if (returnVal == JFileChooser.APPROVE_OPTION) {
            this.simLocation.setText(fc.getSelectedFile().getAbsolutePath());
            simPath = fc.getSelectedFile().getAbsolutePath();
            sim = true;
            checkButton();
        }
    }//GEN-LAST:event_simLocationButtonActionPerformed

    private void addComponentButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_addComponentButtonActionPerformed
        JFileChooser fc = new JFileChooser();
        fc.setMultiSelectionEnabled(true);
        
        FileNameExtensionFilter filter = new FileNameExtensionFilter("DEVS Files", "adevs", "cdevs", "devsmessage");
        fc.setFileFilter(filter);
        //fc.setCurrentDirectory(new File("./files"));
        fc.setCurrentDirectory(new File("files"));
        
        int returnVal;
        returnVal = fc.showOpenDialog(null);

        if (returnVal == JFileChooser.APPROVE_OPTION) {
            File[] files = fc.getSelectedFiles();
            
            for (File f : files){
                DefaultListModel dlm = (DefaultListModel) this.componentsList.getModel();
                if (!dlm.contains(f.getPath()))
                    dlm.addElement(f.getPath());
            }
        }
    }//GEN-LAST:event_addComponentButtonActionPerformed

    private void removeComponentButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_removeComponentButtonActionPerformed
        DefaultListModel dlm = (DefaultListModel) this.componentsList.getModel();
        dlm.removeElement(this.componentsList.getSelectedValue());
    }//GEN-LAST:event_removeComponentButtonActionPerformed

    private void createButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_createButtonActionPerformed
        ArrayList<String> listElements = new ArrayList();
        DefaultListModel dlm = (DefaultListModel) this.componentsList.getModel();
        for (int i = 0; i < dlm.getSize(); i++){
            listElements.add((String) dlm.getElementAt(i));
        }
        
        File written = new File(location);
        
        
        if (System.getProperty("os.name").startsWith("Windows")) {
            Settings.location = (location.substring(0, location.lastIndexOf("\\")));
        } else {
            Settings.location = (location.substring(0, location.lastIndexOf("/")));
        }
        Settings.write(written, this.nameField.getText(), listElements, 
                this.compLocation.getText().concat("/output.py"), 
                this.simLocation.getText().concat("/" + this.nameField.getText() + "_experiment.py"), null);
        
        Project.newModel(written, callback.getStateKeeper());
        
        this.setVisible(false);
    }//GEN-LAST:event_createButtonActionPerformed

    private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelButtonActionPerformed
        this.setVisible(false);
    }//GEN-LAST:event_cancelButtonActionPerformed


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton addComponentButton;
    private javax.swing.JButton cancelButton;
    private javax.swing.JTextField compLocation;
    private javax.swing.JButton compLocationButton;
    private javax.swing.JList<String> componentsList;
    private javax.swing.JButton createButton;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JSeparator jSeparator2;
    private javax.swing.JSeparator jSeparator3;
    private javax.swing.JTextField nameField;
    private javax.swing.JButton removeComponentButton;
    private javax.swing.JTextField simLocation;
    private javax.swing.JButton simLocationButton;
    // End of variables declaration//GEN-END:variables
}
