/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package mdeckers.thesis.uantwerp.gui.graph;

import com.mxgraph.layout.hierarchical.mxHierarchicalLayout;
import com.mxgraph.layout.mxIGraphLayout;
import javax.swing.JFrame;

import com.mxgraph.swing.mxGraphComponent;
import com.mxgraph.swing.util.mxMorphing;
import com.mxgraph.util.mxEvent;
import com.mxgraph.util.mxEventObject;
import com.mxgraph.util.mxEventSource.mxIEventListener;
import com.mxgraph.view.mxGraph;
import java.util.ArrayList;
import mdeckers.thesis.uantwerp.model.AtomicDEVS;

public class AtomicDEVSGraph extends JFrame
{
    private ArrayList<ArrayList<Object>> objects;
    private AtomicDEVS cdevs;
            
    public AtomicDEVSGraph(AtomicDEVS cdevs) {
        super(cdevs.getName());
        
        this.cdevs = cdevs;
        
        mxGraph graph = new mxGraph();
        Object parent = graph.getDefaultParent();
        graph.getModel().beginUpdate();
        
        
        try {
            objects = new ArrayList();
            for (String c : cdevs.getStates()){
                if (c.contains(": starting state")){
                    c = c.substring(0, c.indexOf(": starting state")).trim();
                }
                ArrayList<Object> adder = new ArrayList();
                adder.add(c);
                adder.add(graph.insertVertex(parent, null, c, 100, 100, c.length()*6, 30));
                objects.add(adder);
            }
                
            setupITs(graph, parent);
            setupETs(graph, parent);
        }
        finally {
            graph.getModel().endUpdate();
        }
        
        
        
        mxGraphComponent graphComponent = new mxGraphComponent(graph);
        getContentPane().add(graphComponent);
        
        morphGraph(graph, graphComponent);
        
        this.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
        this.setSize(800, 800);
        this.setVisible(true);
    }
    
    private void setupITs(mxGraph graph, Object parent){
        /*String from = cdevs.getITs().get(0).get(0), to = cdevs.getITs().get(1).get(0); 
        from = from.substring(from.indexOf(":")+2).trim();
        to = to.substring(to.indexOf(":")+2).trim();


        Object f = null, t = null;

        for (ArrayList a : objects){
            if (a.get(0).equals(from)){
                f = a.get(1);
                break;
            }
        }
        for (ArrayList a : objects){
            if (a.get(0).equals(to)){
                t = a.get(1);
                break;
            }
        }

        graph.insertEdge(parent, null, "internal", f, t, "strokeColor=green;fontColor=green");*/
        String from = "", to = "";
        Object f = null, t = null;
        for (int i = 0; i < cdevs.getITs().size(); i++){
            if (i % 4 == 0){
                from = cdevs.getITs().get(i).get(0);
                from = from.substring(from.indexOf(":")+2).trim();
                for (ArrayList a : objects){
                    if (a.get(0).equals(from)){
                        f = a.get(1);
                        break;
                    }
                }
            } else if (i % 4 == 1){
                to = cdevs.getITs().get(i).get(0);
                to = to.substring(to.indexOf(":")+2).trim();
                for (ArrayList a : objects){
                    if (a.get(0).equals(to)){
                        t = a.get(1);
                        break;
                    }
                }
            } else if (i % 4 == 2){
                graph.insertEdge(parent, null, "internal", f, t, "strokeColor=green;fontColor=green");
            }
        }
    }
    
    private void setupETs(mxGraph graph, Object parent){
        String from = "", to = "";
        Object f = null, t = null;
        for (int i = 0; i < cdevs.getETs().size(); i++){
            if (i % 4 == 0){
                from = cdevs.getETs().get(i).get(0);
                from = from.substring(from.indexOf(":")+2).trim();
                for (ArrayList a : objects){
                    if (a.get(0).equals(from)){
                        f = a.get(1);
                        break;
                    }
                }
            } else if (i % 4 == 1){
                to = cdevs.getETs().get(i).get(0);
                to = to.substring(to.indexOf(":")+2).trim();
                for (ArrayList a : objects){
                    if (a.get(0).equals(to)){
                        t = a.get(1);
                        break;
                    }
                }
            } else if (i % 4 == 2){
                graph.insertEdge(parent, null, "external", f, t, "strokeColor=red;fontColor=red");
            }
        }
    }
    
    private static void morphGraph(mxGraph graph, mxGraphComponent graphComponent) {
        // define layout
        /*
        mxCircleLayout,
        mxCompactTreeLayout,
        mxEdgeLabelLayout, 
        mxFastOrganicLayout, 
        mxHierarchicalLayout, 
        mxOrganicLayout, 
        mxOrthogonalLayout, 
        mxParallelEdgeLayout, 
        mxPartitionLayout, 
        mxStackLayout
        */
        mxIGraphLayout layout = new mxHierarchicalLayout(graph);

        // layout using morphing
        graph.getModel().beginUpdate();
        try {
                layout.execute(graph.getDefaultParent());
        } finally {
                mxMorphing morph = new mxMorphing(graphComponent, 20, 1.5, 20);

                morph.addListener(mxEvent.DONE, new mxIEventListener() {

                    @Override
                    public void invoke(Object arg0, mxEventObject arg1) {
                            graph.getModel().endUpdate();
                            // fitViewport();
                    }

                });

                morph.startAnimation();
        }

    }

}
