/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package mdeckers.thesis.uantwerp.gui.graph;

import com.mxgraph.layout.hierarchical.mxHierarchicalLayout;
import com.mxgraph.layout.mxFastOrganicLayout;
import com.mxgraph.layout.mxIGraphLayout;
import javax.swing.JFrame;

import com.mxgraph.swing.mxGraphComponent;
import com.mxgraph.swing.util.mxMorphing;
import com.mxgraph.util.mxEvent;
import com.mxgraph.util.mxEventObject;
import com.mxgraph.util.mxEventSource.mxIEventListener;
import com.mxgraph.view.mxGraph;
import java.util.ArrayList;
import mdeckers.thesis.uantwerp.model.CoupledDEVS;

public class CoupledDEVSGraph extends JFrame
{
    public CoupledDEVSGraph(CoupledDEVS cdevs) {
        super(cdevs.getName());
        
        mxGraph graph = new mxGraph();
        Object parent = graph.getDefaultParent();
        graph.getModel().beginUpdate();
        
        
        try {
            ArrayList<ArrayList<Object>> objects = new ArrayList();
            Object inThis = graph.insertVertex(parent, null, "this.input", 0, 0, 60, 20, "ROUNDED;fillColor=red;fontColor=white");
            Object outThis = graph.insertVertex(parent, null, "this.output", 0, 0, 60, 20, "ROUNDED;fillColor=green;fontColor=white");
            for (String c : cdevs.getComponents()){
                ArrayList<Object> adder = new ArrayList();
                adder.add(c.substring(c.indexOf(":")+2));
                adder.add(graph.insertVertex(parent, null, c, 100, 100, c.length()*6, 30));
                objects.add(adder);
            }
            for (String c : cdevs.getConnections()){
                String from, to; 
                from = c.substring(0, c.indexOf("->")).trim();
                to = c.substring(c.indexOf("->")+2, c.length()).trim();
                
                if (from.contains(".")){
                    from = from.substring(0, from.indexOf("."));
                } else {
                    from = "";
                }
                if (to.contains(".")){
                    to = to.substring(0, to.indexOf("."));
                } else {
                    to = "";
                }
                
                Object f = null, t = null;
                
                if (!from.trim().isEmpty()){
                    for (ArrayList a : objects){
                        if (a.get(0).equals(from)){
                            f = a.get(1);
                            break;
                        }
                    }
                } else {
                    f = inThis;
                }
                if (!to.trim().isEmpty()){
                    for (ArrayList a : objects){
                        if (a.get(0).equals(to)){
                            t = a.get(1);
                            break;
                        }
                    }
                } else {
                    t = outThis;
                }
                
                graph.insertEdge(parent, null, "", f, t);
            }
        }
        finally {
            graph.getModel().endUpdate();
        }
        
        
        
        mxGraphComponent graphComponent = new mxGraphComponent(graph);
        getContentPane().add(graphComponent);
        
        morphGraph(graph, graphComponent);
        
        this.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
        this.setSize(800, 800);
        this.setVisible(true);
    }
    
    private static void morphGraph(mxGraph graph, mxGraphComponent graphComponent) {
        // define layout
        /*
        mxCircleLayout,
        mxCompactTreeLayout,
        mxEdgeLabelLayout, 
        mxFastOrganicLayout, 
        mxHierarchicalLayout, 
        mxOrganicLayout, 
        mxOrthogonalLayout, 
        mxParallelEdgeLayout, 
        mxPartitionLayout, 
        mxStackLayout
        */
        mxIGraphLayout layout = new mxHierarchicalLayout(graph);

        // layout using morphing
        graph.getModel().beginUpdate();
        try {
                layout.execute(graph.getDefaultParent());
        } finally {
                mxMorphing morph = new mxMorphing(graphComponent, 20, 1.5, 20);

                morph.addListener(mxEvent.DONE, new mxIEventListener() {

                    @Override
                    public void invoke(Object arg0, mxEventObject arg1) {
                            graph.getModel().endUpdate();
                            // fitViewport();
                    }

                });

                morph.startAnimation();
        }

    }

}
