/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package mdeckers.thesis.uantwerp.gui.main;

import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import javax.swing.JTree;
import javax.swing.event.TreeSelectionEvent;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeModel;
import mdeckers.thesis.uantwerp.model.AtomicDEVS;
import mdeckers.thesis.uantwerp.model.CoupledDEVS;
import mdeckers.thesis.uantwerp.model.Message;
import mdeckers.thesis.uantwerp.model.Project;

/**
 *
 * @author Michael
 */
public class FileSelector extends JTree{
    
    JTree tree;
    Object lastSelected;
    MainFrame parent;
    
    public FileSelector(MainFrame parent){
        super();
        this.parent = parent;
        DefaultMutableTreeNode dmtn = new DefaultMutableTreeNode("Empty project");
        DefaultTreeModel dtm = new DefaultTreeModel(dmtn);
        this.setModel(dtm);
        tree = this;
        
        this.addMouseListener(new MouseAdapter(){
            public void mousePressed(MouseEvent e) {
                DefaultMutableTreeNode node = (DefaultMutableTreeNode)
                tree.getLastSelectedPathComponent();

                if (node == null)
                    return;
                
                if(e.getClickCount() == 2) {
                    lastSelected = node.getUserObject();
                    show(lastSelected);
                }
            }
            
        });
    }
    
    private void show(Object o){
        parent.itemSelected(o);
    }
    //Where the tree is initialized:
    

    //Listen for when the selection changes.
    
    public void valueChanged(TreeSelectionEvent e) {
    //Returns the last path element of the selection.
    //This method is useful only when the selection model allows a single selection.
        
    }
    
    private boolean containsProject(String location) {
        return true;
    }
    
    public void update(Project project, boolean showLib){
        if (project != null && project.getSettings() != null && project.getSettings().getName() != null){
            DefaultMutableTreeNode dmtn = new DefaultMutableTreeNode(project.getSettings().getName());

            createNodes(dmtn, project, showLib);

            DefaultTreeModel dtm = new DefaultTreeModel(dmtn);
            this.setModel(dtm);
        }
    }

    private void createNodes(DefaultMutableTreeNode top, Project project, boolean showLib) {
        DefaultMutableTreeNode settings = null;
        DefaultMutableTreeNode type1 = null;
        DefaultMutableTreeNode type2 = null;
        DefaultMutableTreeNode type3 = null;
        DefaultMutableTreeNode model = null;
        
        settings = new DefaultMutableTreeNode(project.getSettings().getName());
        top.add(settings);
        type1 = new DefaultMutableTreeNode("Coupled DEVS");
        top.add(type1);
        type2 = new DefaultMutableTreeNode("Atomic DEVS");
        top.add(type2);
        type3 = new DefaultMutableTreeNode("Message");
        top.add(type3);
        
        for (Object o : project.getSettings().getComponentsObjects()){
            if (o instanceof CoupledDEVS){
                if (showLib || ((CoupledDEVS) o).isLibary() != 2){
                    model = new DefaultMutableTreeNode(o);
                    type1.add(model);
                }
            } else if (o instanceof AtomicDEVS){
                if (showLib || ((AtomicDEVS) o).isLibary() != 2){
                    model = new DefaultMutableTreeNode(o);
                    type2.add(model);
                }
            } else if (o instanceof Message){
                if (showLib || ((Message) o).isLibary() != 2){
                    model = new DefaultMutableTreeNode(o);
                    type3.add(model);
                }
            }
        }
    }
}
