/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package mdeckers.thesis.uantwerp.gui.main;

import java.awt.BorderLayout;
import java.io.BufferedReader;
import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.Scanner;
import java.util.UUID;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.BoxLayout;
import javax.swing.JDialog;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextArea;
import javax.swing.UIManager;
import javax.swing.JScrollPane;
import javax.swing.JTextField;
import javax.swing.filechooser.FileNameExtensionFilter;
import javax.swing.text.JTextComponent;
import mdeckers.thesis.uantwerp.compiler.PyPDEVSCreator;
import mdeckers.thesis.uantwerp.gui.editor.AbstractComponentView;
import mdeckers.thesis.uantwerp.gui.editor.AtomicDEVSPanel;
import mdeckers.thesis.uantwerp.gui.editor.CoupledDEVSPanel;
import mdeckers.thesis.uantwerp.gui.editor.MessagePanel;
import mdeckers.thesis.uantwerp.gui.editor.NewComponent;
import mdeckers.thesis.uantwerp.gui.editor.NewProject;
import mdeckers.thesis.uantwerp.gui.simulator.MessageConsole;
import mdeckers.thesis.uantwerp.library.LibraryGetter;
import mdeckers.thesis.uantwerp.model.AtomicDEVS;
import mdeckers.thesis.uantwerp.model.Component;
import mdeckers.thesis.uantwerp.model.CoupledDEVS;
import mdeckers.thesis.uantwerp.model.Message;
import mdeckers.thesis.uantwerp.model.Project;
import mdeckers.thesis.uantwerp.state.StateKeeper;

/**
 *
 * @author Michael
 */
public class MainFrame extends javax.swing.JFrame {

    /**
     * Creates new form MainFrame
     */
    public MainFrame() {
        stateKeeper = new StateKeeper(this);
        
        initComponents();
        Log.setConsole(consoleView);
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        treeScrollPane = new javax.swing.JScrollPane();
        projectTree = new FileSelector(this);
        editorPane = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        jScrollPane2 = new javax.swing.JScrollPane();
        consoleView = new javax.swing.JTextPane();
        showLibCheckbox = new javax.swing.JCheckBox();
        menuBar = new javax.swing.JMenuBar();
        fileMenu = new javax.swing.JMenu();
        loadProjectMenuItem = new javax.swing.JMenuItem();
        newProjectMenu = new javax.swing.JMenuItem();
        jSeparator2 = new javax.swing.JPopupMenu.Separator();
        jMenu2 = new javax.swing.JMenu();
        addADEVSmenu = new javax.swing.JMenuItem();
        addCDEVSmenu = new javax.swing.JMenuItem();
        addMessageMenu = new javax.swing.JMenuItem();
        jMenu3 = new javax.swing.JMenu();
        addNewADEVSmenu = new javax.swing.JMenuItem();
        addNewCDEVSmenu = new javax.swing.JMenuItem();
        addNewMessageMenu = new javax.swing.JMenuItem();
        jSeparator3 = new javax.swing.JPopupMenu.Separator();
        saveMenu = new javax.swing.JMenuItem();
        editMenu = new javax.swing.JMenu();
        clearConsole = new javax.swing.JMenuItem();
        Compile = new javax.swing.JMenu();
        compileMenuItem = new javax.swing.JMenuItem();
        jMenu1 = new javax.swing.JMenu();
        simulateMenuItem = new javax.swing.JMenuItem();
        jMenu4 = new javax.swing.JMenu();
        jMenuItem2 = new javax.swing.JMenuItem();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setMinimumSize(new java.awt.Dimension(1200, 680));

        projectTree.setBorder(javax.swing.BorderFactory.createTitledBorder("Project Explorer"));
        treeScrollPane.setViewportView(projectTree);

        jLabel1.setFont(new java.awt.Font("Tahoma", 0, 48)); // NOI18N
        jLabel1.setText("Usable DEVS Editor");

        jLabel2.setFont(new java.awt.Font("Tahoma", 0, 24)); // NOI18N
        jLabel2.setText("Created by: Michael Deckers");

        jLabel3.setFont(new java.awt.Font("Tahoma", 0, 18)); // NOI18N
        jLabel3.setText("as part of his Master Thesis");

        jLabel4.setFont(new java.awt.Font("Tahoma", 0, 18)); // NOI18N
        jLabel4.setText("at the University of Antwerp");

        javax.swing.GroupLayout editorPaneLayout = new javax.swing.GroupLayout(editorPane);
        editorPane.setLayout(editorPaneLayout);
        editorPaneLayout.setHorizontalGroup(
            editorPaneLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(editorPaneLayout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(editorPaneLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel1, javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jLabel2, javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jLabel3, javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jLabel4, javax.swing.GroupLayout.Alignment.TRAILING))
                .addContainerGap())
        );
        editorPaneLayout.setVerticalGroup(
            editorPaneLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(editorPaneLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel1)
                .addGap(18, 18, 18)
                .addComponent(jLabel2)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel3)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel4)
                .addContainerGap(522, Short.MAX_VALUE))
        );

        consoleView.setBorder(javax.swing.BorderFactory.createTitledBorder("Console"));
        consoleView.setDisabledTextColor(new java.awt.Color(0, 0, 0));
        consoleView.setEnabled(false);
        consoleView.setMaximumSize(new java.awt.Dimension(2147483647, 250));
        jScrollPane2.setViewportView(consoleView);

        showLibCheckbox.setText("Show internal library details");
        showLibCheckbox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                showLibCheckboxActionPerformed(evt);
            }
        });

        fileMenu.setText("File");

        loadProjectMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_O, java.awt.event.InputEvent.CTRL_MASK));
        loadProjectMenuItem.setText("Open DEVS Project");
        loadProjectMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                loadProjectMenuItemActionPerformed(evt);
            }
        });
        fileMenu.add(loadProjectMenuItem);
        loadProjectMenuItem.addActionListener(new java.awt.event.ActionListener() {
            @Override
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                Project.loadModel(this, stateKeeper);
            }
        });

        newProjectMenu.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_N, java.awt.event.InputEvent.CTRL_MASK));
        newProjectMenu.setText("New DEVS Project");
        newProjectMenu.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                newProjectMenuActionPerformed(evt);
            }
        });
        fileMenu.add(newProjectMenu);
        fileMenu.add(jSeparator2);

        jMenu2.setText("Add Existing...");

        addADEVSmenu.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_A, java.awt.event.InputEvent.ALT_MASK));
        addADEVSmenu.setText("Add Atomic DEVS");
        addADEVSmenu.setBorder(null);
        addADEVSmenu.setEnabled(false);
        addADEVSmenu.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                addADEVSmenuActionPerformed(evt);
            }
        });
        jMenu2.add(addADEVSmenu);

        addCDEVSmenu.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_C, java.awt.event.InputEvent.ALT_MASK));
        addCDEVSmenu.setText("Add Coupled DEVS");
        addCDEVSmenu.setBorder(null);
        addCDEVSmenu.setEnabled(false);
        addCDEVSmenu.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                addCDEVSmenuActionPerformed(evt);
            }
        });
        jMenu2.add(addCDEVSmenu);

        addMessageMenu.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_M, java.awt.event.InputEvent.ALT_MASK));
        addMessageMenu.setText("Add Message");
        addMessageMenu.setBorder(null);
        addMessageMenu.setEnabled(false);
        addMessageMenu.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                addMessageMenuActionPerformed(evt);
            }
        });
        jMenu2.add(addMessageMenu);

        fileMenu.add(jMenu2);

        jMenu3.setText("Add New");

        addNewADEVSmenu.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_A, java.awt.event.InputEvent.ALT_MASK | java.awt.event.InputEvent.SHIFT_MASK));
        addNewADEVSmenu.setText("New Atomic DEVS");
        addNewADEVSmenu.setEnabled(false);
        addNewADEVSmenu.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                addNewADEVSmenuActionPerformed(evt);
            }
        });
        jMenu3.add(addNewADEVSmenu);

        addNewCDEVSmenu.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_C, java.awt.event.InputEvent.ALT_MASK | java.awt.event.InputEvent.SHIFT_MASK));
        addNewCDEVSmenu.setText("New Coupled DEVS");
        addNewCDEVSmenu.setEnabled(false);
        addNewCDEVSmenu.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                addNewCDEVSmenuActionPerformed(evt);
            }
        });
        jMenu3.add(addNewCDEVSmenu);

        addNewMessageMenu.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_M, java.awt.event.InputEvent.ALT_MASK | java.awt.event.InputEvent.SHIFT_MASK));
        addNewMessageMenu.setText("New Message");
        addNewMessageMenu.setEnabled(false);
        addNewMessageMenu.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                addNewMessageMenuActionPerformed(evt);
            }
        });
        jMenu3.add(addNewMessageMenu);

        fileMenu.add(jMenu3);
        fileMenu.add(jSeparator3);

        saveMenu.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_S, java.awt.event.InputEvent.CTRL_MASK));
        saveMenu.setText("Save All");
        saveMenu.setToolTipText("");
        saveMenu.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                saveMenuActionPerformed(evt);
            }
        });
        fileMenu.add(saveMenu);

        menuBar.add(fileMenu);

        editMenu.setText("Edit");

        clearConsole.setText("Clear console");
        clearConsole.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                clearConsoleActionPerformed(evt);
            }
        });
        editMenu.add(clearConsole);

        menuBar.add(editMenu);

        Compile.setText("Compile");

        compileMenuItem.setText("Compile to PyPDEVS");
        compileMenuItem.setEnabled(false);
        compileMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                compileMenuItemActionPerformed(evt);
            }
        });
        Compile.add(compileMenuItem);

        menuBar.add(Compile);

        jMenu1.setText("Simulate");

        simulateMenuItem.setText("Run Simulation");
        simulateMenuItem.setEnabled(false);
        simulateMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                simulateMenuItemActionPerformed(evt);
            }
        });
        jMenu1.add(simulateMenuItem);

        menuBar.add(jMenu1);

        jMenu4.setText("Library");

        jMenuItem2.setText("Add from local");
        jMenuItem2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem2ActionPerformed(evt);
            }
        });
        jMenu4.add(jMenuItem2);

        menuBar.add(jMenu4);

        setJMenuBar(menuBar);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(treeScrollPane, javax.swing.GroupLayout.DEFAULT_SIZE, 190, Short.MAX_VALUE)
                    .addComponent(showLibCheckbox, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 1074, Short.MAX_VALUE)
                        .addContainerGap())
                    .addComponent(editorPane, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(treeScrollPane, javax.swing.GroupLayout.PREFERRED_SIZE, 802, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(showLibCheckbox))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(editorPane, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(18, 18, 18)
                        .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 120, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void loadProjectMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_loadProjectMenuItemActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_loadProjectMenuItemActionPerformed

    private void clearConsoleActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_clearConsoleActionPerformed
        Log.clear();
    }//GEN-LAST:event_clearConsoleActionPerformed

    private void compileMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_compileMenuItemActionPerformed
        PyPDEVSCreator creator;
        creator = new  PyPDEVSCreator(stateKeeper.getProject().getSettings().getCompilationLocation());
        creator.create(stateKeeper.getProject().getSettings().getAllFiles());
        Log.message("Compilation complete. PyPDEVS in file \"" + stateKeeper.getProject().getSettings().getCompilationLocation() + "\".");
    }//GEN-LAST:event_compileMenuItemActionPerformed

    private void simulateMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_simulateMenuItemActionPerformed
        String s = null;
        try {
            
            
            JDialog.setDefaultLookAndFeelDecorated(true);
            
            ArrayList<String> a = new ArrayList();
            for (Object o : stateKeeper.getProject().getSettings().getComponentsObjects()){
                if (o instanceof CoupledDEVS){
                    a.add(((CoupledDEVS) o).getName());
                }
            }
            
            //Object[] selectionValues = String[a.size()];
            
            JTextField time = new JTextField(25);
            time.setText("10.0");
            
            JPanel myPanel = new JPanel();
            myPanel.setLayout(new BorderLayout());
            myPanel.add(new JLabel("Set end time:"), BorderLayout.PAGE_START);
            myPanel.add(time, BorderLayout.LINE_START);
            myPanel.add(new JLabel("Select starting DEVS:"), BorderLayout.PAGE_END);
            
            
            String initialSelection = "Root";
            Object selection = JOptionPane.showInputDialog(null, myPanel,
                "Simulation Settings", JOptionPane.QUESTION_MESSAGE, null, a.toArray(), initialSelection);
            
            double timevalue = 10.0;
            try {
                timevalue = Double.parseDouble(time.getText());
            }
            catch(NumberFormatException e) {
                Log.warning("Please enter valid number.");
                return;
            }
            
            if (selection == null){
                return;
            }
            
            
            HashMap<String, JTextField> params = new HashMap();
            ArrayList<JLabel> paramsLabels = new ArrayList();
            JPanel paramPanel = new JPanel();
            paramPanel.setLayout(new BoxLayout(paramPanel, BoxLayout.Y_AXIS));
            
            ArrayList<CoupledDEVS> cdevs = stateKeeper.getProject().getSettings().getCdevs();
            ArrayList<String> paramsStrings = new ArrayList();
            for (CoupledDEVS cd : cdevs){
                if (cd.getName().equals(selection)){
                    paramsStrings = cd.getParameters();
                    break;
                }   
            }
            
            for (String st : paramsStrings){
                JLabel label = new JLabel(st.substring(0, st.indexOf("=")).trim());
                JTextField adder = new JTextField(25);
                adder.setText(st.substring(st.indexOf("=")+2));
                params.put(st.substring(0, st.indexOf("=")).replace(" : ", "_").trim(), adder);
                
                paramPanel.add(label);
                paramPanel.add(adder);
            }
            
            JOptionPane.showMessageDialog(null, paramPanel, "Simulation Options", JOptionPane.PLAIN_MESSAGE);
            
            String outputLoc = stateKeeper.getProject().getSettings().getSimulationSettings();
            
            Scanner scanner = new Scanner(new File(outputLoc));
            ArrayList<String> list = new ArrayList<>();
            while (scanner.hasNextLine()){
                list.add(scanner.nextLine());
            }
            scanner.close();
            
            String compLoc = stateKeeper.getProject().getSettings().getCompilationLocation().replace("\\", "/");
            
            //list.add(1, "import sys\nsys.path.append('" + compLoc.substring(0, compLoc.lastIndexOf('/')) + "')\nfrom " + compLoc.substring(compLoc.lastIndexOf("/")+1, compLoc.lastIndexOf(".")) + " import " + selection );
            list.add(1, "import sys\nsys.path.append('" + compLoc.substring(0, compLoc.lastIndexOf('/')) + "')\nfrom " + compLoc.substring(compLoc.lastIndexOf("/")+1, compLoc.lastIndexOf(".")) + " import *");
            list.remove(2);
            list.remove(2);
            list.remove(2);
            
            list.add(5, "\treturn time >= " + timevalue);
            list.remove(6);
            
            String newAdder = "";
            Iterator it = params.entrySet().iterator();
            while (it.hasNext()) {
                Map.Entry pair = (Map.Entry)it.next();
                //newAdder += "\"" + pair.getKey() + "\" : " + ((JTextField) pair.getValue()).getText() + ", ";
                newAdder += pair.getKey() + " = " + ((JTextField) pair.getValue()).getText() + ", ";
                it.remove(); // avoids a ConcurrentModificationException
            }
            if (newAdder.length() > 0)
                newAdder = newAdder.substring(0, newAdder.length()-2);
            
            
            //list.add(6, "sim = Simulator(" + selection + "(parameters = {\"name\" : \"Root\", " + newAdder + "}))");
            list.add(6, "sim = Simulator(" + selection + "(name = \"Root\", " + newAdder + "))");
            list.remove(7);
            
            PrintWriter writer = new PrintWriter(outputLoc, "UTF-8");  
            for (String t : list)
                writer.write(t + "\n");

            writer.close();
            
            if (selection != null){

                editorPane.setLayout(new BorderLayout());
                editorPane.removeAll();

                JTextComponent jTextArea = new JTextArea(5, 100);
                editorPane.add(new JScrollPane(jTextArea));
                MessageConsole mc = new MessageConsole(jTextArea);
                mc.redirectOut(null, System.out);
                editorPane.validate();
                editorPane.repaint();
                
                
                Process p;
                if (System.getProperty("os.name").startsWith("Windows")) {
                    p = Runtime.getRuntime().exec("python \"" + stateKeeper.getProject().getSettings().getSimulationSettings() + "\"");
                } else {
                    System.out.println(stateKeeper.getProject().getSettings().getSimulationSettings().replace(" ", "\\ "));
                    p = Runtime.getRuntime().exec("python \"" + stateKeeper.getProject().getSettings().getSimulationSettings().replace(" ", "\\ ") + "\"");
                     
                }
                

                
                
                InputStream input = p.getInputStream();
                InputStream error = p.getErrorStream();

                new Thread(new Runnable() {
                    public void run() {
                        BufferedReader stdInput = null;
                        BufferedReader stdError = null;
                        try {
                            stdInput = new BufferedReader(new InputStreamReader(input));
                            stdError = new BufferedReader(new InputStreamReader(error));
                            String line = null;
                            while ((line = stdInput.readLine()) != null) {
                                System.out.println(line);
                            }
                            while ((line = stdError.readLine()) != null) {
                                System.err.println(line);
                            }
                        } catch (Exception e) {
                          // TODO
                        } finally {
                            if (stdInput != null) {
                                try {
                                    stdInput.close();
                                } catch (IOException e) {
                                  // ignore
                                }
                            }
                            if (stdError != null) {
                                try {
                                    stdError.close();
                                } catch (IOException e) {
                                  // ignore
                                }
                            }
                        }
                    }
                  }).start();
            }
        } catch (IOException ex) {
            Logger.getLogger(MainFrame.class.getName()).log(Level.SEVERE, null, ex);
        }
    }//GEN-LAST:event_simulateMenuItemActionPerformed

    private void newProjectMenuActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_newProjectMenuActionPerformed
        JFileChooser fc = new JFileChooser();
        fc.setAcceptAllFileFilterUsed(false);
        FileNameExtensionFilter filter = new FileNameExtensionFilter("DEVS Settings File", "devssettings");
        fc.setFileFilter(filter);
        //fc.setCurrentDirectory(new File("./files"));
        fc.setCurrentDirectory(new File("files"));
        
        int returnVal;
        returnVal = fc.showOpenDialog(null);

        if (returnVal == JFileChooser.APPROVE_OPTION) {
            String path = fc.getSelectedFile().getAbsolutePath();
            System.out.println("path: " + path);
            if (!path.contains(".devssettings")){
                path = path.concat(".devssettings");
            }
            NewProject np = new NewProject(this, path);
            np.setVisible(true);
        }
    }//GEN-LAST:event_newProjectMenuActionPerformed

    private void addCDEVSmenuActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_addCDEVSmenuActionPerformed
        addExistingFile("coupled");
    }//GEN-LAST:event_addCDEVSmenuActionPerformed

    private void addADEVSmenuActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_addADEVSmenuActionPerformed
        addExistingFile("atomic");
    }//GEN-LAST:event_addADEVSmenuActionPerformed

    private void addMessageMenuActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_addMessageMenuActionPerformed
        addExistingFile("message");
    }//GEN-LAST:event_addMessageMenuActionPerformed

    public void addExistingFile(String type){
        String extension = null;
        String fileType = null;
        
        if (type.equals("atomic")){
            extension = "adevs";
            fileType = "Atomic DEVS";
        } else if (type.equals("coupled")){
            extension = "cdevs";
            fileType = "Coupled DEVS";
        } else if (type.equals("message")){
            extension = "devsmessage";
            fileType = "Message";
        } else if (type.equals("library")){
            extension = "devslib";
        }
        
        JFileChooser fc = new JFileChooser();
        fc.setAcceptAllFileFilterUsed(false);
        FileNameExtensionFilter filter = new FileNameExtensionFilter(fileType, extension);
        fc.setFileFilter(filter);
        fc.setCurrentDirectory(new File(stateKeeper.getProject().getSettings().getLocation()));
        
        int returnVal;
        returnVal = fc.showOpenDialog(null);

        if (returnVal == JFileChooser.APPROVE_OPTION) {
            File file = fc.getSelectedFile();
            if (type.equals("library")){
                ArrayList<Component> result = LibraryGetter.getComponents(file);
                if (stateKeeper.getProject().getSettings().getLibraryLocation() != null){
                    if (!stateKeeper.getProject().getSettings().getLibraryLocation().contains(file.getAbsolutePath()))
                        stateKeeper.getProject().getSettings().getLibraryLocation().add(file.getAbsolutePath());
                } else {
                    stateKeeper.getProject().getSettings().setLibraryLocation(new ArrayList());
                    stateKeeper.getProject().getSettings().getLibraryLocation().add(file.getAbsolutePath());
                }
                for (Component c : result) {
                    for (AtomicDEVS a : stateKeeper.getProject().getSettings().getAdevs()){
                        if (a.getName().equals(c.getName())){
                            Log.error("A component with the same name is already in the project. Library component renamed.");
                            c.setName(c.getName() + "_LIB_" + UUID.randomUUID().toString());
                        }
                    }
                    for (CoupledDEVS a : stateKeeper.getProject().getSettings().getCdevs()){
                        if (a.getName().equals(c.getName())){
                            Log.error("A component with the same name is already in the project. Library component renamed.");
                            c.setName(c.getName() + "_LIB_" + UUID.randomUUID().toString());
                        }
                    }
                    for (Message a : stateKeeper.getProject().getSettings().getMessages()){
                        if (a.getName().equals(c.getName())){
                            Log.error("A component with the same name is already in the project. Library component renamed.");
                            c.setName(c.getName() + "_LIB_" + UUID.randomUUID().toString());
                        }
                    }

                    if (c instanceof AtomicDEVS){
                        stateKeeper.getProject().getSettings().addAtomic((AtomicDEVS) c, file.getAbsolutePath());
                    } else if (c instanceof CoupledDEVS){
                        stateKeeper.getProject().getSettings().addCoupled((CoupledDEVS) c, file.getAbsolutePath());
                    } else if (c instanceof Message){
                        stateKeeper.getProject().getSettings().addMessage((Message) c, file.getAbsolutePath());
                    }

                    updateTree();
                    
                    if (openedComponentList != null){
                        Iterator it = openedComponentList.entrySet().iterator();
                        while (it.hasNext()) {
                            Map.Entry pair = (Map.Entry)it.next();
                            if (pair.getValue() instanceof CoupledDEVSPanel){
                                ((CoupledDEVSPanel) pair.getValue()).updateComponents();
                            }
                            it.remove(); // avoids a ConcurrentModificationException
                        }
                    }
                }
                stateKeeper.getProject().getSettings().save();
            } else {
                addComponent(file, type);
            }
        }
    }
    
    private boolean addComponent(File file, String type){
        Component adder = null;
        if (type.equals("atomic")){
            adder = new  AtomicDEVS(file);
        } else if (type.equals("coupled")){
            adder = new  CoupledDEVS(file);
        } else if (type.equals("message")){
            adder = new  Message(file);
        }
        
        for (AtomicDEVS a : stateKeeper.getProject().getSettings().getAdevs()){
            if (a.getName().equals(adder.getName())){
                Log.error("A component with the same name is already in the project. Adding failed.");
                return false;
            }
        }
        for (CoupledDEVS a : stateKeeper.getProject().getSettings().getCdevs()){
            if (a.getName().equals(adder.getName())){
                Log.error("A component with the same name is already in the project. Adding failed.");
                return false;
            }
        }
        for (Message a : stateKeeper.getProject().getSettings().getMessages()){
            if (a.getName().equals(adder.getName())){
                Log.error("A component with the same name is already in the project. Adding failed.");
                return false;
            }
        }
        
        if (type.equals("atomic")){
            stateKeeper.getProject().getSettings().addAtomic((AtomicDEVS) adder, file.getAbsolutePath());
        } else if (type.equals("coupled")){
            stateKeeper.getProject().getSettings().addCoupled((CoupledDEVS) adder, file.getAbsolutePath());
        } else if (type.equals("message")){
            stateKeeper.getProject().getSettings().addMessage((Message) adder, file.getAbsolutePath());
        }
        
        updateTree();
        
        if (openedComponentList != null){
            Iterator it = openedComponentList.entrySet().iterator();
            while (it.hasNext()) {
                Map.Entry pair = (Map.Entry)it.next();
                if (pair.getValue() instanceof CoupledDEVSPanel){
                    ((CoupledDEVSPanel) pair.getValue()).updateComponents();
                }
                it.remove(); // avoids a ConcurrentModificationException
            }
        }
        
        return true;
    }
    
    private void saveMenuActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_saveMenuActionPerformed
        stateKeeper.getProject().getSettings().save();
        if (openedComponentList == null)
            return;
        Iterator it = openedComponentList.entrySet().iterator();
        while (it.hasNext()) {
            Map.Entry pair = (Map.Entry)it.next();
            if (pair.getValue() instanceof AtomicDEVSPanel)
                ((AtomicDEVSPanel) pair.getValue()).save();
            else if (pair.getValue() instanceof CoupledDEVSPanel)
                ((CoupledDEVSPanel) pair.getValue()).save();
            else if (pair.getValue() instanceof MessagePanel)
                ((MessagePanel) pair.getValue()).save();
            it.remove();
        }
    }//GEN-LAST:event_saveMenuActionPerformed

    private void addNewCDEVSmenuActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_addNewCDEVSmenuActionPerformed
        NewComponent nc = new NewComponent(this, stateKeeper.getProject().getSettings().getLocation(), "coupled");
        nc.setVisible(true);
    }//GEN-LAST:event_addNewCDEVSmenuActionPerformed

    private void addNewADEVSmenuActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_addNewADEVSmenuActionPerformed
        NewComponent nc = new NewComponent(this, stateKeeper.getProject().getSettings().getLocation(), "atomic");
        nc.setVisible(true);
    }//GEN-LAST:event_addNewADEVSmenuActionPerformed

    private void addNewMessageMenuActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_addNewMessageMenuActionPerformed
        NewComponent nc = new NewComponent(this, stateKeeper.getProject().getSettings().getLocation(), "message");
        nc.setVisible(true);
    }//GEN-LAST:event_addNewMessageMenuActionPerformed

    private void jMenuItem2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem2ActionPerformed
        addExistingFile("library");
    }//GEN-LAST:event_jMenuItem2ActionPerformed

    private void showLibCheckboxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_showLibCheckboxActionPerformed
        updateTree();
    }//GEN-LAST:event_showLibCheckboxActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    //javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(MainFrame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(MainFrame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(MainFrame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(MainFrame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new MainFrame().setVisible(true);
            }
        });
        
        
    }
    
    private StateKeeper stateKeeper;
    
    public StateKeeper getStateKeeper() {
        return stateKeeper;
    }
    
    public void projectUpdated(){
        updateTree();
        editorPane.removeAll();
        editorPane.validate();
        editorPane.repaint();
        openedComponentList = null;
        enableMenuButtons();
    }
    
    private void updateTree(){
        ((FileSelector) projectTree).update(stateKeeper.getProject(), this.showLibCheckbox.isSelected());
    }
    
    private void enableMenuButtons(){
        this.simulateMenuItem.setEnabled(true);
        this.compileMenuItem.setEnabled(true);
        this.addADEVSmenu.setEnabled(true);
        this.addCDEVSmenu.setEnabled(true);
        this.addMessageMenu.setEnabled(true);
        this.addNewADEVSmenu.setEnabled(true);
        this.addNewCDEVSmenu.setEnabled(true);
        this.addNewMessageMenu.setEnabled(true);
    }
    
    private HashMap<Component, AbstractComponentView> openedComponentList;
    
    public void itemSelected(Object o){
        if (openedComponentList == null){
            openedComponentList = new HashMap();
        }
        if (o instanceof Component){
            editorPane.setLayout(new BorderLayout());
            java.awt.Component newPanel = null;

            if (o instanceof Message){
                if (!openedComponentList.containsKey(o)){
                    openedComponentList.put((Component) o, new MessagePanel((Message) o));
                }
                newPanel = (MessagePanel) openedComponentList.get((Component) o);
            } else if (o instanceof CoupledDEVS){
                if (!openedComponentList.containsKey(o)){
                    openedComponentList.put((Component) o, new CoupledDEVSPanel((CoupledDEVS) o, stateKeeper.getProject().getSettings()));
                }
                newPanel = (CoupledDEVSPanel) openedComponentList.get((Component) o);
            } else if (o instanceof AtomicDEVS){
                if (!openedComponentList.containsKey(o)){
                    openedComponentList.put((Component) o, new AtomicDEVSPanel((AtomicDEVS) o, stateKeeper.getProject().getSettings()));
                }
                newPanel = (AtomicDEVSPanel) openedComponentList.get((Component) o);
            }

            editorPane.removeAll();
            editorPane.add(newPanel, BorderLayout.NORTH);
            editorPane.validate();
            editorPane.repaint();
        }
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JMenu Compile;
    private javax.swing.JMenuItem addADEVSmenu;
    private javax.swing.JMenuItem addCDEVSmenu;
    private javax.swing.JMenuItem addMessageMenu;
    private javax.swing.JMenuItem addNewADEVSmenu;
    private javax.swing.JMenuItem addNewCDEVSmenu;
    private javax.swing.JMenuItem addNewMessageMenu;
    private javax.swing.JMenuItem clearConsole;
    private javax.swing.JMenuItem compileMenuItem;
    private javax.swing.JTextPane consoleView;
    private javax.swing.JMenu editMenu;
    private javax.swing.JPanel editorPane;
    private javax.swing.JMenu fileMenu;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JMenu jMenu1;
    private javax.swing.JMenu jMenu2;
    private javax.swing.JMenu jMenu3;
    private javax.swing.JMenu jMenu4;
    private javax.swing.JMenuItem jMenuItem2;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JPopupMenu.Separator jSeparator2;
    private javax.swing.JPopupMenu.Separator jSeparator3;
    private javax.swing.JMenuItem loadProjectMenuItem;
    private javax.swing.JMenuBar menuBar;
    private javax.swing.JMenuItem newProjectMenu;
    private javax.swing.JTree projectTree;
    private javax.swing.JMenuItem saveMenu;
    private javax.swing.JCheckBox showLibCheckbox;
    private javax.swing.JMenuItem simulateMenuItem;
    private javax.swing.JScrollPane treeScrollPane;
    // End of variables declaration//GEN-END:variables
}
