/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package mdeckers.thesis.uantwerp.library;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.URL;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.zip.ZipEntry;
import java.util.zip.ZipInputStream;
import mdeckers.thesis.uantwerp.model.AtomicDEVS;
import mdeckers.thesis.uantwerp.model.Component;
import mdeckers.thesis.uantwerp.model.CoupledDEVS;
import mdeckers.thesis.uantwerp.model.Message;
import mdeckers.thesis.uantwerp.model.Settings;

/**
 *
 * @author Michael
 */
public class LibraryGetter {
    public static void main(String[] args) throws Exception {

        URL oracle = new URL("file:///C:/Users/Michael/Google%20Drive/School_15-16/MasterThesis/Programming/PyPDEVS_Compiler/files/Root.cdevs");
        BufferedReader in = new BufferedReader(
        new InputStreamReader(oracle.openStream()));

        String inputLine;
        while ((inputLine = in.readLine()) != null)
            System.out.println(inputLine);
        in.close();
    }

    public static ArrayList<Component> getComponents(File file) {
        ArrayList<Component> files = unZip(file);
        
        return files;
    }
    
    public static ArrayList<String> getFileNames(File file){
        ArrayList<String> filenames = new ArrayList();
        ZipInputStream zis = null;
        try {
            zis = new ZipInputStream(new FileInputStream(file));
            ZipEntry ze = zis.getNextEntry();
            while (ze != null){
                String filename = ze.getName();
                String path = file.getAbsolutePath();
                filenames.add(path.substring(0, path.lastIndexOf("\\")) + "\\" + filename);
                ze = zis.getNextEntry();
            }
        } catch (FileNotFoundException ex) {} catch (IOException ex) {} 
        finally {
            try {
                zis.close();
            } catch (IOException ex) {}
        }
        return filenames;
    }

    private static ArrayList<Component> unZip(File file) {
        ZipInputStream zis = null;
        ArrayList<Component> result = new ArrayList();
        HashMap<String, Component> map = new HashMap();
        try {
            zis = new ZipInputStream(new FileInputStream(file));
            String root = "";
            
            ZipEntry ze = zis.getNextEntry();
            while (ze != null){
                String filename = ze.getName();
                ArrayList<String> lines = Settings.readFromZipInputStream(zis);
                
                if (filename.contains(".adevs")){
                    AtomicDEVS adder = new AtomicDEVS(lines);
                    map.put(filename, adder);
                    result.add(adder);
                    result.get(result.size()-1).setLibrary(2);
                } else if (filename.contains(".cdevs")){
                    CoupledDEVS adder = new CoupledDEVS(lines);
                    map.put(filename, adder);
                    result.add(adder);
                    result.get(result.size()-1).setLibrary(2);
                } else if (filename.contains(".devsmessage")){
                    Message adder = new Message(lines);
                    map.put(filename, adder);
                    result.add(adder);
                    result.get(result.size()-1).setLibrary(2);
                } else if (filename.contains(".libinfo")) {
                    for (String s : lines){
                        if (s.contains("[root = ")){
                            root = s.substring(7).trim();
                            root = root.substring(0, root.length()-1);
                        }
                    }
                }
                ze = zis.getNextEntry();
            }
            if (map.get(root) != null){
                map.get(root).setLibrary(1);
                
            }
            
            
        } catch (FileNotFoundException ex) {} catch (IOException ex) {} 
        finally {
            try {
                zis.close();
            } catch (IOException ex) {}
        }
        return result;
    }
    
    
}
