/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package mdeckers.thesis.uantwerp.model;

import java.io.File;
import java.util.ArrayList;
import mdeckers.thesis.uantwerp.model.persistence.AtomicDEVSPersistence;

/**
 *
 * @author Michael
 */
public class AtomicDEVS extends DEVS{
    
    private ArrayList<String> parameters;
    private ArrayList<String> ports;
    private ArrayList<String> states;
    private ArrayList<ArrayList<String>> TAs;
    private ArrayList<ArrayList<String>> OFs;
    private ArrayList<ArrayList<String>> ITs;
    private ArrayList<ArrayList<String>> ETs;
    
    
    private boolean isRoot;
    /**
     * type:
     * 1 = components
     * 2 = ports
     * 3 = connections
     */
    private int type;
    private int ta_number;
    private int of_number;
    private int it_number;
    private int et_number;
    private AtomicDEVSPersistence persistence;
    
    
    public AtomicDEVS(File file){
        this.name = "new AtomicDEVS";
        parameters = new ArrayList();
        ports = new ArrayList();
        states = new ArrayList();
        TAs = new ArrayList();
        OFs = new ArrayList();
        ITs = new ArrayList();
        ETs = new ArrayList();
        
        this.persistence = new AtomicDEVSPersistence(file, this);
        
        readFile(file);
    }
    
    public AtomicDEVS(ArrayList<String> lines){
        this.name = "new AtomicDEVS";
        parameters = new ArrayList();
        ports = new ArrayList();
        states = new ArrayList();
        TAs = new ArrayList();
        OFs = new ArrayList();
        ITs = new ArrayList();
        ETs = new ArrayList();
        
        //this.persistence = new AtomicDEVSPersistence(file, this);
        
        readFile(lines);
    }
    
    public AtomicDEVS(String location){
        this.name = "new AtomicDEVS";
        parameters = new ArrayList();
        ports = new ArrayList();
        states = new ArrayList();
        TAs = new ArrayList();
        OFs = new ArrayList();
        ITs = new ArrayList();
        ETs = new ArrayList();
        
        this.persistence = new AtomicDEVSPersistence(new File(location), this);
    }
    
    public void setRoot(boolean root){
        this.isRoot = root;
    }
    
    private void readFile(File file) {
        type = 0;
        of_number = 0;
        ta_number = 0;
        it_number = 0;
        et_number = 0;
        parameters.clear();
        ports.clear();
        states.clear();
        TAs.clear();
        OFs.clear();
        ITs.clear();
        ETs.clear();
        
        readingCondition = false;
        readingAction = false;
        
        ArrayList<String> lines = Project.readFromFile(file);
        if (lines == null)
            return;
        
        for (int i = 0; i < lines.size(); i++){
            treatLine(lines.get(i));
        }
    }
    
    private void readFile(ArrayList<String> lines) {
        type = 0;
        of_number = 0;
        ta_number = 0;
        it_number = 0;
        et_number = 0;
        parameters.clear();
        ports.clear();
        states.clear();
        TAs.clear();
        OFs.clear();
        ITs.clear();
        ETs.clear();
        
        readingCondition = false;
        readingAction = false;
        
        if (lines == null)
            return;
        
        for (int i = 0; i < lines.size(); i++){
            treatLine(lines.get(i));
        }
    }
    
    private void treatLine(String line){
        if (line.contains("[name")){
            this.name = line.substring(line.indexOf("=")+1, line.lastIndexOf("]")).trim();
        } else if (line.contains("[state parameters]")){
            type = 1;
        } else if (line.contains("[ports]")){
            type = 2;
        } else if (line.contains("[states]")){
            type = 3;
        } else if (line.contains("[time advance]")){
            type = 4;
        } else if (line.contains("[output function]")){
            type = 5;
        } else if (line.contains("[internal transition]")){
            type = 6;
        } else if (line.contains("[external transition")){
            type = 7;
        } else {
            switch (type) {
                case 1:
                    handleStateParameters(line);
                    break;
                case 2:
                    handlePort(line);
                    break;
                case 3:
                    handleStates(line);
                    break;
                case 4:
                    handleTA(line);
                    break;
                case 5:
                    handleOF(line);
                    break;
                case 6: 
                    handleIT(line);
                    break;
                case 7:
                    handleET(line);
                    break;
                default:
                    break;
            }
        }
        
    }

    private void handleStateParameters(String line) {
        if (line.trim().length() == 0){
            return;
        }
        parameters.add(line.trim());
    }

    private void handlePort(String line) {
        if (line.trim().length() == 0){
            return;
        }
        ports.add(line.trim());
    }

    private void handleStates(String line) {
        if (line.trim().length() == 0){
            return;
        }
        states.add(line.trim());
    }

    int lowestnumbertabs;
    int numberaccolades;
    
    private int count(String line, String needle){
        return line.length() - line.replace(needle, "").length();
    }
    
    private void handleTA(String line) {
        if (line.trim().length() == 0)
            return;
        
        if (ta_number == 0) {
            String state = line.substring(0, line.indexOf(":")).trim();
            if (state != null){
                lowestnumbertabs = Integer.MAX_VALUE;
                ta_number = 1;
                TAs.add(new ArrayList());
                TAs.get(TAs.size()-1).add(state);
                numberaccolades = count(line, "{");
                numberaccolades -= count(line, "}");
                if (line.trim().indexOf("{") == line.trim().length()-1){
                    return;
                }
                if (line.substring(line.indexOf("{")+1).contains("\t"))
                    lowestnumbertabs = count(line, "\t");
                else
                    lowestnumbertabs = 0;
                String adder = "";
                for (int i = 0; i < lowestnumbertabs; i++)
                    adder += "\t";
                adder += line.substring(line.indexOf("{")+1).trim();
                
                if (numberaccolades == 0){
                    String adderRE = new StringBuilder(adder).reverse().toString();
                    adderRE = adderRE.replaceFirst("}", "");
                    adder = new StringBuilder(adderRE).reverse().toString();
                }
                TAs.get(TAs.size()-1).add(adder);
                
                if (numberaccolades == 0)
                    ta_number = 0;
            }
        } else {
            numberaccolades += count(line, "{");
            numberaccolades -= count(line, "}");
            if (lowestnumbertabs == Integer.MAX_VALUE){
                lowestnumbertabs = count(line, "\t");
            }

            if (line.trim().length() != 0){
                if (numberaccolades != 0){
                    int tabcount = count(line, "\t") - lowestnumbertabs;
                    String adder = "";
                    for (int i = 0; i < tabcount; i++)
                        adder += "\t";
                    adder += line.trim();
                    TAs.get(TAs.size()-1).add(adder);
                } else {
                    ta_number = 0;
                    int tabcount = count(line, "\t") - lowestnumbertabs;
                    String adder = "";
                    for (int i = 0; i < tabcount; i++)
                        adder += "\t";
                    adder += line.substring(0, line.lastIndexOf("}")).trim();
                    TAs.get(TAs.size()-1).add(adder);
                }
            }
        }
    }

    private void handleOF(String line) {
        if (line.trim().length() == 0)
            return;
        
        if (of_number == 0) {
            String state = line.substring(0, line.indexOf(":")).trim();
            if (state != null){
                lowestnumbertabs = Integer.MAX_VALUE;
                of_number = 1;
                OFs.add(new ArrayList());
                OFs.get(OFs.size()-1).add(state);
                numberaccolades = count(line, "{");
                numberaccolades -= count(line, "}");
                if (line.trim().indexOf("{") == line.trim().length()-1){
                    return;
                }
                if (line.substring(line.indexOf("{")+1).contains("\t"))
                    lowestnumbertabs = count(line, "\t");
                else
                    lowestnumbertabs = 0;
                String adder = "";
                for (int i = 0; i < lowestnumbertabs; i++)
                    adder += "\t";
                adder += line.substring(line.indexOf("{")+1).trim();
                
                if (numberaccolades == 0){
                    String adderRE = new StringBuilder(adder).reverse().toString();
                    adderRE = adderRE.replaceFirst("}", "");
                    adder = new StringBuilder(adderRE).reverse().toString();
                }
                
                OFs.get(OFs.size()-1).add(adder);
                
                if (numberaccolades == 0)
                    of_number = 0;
            }
        } else {
            numberaccolades += count(line, "{");
            numberaccolades -= count(line, "}");
            if (lowestnumbertabs == Integer.MAX_VALUE){
                lowestnumbertabs = count(line, "\t");
            }
            if (line.trim().length() != 0){
                if (numberaccolades != 0){
                    int tabcount = count(line, "\t") - lowestnumbertabs;
                    String adder = "";
                    for (int i = 0; i < tabcount; i++)
                        adder += "\t";
                    adder += line.trim();
                    OFs.get(OFs.size()-1).add(adder);
                } else {
                    of_number = 0;
                    int tabcount = count(line, "\t") - lowestnumbertabs;
                    String adder = "";
                    for (int i = 0; i < tabcount; i++)
                        adder += "\t";
                    adder += line.substring(0, line.lastIndexOf("}")).trim();
                    OFs.get(OFs.size()-1).add(adder);
                }
            }
        }
        
    }
    
    private boolean readingCondition;
    private boolean readingAction;
    
    private void handleIT(String line) {
        if (line.trim().length() == 0){
            return;
        }
        
        if (!readingCondition && !readingAction){
            if (line.contains("from_state") || line.contains("to_state")){
                if (line.contains("from_state")){
                    ITs.add(new ArrayList());
                    ITs.get(ITs.size()-1).add(line);
                } else {
                    ITs.add(new ArrayList());
                    ITs.get(ITs.size()-1).add(line);
                }
            } else if (line.contains("condition")) {
                ITs.add(new ArrayList());
                ITs.get(ITs.size()-1).add("condition");
                readingCondition = true;
                lowestnumbertabs = Integer.MAX_VALUE;
                numberaccolades = count(line, "{");
                numberaccolades -= count(line, "}");
                if (line.trim().indexOf("{") == line.trim().length()-1){
                    return;
                }
                if (line.substring(line.indexOf("{")+1).contains("\t"))
                    lowestnumbertabs = count(line, "\t");
                else
                    lowestnumbertabs = 0;
                String adder = "";
                for (int i = 0; i < lowestnumbertabs; i++)
                    adder += "\t";
                adder += line.substring(line.indexOf("{")+1).trim();
                
                if (numberaccolades == 0){
                    String adderRE = new StringBuilder(adder).reverse().toString();
                    adderRE = adderRE.replaceFirst("}", "");
                    adder = new StringBuilder(adderRE).reverse().toString();
                }
                
                for (int i = ITs.size()-1; i >= 0; i--) {
                    if (ITs.get(i).get(0).equals("condition")) {
                        ITs.get(i).add(adder);
                        break;
                    }
                }

                if (numberaccolades == 0)
                    readingCondition = false;

            } else if (line.contains("action")) {
                readingAction = true;
                ITs.add(new ArrayList());
                ITs.get(ITs.size()-1).add("action");
                lowestnumbertabs = Integer.MAX_VALUE;
                numberaccolades = count(line, "{");
                numberaccolades -= count(line, "}");
                if (line.trim().indexOf("{") == line.trim().length()-1){
                    return;
                }
                if (line.substring(line.indexOf("{")+1).contains("\t"))
                    lowestnumbertabs = count(line, "\t");
                else
                    lowestnumbertabs = 0;
                String adder = "";
                for (int i = 0; i < lowestnumbertabs; i++)
                    adder += "\t";
                adder += line.substring(line.indexOf("{")+1).trim();
                
                for (int i = ITs.size()-1; i >= 0; i--) {
                    if (ITs.get(i).get(0).equals("action")) {
                        ITs.get(i).add(adder);
                        break;
                    }
                }

                if (numberaccolades == 0)
                    readingAction = false;
            }
        } else if (readingCondition) {
            
            numberaccolades += count(line, "{");
            numberaccolades -= count(line, "}");
            if (numberaccolades == 0)
                readingCondition = false;
            if (lowestnumbertabs == Integer.MAX_VALUE){
                lowestnumbertabs = count(line, "\t");
            }
            if (line.trim().length() != 0){
                if (numberaccolades != 0){
                    int tabcount = count(line, "\t") - lowestnumbertabs;
                    String adder = "";
                    for (int i = 0; i < tabcount; i++)
                        adder += "\t";
                    adder += line.trim();
                    for (int i = ITs.size()-1; i >= 0; i--) {
                        if (ITs.get(i).get(0).equals("condition")) {
                            ITs.get(i).add(adder);
                            break;
                        }
                    }
                } else {
                    readingCondition = false;
                    int tabcount = count(line, "\t") - lowestnumbertabs;
                    String adder = "";
                    for (int i = 0; i < tabcount; i++)
                        adder += "\t";
                    adder += line.substring(0, line.lastIndexOf("}")).trim();
                    for (int i = ITs.size()-1; i >= 0; i--) {
                        if (ITs.get(i).get(0).equals("condition")) {
                            ITs.get(i).add(adder);
                            break;
                        }
                    }
                }
            }
            
        } else if (readingAction) {
            
            numberaccolades += count(line, "{");
            numberaccolades -= count(line, "}");
            
            if (numberaccolades == 0)
                readingAction = false;
            
            if (lowestnumbertabs == Integer.MAX_VALUE){
                lowestnumbertabs = count(line, "\t");
            }
            if (line.trim().length() != 0){
                if (numberaccolades != 0){
                    int tabcount = count(line, "\t") - lowestnumbertabs;
                    String adder = "";
                    for (int i = 0; i < tabcount; i++)
                        adder += "\t";
                    adder += line.trim();
                    for (int i = ITs.size()-1; i >= 0; i--) {
                        if (ITs.get(i).get(0).equals("action")) {
                            ITs.get(i).add(adder);
                            break;
                        }
                    }
                } else {
                    readingAction = false;
                    int tabcount = count(line, "\t") - lowestnumbertabs;
                    String adder = "";
                    for (int i = 0; i < tabcount; i++)
                        adder += "\t";
                    adder += line.substring(0, line.lastIndexOf("}")).trim();
                    for (int i = ITs.size()-1; i >= 0; i--) {
                        if (ITs.get(i).get(0).equals("action")) {
                            ITs.get(i).add(adder);
                            break;
                        }
                    }
                }
            }
            
        }
    }

    private void handleIT2(String line) {
        if (line.trim().length() == 0){
            return;
        }
        
        if (!readingCondition && !readingAction){
            if (line.contains("from_state") || line.contains("to_state")){
                if (line.contains("from_state")){
                    ITs.add(new ArrayList());
                    ITs.get(ITs.size()-1).add(line);
                } else {
                    ITs.add(new ArrayList());
                    ITs.get(ITs.size()-1).add(line);
                }
            } else if (line.contains("condition")) {
                ITs.add(new ArrayList());
                ITs.get(ITs.size()-1).add("condition");
                readingCondition = true;
                lowestnumbertabs = Integer.MAX_VALUE;
                numberaccolades = count(line, "{");
                numberaccolades -= count(line, "}");
                if (line.trim().indexOf("{") == line.trim().length()-1){
                    return;
                }
                if (line.substring(line.indexOf("{")+1).contains("\t"))
                    lowestnumbertabs = count(line, "\t");
                else
                    lowestnumbertabs = 0;
                String adder = "";
                for (int i = 0; i < lowestnumbertabs; i++)
                    adder += "\t";
                adder += line.substring(line.indexOf("{")+1).trim();
                
                if (numberaccolades == 0){
                    String adderRE = new StringBuilder(adder).reverse().toString();
                    adderRE = adderRE.replaceFirst("}", "");
                    adder = new StringBuilder(adderRE).reverse().toString();
                }
                
                for (ArrayList<String> ar : ITs)
                    if (ar.get(0).equals("condition"))
                        ar.add(adder);

                if (numberaccolades == 0)
                    readingCondition = false;

            } else if (line.contains("action")) {
                readingAction = true;
                ITs.add(new ArrayList());
                ITs.get(ITs.size()-1).add("action");
                lowestnumbertabs = Integer.MAX_VALUE;
                numberaccolades = count(line, "{");
                numberaccolades -= count(line, "}");
                if (line.trim().indexOf("{") == line.trim().length()-1){
                    return;
                }
                if (line.substring(line.indexOf("{")+1).contains("\t"))
                    lowestnumbertabs = count(line, "\t");
                else
                    lowestnumbertabs = 0;
                String adder = "";
                for (int i = 0; i < lowestnumbertabs; i++)
                    adder += "\t";
                adder += line.substring(line.indexOf("{")+1).trim();
                
                for (ArrayList<String> ar : ITs)
                    if (ar.get(0).equals("action"))
                        ar.add(adder);

                if (numberaccolades == 0)
                    readingAction = false;
            }
        } else if (readingCondition) {
            
            numberaccolades += count(line, "{");
            numberaccolades -= count(line, "}");
            if (numberaccolades == 0)
                readingCondition = false;
            if (lowestnumbertabs == Integer.MAX_VALUE){
                lowestnumbertabs = count(line, "\t");
            }
            if (line.trim().length() != 0){
                if (numberaccolades != 0){
                    int tabcount = count(line, "\t") - lowestnumbertabs;
                    String adder = "";
                    for (int i = 0; i < tabcount; i++)
                        adder += "\t";
                    adder += line.trim();
                    for (ArrayList<String> ar : ITs)
                        if (ar.get(0).equals("condition"))
                            ar.add(adder);
                } else {
                    readingCondition = false;
                    int tabcount = count(line, "\t") - lowestnumbertabs;
                    String adder = "";
                    for (int i = 0; i < tabcount; i++)
                        adder += "\t";
                    adder += line.substring(0, line.lastIndexOf("}")).trim();
                    for (ArrayList<String> ar : ITs)
                        if (ar.get(0).equals("condition"))
                            ar.add(adder);
                }
            }
            
        } else if (readingAction) {
            
            numberaccolades += count(line, "{");
            numberaccolades -= count(line, "}");
            
            if (numberaccolades == 0)
                readingAction = false;
            
            if (lowestnumbertabs == Integer.MAX_VALUE){
                lowestnumbertabs = count(line, "\t");
            }
            if (line.trim().length() != 0){
                if (numberaccolades != 0){
                    int tabcount = count(line, "\t") - lowestnumbertabs;
                    String adder = "";
                    for (int i = 0; i < tabcount; i++)
                        adder += "\t";
                    adder += line.trim();
                    for (ArrayList<String> ar : ITs)
                        if (ar.get(0).equals("action"))
                            ar.add(adder);
                } else {
                    readingAction = false;
                    int tabcount = count(line, "\t") - lowestnumbertabs;
                    String adder = "";
                    for (int i = 0; i < tabcount; i++)
                        adder += "\t";
                    adder += line.substring(0, line.lastIndexOf("}")).trim();
                    for (ArrayList<String> ar : ITs)
                        if (ar.get(0).equals("action"))
                            ar.add(adder);
                }
            }
            
        }
    }

    private void handleET(String line) {
        if (line.trim().length() == 0){
            return;
        }
        
        if (!readingCondition && !readingAction){
            if (line.contains("from_state") || line.contains("to_state")){
                if (line.contains("from_state")){
                    ETs.add(new ArrayList());
                    ETs.get(ETs.size()-1).add(line);
                } else {
                    ETs.add(new ArrayList());
                    ETs.get(ETs.size()-1).add(line);
                }
            } else if (line.contains("condition")) {
                ETs.add(new ArrayList());
                ETs.get(ETs.size()-1).add("condition");
                readingCondition = true;
                lowestnumbertabs = Integer.MAX_VALUE;
                numberaccolades = count(line, "{");
                numberaccolades -= count(line, "}");
                if (line.trim().indexOf("{") == line.trim().length()-1){
                    return;
                }
                if (line.substring(line.indexOf("{")+1).contains("\t"))
                    lowestnumbertabs = count(line, "\t");
                else
                    lowestnumbertabs = 0;
                String adder = "";
                for (int i = 0; i < lowestnumbertabs; i++)
                    adder += "\t";
                adder += line.substring(line.indexOf("{")+1).trim();
                
                if (numberaccolades == 0){
                    String adderRE = new StringBuilder(adder).reverse().toString();
                    adderRE = adderRE.replaceFirst("}", "");
                    adder = new StringBuilder(adderRE).reverse().toString();
                }
                
                for (int i = ETs.size()-1; i >= 0; i--) {
                    if (ETs.get(i).get(0).equals("condition")) {
                        ETs.get(i).add(adder);
                        break;
                    }
                }

                if (numberaccolades == 0)
                    readingCondition = false;

            } else if (line.contains("action")) {
                readingAction = true;
                ETs.add(new ArrayList());
                ETs.get(ETs.size()-1).add("action");
                lowestnumbertabs = Integer.MAX_VALUE;
                numberaccolades = count(line, "{");
                numberaccolades -= count(line, "}");
                if (line.trim().indexOf("{") == line.trim().length()-1){
                    return;
                }
                if (line.substring(line.indexOf("{")+1).contains("\t"))
                    lowestnumbertabs = count(line, "\t");
                else
                    lowestnumbertabs = 0;
                String adder = "";
                for (int i = 0; i < lowestnumbertabs; i++)
                    adder += "\t";
                adder += line.substring(line.indexOf("{")+1).trim();
                
                for (int i = ETs.size()-1; i >= 0; i--) {
                    if (ETs.get(i).get(0).equals("action")) {
                        ETs.get(i).add(adder);
                        break;
                    }
                }

                if (numberaccolades == 0)
                    readingAction = false;
            }
        } else if (readingCondition) {
            
            numberaccolades += count(line, "{");
            numberaccolades -= count(line, "}");
            if (numberaccolades == 0)
                readingCondition = false;
            if (lowestnumbertabs == Integer.MAX_VALUE){
                lowestnumbertabs = count(line, "\t");
            }
            if (line.trim().length() != 0){
                if (numberaccolades != 0){
                    int tabcount = count(line, "\t") - lowestnumbertabs;
                    String adder = "";
                    for (int i = 0; i < tabcount; i++)
                        adder += "\t";
                    adder += line.trim();
                    for (int i = ETs.size()-1; i >= 0; i--) {
                        if (ETs.get(i).get(0).equals("condition")) {
                            ETs.get(i).add(adder);
                            break;
                        }
                    }
                } else {
                    readingCondition = false;
                    int tabcount = count(line, "\t") - lowestnumbertabs;
                    String adder = "";
                    for (int i = 0; i < tabcount; i++)
                        adder += "\t";
                    adder += line.substring(0, line.lastIndexOf("}")).trim();
                    for (int i = ETs.size()-1; i >= 0; i--) {
                        if (ETs.get(i).get(0).equals("condition")) {
                            ETs.get(i).add(adder);
                            break;
                        }
                    }
                }
            }
            
        } else if (readingAction) {
            
            numberaccolades += count(line, "{");
            numberaccolades -= count(line, "}");
            
            if (numberaccolades == 0)
                readingAction = false;
            
            if (lowestnumbertabs == Integer.MAX_VALUE){
                lowestnumbertabs = count(line, "\t");
            }
            if (line.trim().length() != 0){
                if (numberaccolades != 0){
                    int tabcount = count(line, "\t") - lowestnumbertabs;
                    String adder = "";
                    for (int i = 0; i < tabcount; i++)
                        adder += "\t";
                    adder += line.trim();
                    for (int i = ETs.size()-1; i >= 0; i--) {
                        if (ETs.get(i).get(0).equals("action")) {
                            ETs.get(i).add(adder);
                            break;
                        }
                    }
                } else {
                    readingAction = false;
                    int tabcount = count(line, "\t") - lowestnumbertabs;
                    String adder = "";
                    for (int i = 0; i < tabcount; i++)
                        adder += "\t";
                    adder += line.substring(0, line.lastIndexOf("}")).trim();
                    for (int i = ETs.size()-1; i >= 0; i--) {
                        if (ETs.get(i).get(0).equals("action")) {
                            ETs.get(i).add(adder);
                            break;
                        }
                    }
                }
            }
            
        }
    }

    public ArrayList<String> getParameters() {
        return parameters;
    }

    public void setParameters(ArrayList<String> parameters) {
        this.parameters = parameters;
    }

    public ArrayList<String> getPorts() {
        return ports;
    }

    public void setPorts(ArrayList<String> ports) {
        this.ports = ports;
    }

    public ArrayList<String> getStates() {
        return states;
    }

    public void setStates(ArrayList<String> states) {
        this.states = states;
    }

    public ArrayList<ArrayList<String>> getTAs() {
        return TAs;
    }

    public void setTAs(ArrayList<ArrayList<String>> TAs) {
        this.TAs = TAs;
    }

    public ArrayList<ArrayList<String>> getOFs() {
        return OFs;
    }

    public void setOFs(ArrayList<ArrayList<String>> OFs) {
        this.OFs = OFs;
    }

    public ArrayList<ArrayList<String>> getITs() {
        return ITs;
    }

    public void setITs(ArrayList<ArrayList<String>> ITs) {
        this.ITs = ITs;
    }

    public ArrayList<ArrayList<String>> getETs() {
        return ETs;
    }

    public void setETs(ArrayList<ArrayList<String>> ETs) {
        this.ETs = ETs;
    }

    public void save() {
        persistence.persist();
    }
    
    
}
