/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package mdeckers.thesis.uantwerp.model;

import java.io.File;
import java.util.ArrayList;
import mdeckers.thesis.uantwerp.model.persistence.CoupledDEVSPersistence;

/**
 *
 * @author Michael
 */
public class CoupledDEVS extends DEVS{
    
    private ArrayList<String> components;
    private ArrayList<String> ports;
    private ArrayList<String> connections;
    private ArrayList<String> priorities;
    private ArrayList<String> parameters;
    private ArrayList<ArrayList<String>> transferFunctions;
    
    private CoupledDEVSPersistence persistence;
    private int ta_number;

    public ArrayList<String> getPriorities() {
        return priorities;
    }

    public void setPriorities(ArrayList<String> priorities) {
        this.priorities = priorities;
    }

    public ArrayList<String> getParameters() {
        return parameters;
    }

    public void setParameters(ArrayList<String> parameters) {
        this.parameters = parameters;
    }

    public ArrayList<ArrayList<String>> getTransferFunctions() {
        return transferFunctions;
    }

    public void setTransferFunctions(ArrayList<ArrayList<String>> transferFunctions) {
        this.transferFunctions = transferFunctions;
    }

    public ArrayList<String> getComponents() {
        return components;
    }

    public void setComponents(ArrayList<String> components) {
        this.components = components;
    }

    public ArrayList<String> getPorts() {
        return ports;
    }

    public void setPorts(ArrayList<String> ports) {
        this.ports = ports;
    }

    public ArrayList<String> getConnections() {
        return connections;
    }

    public void setConnections(ArrayList<String> connections) {
        this.connections = connections;
    }

    public boolean isIsRoot() {
        return isRoot;
    }

    public void setIsRoot(boolean isRoot) {
        this.isRoot = isRoot;
    }
    
    private boolean isRoot;
    /**
     * type:
     * 1 = components
     * 2 = ports
     * 3 = connections
     */
    private int type;
    
    public void save() {
        persistence.persist();
    }
    
    
    public CoupledDEVS(File file){
        this.name = "new CoupledDEVS";
        components = new ArrayList();
        ports = new ArrayList();
        connections = new ArrayList();
        priorities = new ArrayList();
        parameters = new ArrayList();
        transferFunctions = new ArrayList();
        this.persistence = new CoupledDEVSPersistence(file, this);
        
        readFile(file);
    }
    
    public CoupledDEVS(ArrayList<String> lines){
        this.name = "new CoupledDEVS";
        components = new ArrayList();
        ports = new ArrayList();
        connections = new ArrayList();
        priorities = new ArrayList();
        parameters = new ArrayList();
        transferFunctions = new ArrayList();
        //this.persistence = new CoupledDEVSPersistence(file, this);
        
        readFile(lines);
    }
    
    public CoupledDEVS(String file){
        this.name = "new CoupledDEVS";
        components = new ArrayList();
        ports = new ArrayList();
        connections = new ArrayList();
        priorities = new ArrayList();
        parameters = new ArrayList();
        transferFunctions = new ArrayList();
        this.persistence = new CoupledDEVSPersistence(new File(file), this);
        
    }
    
    public void setRoot(boolean root){
        this.isRoot = root;
    }
    
    private void readFile(File file) {
        type = 0;
        components.clear();
        ports.clear();
        connections.clear();
        priorities.clear();
        parameters.clear();
        transferFunctions.clear();
        
        ArrayList<String> lines = Project.readFromFile(file);
        if (lines == null)
            return;
        
        for (int i = 0; i < lines.size(); i++){
            treatLine(lines.get(i));
        }
    }
    
    private void readFile(ArrayList<String> lines) {
        type = 0;
        components.clear();
        ports.clear();
        connections.clear();
        priorities.clear();
        parameters.clear();
        transferFunctions.clear();
        
        if (lines == null)
            return;
        
        for (int i = 0; i < lines.size(); i++){
            treatLine(lines.get(i));
        }
    }
    
    private void treatLine(String line) {
        if (line.contains("[name")){
            this.name = line.substring(line.indexOf("=")+1, line.lastIndexOf("]")).trim();
        } else if (line.contains("[components]")){
            type = 1;
        } else if (line.contains("[ports]")){
            type = 2;
        } else if (line.contains("[connections]")){
            type = 3;
        } else if (line.contains("[parameters]")){
            type = 4;
        } else if (line.contains("[priorities]")){
            type = 5;
        } else if (line.contains("transfer function {")){
            type = 6;
            handleTF(line);
        } else {
            switch (type) {
                case 1:
                    handleComponent(line);
                    break;
                case 2:
                    handlePort(line);
                    break;
                case 3:
                    handleConnection(line);
                    break;
                case 4:
                    handleParameter(line);
                    break;
                case 5:
                    handlePriority(line);
                    break;
                case 6: 
                    handleTF(line);
                    break;
                default:
                    break;
            }
        }
    }

    private void handleComponent(String line) {
        if (line.trim().length() == 0){
            return;
        }
        components.add(line.trim());
    }

    private void handlePort(String line) {
        if (line.trim().length() == 0){
            return;
        }
        ports.add(line.trim());
    }

    private void handleConnection(String line) {
        if (line.trim().length() == 0){
            return;
        }
        connections.add(line.trim());
    }

    private void handleParameter(String line) {
        if (line.trim().length() == 0){
            return;
        }
        parameters.add(line.trim());
    }

    private void handlePriority(String line) {
        if (line.trim().length() == 0){
            return;
        }
        priorities.add(line.trim());
    }

    int lowestnumbertabs;
    int numberaccolades;
    
    private int count(String line, String needle){
        return line.length() - line.replace(needle, "").length();
    }
    
    private void handleTF(String line) {
        if (line.trim().length() == 0)
            return;
        
        if (ta_number == 0) {
            lowestnumbertabs = Integer.MAX_VALUE;
            ta_number = 1;
            transferFunctions.add(new ArrayList());
            transferFunctions.get(transferFunctions.size()-1).add(connections.get(connections.size()-1));
            numberaccolades = count(line, "{");
            numberaccolades -= count(line, "}");
            if (line.trim().indexOf("{") == line.trim().length()-1){
                return;
            }
            if (line.substring(line.indexOf("{")+1).contains("\t"))
                lowestnumbertabs = count(line, "\t");
            else
                lowestnumbertabs = 0;
            String adder = "";
            for (int i = 0; i < lowestnumbertabs; i++)
                adder += "\t";
            adder += line.substring(line.indexOf("{")+1).trim();

            if (numberaccolades == 0){
                String adderRE = new StringBuilder(adder).reverse().toString();
                adderRE = adderRE.replaceFirst("}", "");
                adder = new StringBuilder(adderRE).reverse().toString();
            }
            if (adder.trim().length() > 0)
                transferFunctions.get(transferFunctions.size()-1).add(adder);

            if (numberaccolades == 0)
                ta_number = 0;
        } else {
            numberaccolades += count(line, "{");
            numberaccolades -= count(line, "}");
            if (lowestnumbertabs == Integer.MAX_VALUE){
                lowestnumbertabs = count(line, "\t");
            }

            if (line.trim().length() != 0){
                if (numberaccolades != 0){
                    int tabcount = count(line, "\t") - lowestnumbertabs;
                    String adder = "";
                    for (int i = 0; i < tabcount; i++)
                        adder += "\t";
                    adder += line.trim();
                    if (adder.trim().length() > 0)
                        transferFunctions.get(transferFunctions.size()-1).add(adder);
                } else {
                    ta_number = 0;
                    int tabcount = count(line, "\t") - lowestnumbertabs;
                    String adder = "";
                    for (int i = 0; i < tabcount; i++)
                        adder += "\t";
                    adder += line.substring(0, line.lastIndexOf("}")).trim();
                    if (adder.trim().length() > 0)
                        transferFunctions.get(transferFunctions.size()-1).add(adder);
                }
            }
        }
        if (ta_number == 0){
            type = 3;
        }
    }
}
