/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package mdeckers.thesis.uantwerp.model;

import java.awt.Component;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import static java.lang.Math.log;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Scanner;
import java.util.logging.Level;
import java.util.logging.Logger;
import java.util.zip.ZipInputStream;
import javax.swing.JFileChooser;
import javax.swing.filechooser.FileNameExtensionFilter;
import mdeckers.thesis.uantwerp.state.StateKeeper;

/**
 *
 * @author Michael
 */
public class Project {
    
    String projectLocation;
    
    Settings settings;
    StateKeeper state;
    
    
    
    public static void newModel(File file, StateKeeper state){
        Project loaded = new Project(state);
        loaded.createForFile(file);
    }
    
    public static void loadModel(Object caller, StateKeeper state){
        Project loaded = new Project(state);
       
        loaded.openProjectFile(caller);
     
    }

    private Project(StateKeeper state) {
        this.state = state;
        state.setProject(this);
        settings = new Settings();
    }
    
    public void createForFile(File file){
        projectLocation = file.getPath(); 
        settings.setProjectLocation(projectLocation);
        settings.read(file);
        state.updatedProject();
    }
    
    public void openProjectFile(Object caller){
        JFileChooser fc = new JFileChooser();
        fc.setAcceptAllFileFilterUsed(false);
        FileNameExtensionFilter filter = new FileNameExtensionFilter("DEVS Settings File", "devssettings");
        fc.setFileFilter(filter);
        //fc.setCurrentDirectory(new File("./files"));
        fc.setCurrentDirectory(new File("files"));
        
        int returnVal;
        returnVal = fc.showOpenDialog(null);

        if (returnVal == JFileChooser.APPROVE_OPTION) {
            File file = fc.getSelectedFile();
            
            createForFile(file);
        }
    }

    public Settings getSettings() {
        return settings;
    }
    
    public static ArrayList<String> readFromFile(File file) {
        try {
            Scanner scanner = new Scanner(file);
            ArrayList<String> list = new ArrayList<>();
            while (scanner.hasNextLine()){
                list.add(scanner.nextLine());
            }
            scanner.close();
            return list;
        } catch (FileNotFoundException ex) {
            Logger.getLogger(Project.class.getName()).log(Level.SEVERE, null, ex);
        }
        return null;
    }
    
    

}
