/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package mdeckers.thesis.uantwerp.model;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.UnsupportedEncodingException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.logging.Level;
import java.util.logging.Logger;
import java.util.zip.ZipInputStream;
import mdeckers.thesis.uantwerp.library.LibraryGetter;
import mdeckers.thesis.uantwerp.model.persistence.MessagePersistence;

/**
 *
 * @author Michael
 */
public class Settings {
    
    String name;
    ArrayList<String> components;
    ArrayList<Component> componentsObjects;
    ArrayList<AtomicDEVS> adevs;
    ArrayList<CoupledDEVS> cdevs;
    ArrayList<Message> messages;
    CoupledDEVS root;
    int type;
    public static String location;
    String thisPath;
    ArrayList<String> libraryLocations;

    public ArrayList<String> getLibraryLocation() {
        return libraryLocations;
    }

    public void setLibraryLocation(ArrayList<String> libraryLocation) {
        this.libraryLocations = libraryLocation;
    }
    
    String compilationLocation;
    String simulationSettings;
    
    ArrayList<File> allFiles;
    
    public Settings(){
        components = new ArrayList();
        adevs = new ArrayList();
        cdevs = new ArrayList();
        messages = new ArrayList();
        componentsObjects = new ArrayList();
        allFiles = new ArrayList();
        libraryLocations = new ArrayList();
    }
    
    public void save(){
        write(new File(thisPath), name, this.components, this.compilationLocation, this.simulationSettings, this.libraryLocations);
    }
    
    public static void write(File file, String name, ArrayList<String> components, String comp, String sim, ArrayList<String> lib){
        String sim2 = sim;
        PrintWriter writer = null;
        try {
            writer = new PrintWriter(file, "UTF-8");
            
            writer.write("[name = " + name + "]\n\n");
            
            writer.write("[DEVS components]\n");
            
            for (String s : components){
                System.out.println(s + "\n" + location);
                if (s.contains(location)){
                    
                    s = s.replace(location, ".");
                }
                writer.write(s + "\n");
            }
            writer.write("\n");
            
            writer.write("[root = Root]\n\n");
            
            writer.write("[compilation output]\n");
            if (comp.contains(location)){
                comp = comp.replace(location, ".");
            }
            writer.write(comp + "\n");
            writer.write("\n");
            
            writer.write("[simulation settings]\n");
            if (sim.contains(location)){
                sim = sim.replace(location, ".");
            }
            writer.write(sim + "\n");
            
            if (lib != null && !lib.isEmpty()){
                writer.write("[library location]\n");
                for (String s : lib){
                    if (s.contains(location)){
                        s = s.replace(location, ".");
                    }
                    writer.write(s + "\n");
                }
            }
            
            writer.close();
        } catch (FileNotFoundException ex) {
            Logger.getLogger(MessagePersistence.class.getName()).log(Level.SEVERE, null, ex);
        } catch (UnsupportedEncodingException ex) {
            Logger.getLogger(MessagePersistence.class.getName()).log(Level.SEVERE, null, ex);
        } finally {
            writer.close();
        }
        
        writeExperiment(sim2);
    }
    
    private static void writeExperiment(String sim){
        FileWriter fw = null;
        try {
            String text = "from pypdevs.DEVS import *\n" +
                    "import sys\n" +
                    "sys.path.append('C:/Users/Michael/Google Drive/School_15-16/Master Thesis/Programming/PyPDEVS_Compiler/files/compiled')\n" +
                    "from output import Root\n" +
                    "from pypdevs.simulator import Simulator\n" +
                    "def termination_condition(time, model):\n" +
                    "	time = time[0]\n" +
                    "	return time >= 10.0\n" +
                    "sim = Simulator(Root())\n" +
                    "sim.setClassicDEVS()\n" +
                    "sim.setVerbose()\n" +
                    "sim.setTerminationCondition(termination_condition)\n" +
                    "sim.simulate()";
            File file = new File(sim);
            fw = new FileWriter(file);
            fw.write(text);
        } catch (IOException ex) {
            Logger.getLogger(Settings.class.getName()).log(Level.SEVERE, null, ex);
        } finally {
            try {
                fw.close();
            } catch (IOException ex) {
                Logger.getLogger(Settings.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
    }
    
    
    public void addAtomic(AtomicDEVS comp, String line){
        components.add(line);
        File file = new File(line);
        allFiles.add(file);
        adevs.add(comp);
        componentsObjects.add(comp);
        ArrayList<String> buffer = new ArrayList();
        for (Component c : componentsObjects){
            if (c.library != 0){
                for (int i = 0; i < components.size(); i++){
                    if (components.get(i).equals(c.name)){
                        buffer.add(components.remove(i));
                        break;
                    }
                }
            }
        }
        Settings.write(new File(this.thisPath), name, components, this.compilationLocation, this.simulationSettings, this.libraryLocations);
        components.addAll(buffer);
    }
    
    public void addCoupled(CoupledDEVS comp, String line){
        components.add(line);
        File file = new File(line);
        allFiles.add(file);
        cdevs.add(comp);
        componentsObjects.add(comp);
        ArrayList<String> buffer = new ArrayList();
        for (Component c : componentsObjects){
            if (c.library != 0){
                for (int i = 0; i < components.size(); i++){
                    if (components.get(i).equals(c.name)){
                        buffer.add(components.remove(i));
                        break;
                    }
                }
            }
        }
        Settings.write(new File(this.thisPath), name, components, this.compilationLocation, this.simulationSettings, this.libraryLocations);
        components.addAll(buffer);
    }
    
    public void addMessage(Message comp, String line){
        components.add(line);
        File file = new File(line);
        allFiles.add(file);
        messages.add(comp);
        componentsObjects.add(comp);
        ArrayList<String> buffer = new ArrayList();
        for (Component c : componentsObjects){
            if (c.library != 0){
                for (int i = 0; i < components.size(); i++){
                    if (components.get(i).equals(c.name)){
                        buffer.add(components.remove(i));
                        break;
                    }
                }
            }
        }
        Settings.write(new File(this.thisPath), name, components, this.compilationLocation, this.simulationSettings, this.libraryLocations);
        components.addAll(buffer);
    }
    

    public void read(File file) {
        ArrayList<String> lines = Project.readFromFile(file);
        
        location = file.getParentFile().getPath();
        type = 0;
        
        for (String line : lines){
            treatLine(line);
        }
    }
  

    private void treatLine(String line) {
        if (line.contains("[name")){
            name = line.substring(line.indexOf("=")+1, line.lastIndexOf("]")).trim();
        } else if (line.contains("[DEVS components]")){
            type = 1;
        } else if (line.contains("[root")){
            findRoot(line.substring(line.indexOf("=")+1, line.lastIndexOf("]")).trim());
        } else if (line.contains("[META]")){
            type = 3;
        } else if (line.contains("[compilation output]")){
            type = 4;
        } else if (line.contains("[simulation settings]")){
            type = 5;
        } else if (line.contains("[library location")){
            type = 6;
        } else {
            switch(type){
                case 1: 
                    readComponent(line);
                    break;
                case 3:
                    readMETA(line);
                    break;
                case 4:
                    if (line.trim().length() > 0) {
                        compilationLocation = toAbsolutePath(line.trim());
                    }
                    break;
                case 5:
                    if (line.trim().length() > 0) {
                        simulationSettings = toAbsolutePath(line.trim());
                    }
                    break;
                case 6:
                    if (line.trim().length() > 0) {
                        readLib(toAbsolutePath(line.trim()));
                        
                        
                    }
                    break;
                default:
                    break;
            }
        }
    }
    
    private void readLib(String path){
        libraryLocations.add(path);
        ArrayList<Component> comps = LibraryGetter.getComponents(new File(path));
        
        for (Component c : comps){
            if (c instanceof AtomicDEVS){
                adevs.add((AtomicDEVS) c);
                componentsObjects.add(c);
            } else if (c instanceof CoupledDEVS){
                cdevs.add((CoupledDEVS) c);
                componentsObjects.add(c);
            } else if (c instanceof Message){
                messages.add((Message) c);
                componentsObjects.add(c);
            }
        }
    }

    private void readComponent(String line) {
        if (line.trim().length() == 0){
            return;
        }
        String extension = line.substring(line.lastIndexOf(".") + 1);
        if (extension.equals("adevs")){
            components.add(line);
            File file = new File(toAbsolutePath(line));
            allFiles.add(file);
            AtomicDEVS adder = new  AtomicDEVS(file);
            adevs.add(adder);
            componentsObjects.add(adder);
        } else if (extension.equals("cdevs")){
            File file = new File(toAbsolutePath(line));
            allFiles.add(file);
            CoupledDEVS adder = new  CoupledDEVS(file);
            components.add(line);
            cdevs.add(adder);
            componentsObjects.add(adder);
        } else if (extension.equals("devsmessage")){
            File file = new File(toAbsolutePath(line));
            allFiles.add(file);
            Message adder = new  Message(file);
            components.add(line);
            messages.add(adder);
            componentsObjects.add(adder);
        }
    }
    
    
    
    private String toAbsolutePath(String path){
        int count = 0;
        while (path.charAt(0) == '.'){
            count++;
            path = path.substring(1);
        }
        String prePath = location;
        
        for (int i = 1; i < count; i++){
            if (System.getProperty("os.name").startsWith("Windows")) {
                prePath = prePath.substring(0, prePath.lastIndexOf("\\"));
            } else {
                prePath = prePath.substring(0, prePath.lastIndexOf("/"));
            } 
        }
        if (path.charAt(0) == '/'){
            path = path.substring(1);
        }
        if (path.substring(0, 1).equals("\\")){
            path = path.substring(1);
        }
        if (count != 0){
            if (System.getProperty("os.name").startsWith("Windows")) {
                prePath = prePath + "\\" + path;
                prePath = prePath.replace("/", "\\");
            } else {
                prePath = prePath + "/" + path;
                prePath = prePath.replace("\\", "/");
            } 
            if (System.getProperty("os.name").startsWith("Windows")) {} else {
                prePath = "/".concat(prePath);
            } 
            return prePath;
        } else {
            if (System.getProperty("os.name").startsWith("Windows")) {} else {
                path = "/".concat(path);
            } 
            return path;
        }
        
    }
    
    public static ArrayList<String> readFromZipInputStream(ZipInputStream zis){
        ArrayList<String> result = new ArrayList();
        try {
            byte[] buffer = new byte[32768];
            int len;
            while ((len = zis.read(buffer)) > 0) {
                try {
                    String str = new String(buffer, "UTF-8");
                    result.add(str);
                } catch (UnsupportedEncodingException ex) {
                    Logger.getLogger(Project.class.getName()).log(Level.SEVERE, null, ex);
                }
            }
        } catch (IOException ex) {
            Logger.getLogger(Project.class.getName()).log(Level.SEVERE, null, ex);
        }
        String buf = result.get(0);
        
        String[] parts = buf.split("\n");
        result = new ArrayList(Arrays.asList(parts));
        
        return result;
    }

    private void readMETA(String line) {
        //not yet implemented
    }

    private String rootname;
    
    private void findRoot(String trim) {
        rootname = trim;
    }

    public String getName() {
        return name;
    }

    public ArrayList<String> getComponents() {
        return components;
    }

    public ArrayList<Component> getComponentsObjects() {
        return componentsObjects;
    }

    public ArrayList<AtomicDEVS> getAdevs() {
        return adevs;
    }

    public ArrayList<CoupledDEVS> getCdevs() {
        return cdevs;
    }

    public ArrayList<Message> getMessages() {
        return messages;
    }

    public CoupledDEVS getRoot() {
        return root;
    }

    public ArrayList<File> getAllFiles() {
        ArrayList<File> ret = new ArrayList();
        ret.addAll(allFiles);
        for (String s : this.libraryLocations){
            for (String d : LibraryGetter.getFileNames(new File(s))){
                if (!d.contains(".libinfo")){
                    ret.add(new File(d));
                }
            }
        }
        return ret;
    }

    public void setAllFiles(ArrayList<File> allFiles) {
        this.allFiles = allFiles;
    }

    public String getCompilationLocation() {
        return compilationLocation;
    }

    public void setCompilationLocation(String compilationLocation) {
        this.compilationLocation = compilationLocation;
    }

    public String getSimulationSettings() {
        return simulationSettings;
    }

    public void setSimulationSettings(String simulationSettings) {
        this.simulationSettings = simulationSettings;
    }

    public String getLocation() {
        return location;
    }

    void setProjectLocation(String projectLocation) {
        this.thisPath = projectLocation;
    }
    
}
