/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package mdeckers.thesis.uantwerp.model.persistence;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.io.UnsupportedEncodingException;
import java.util.ArrayList;
import java.util.logging.Level;
import java.util.logging.Logger;
import mdeckers.thesis.uantwerp.model.AtomicDEVS;

/**
 *
 * @author Michael
 */
public class AtomicDEVSPersistence {
    AtomicDEVS adevs;
    File file;
    
    public AtomicDEVSPersistence(File file, AtomicDEVS cdevs){
        this.file = file;
        this.adevs = cdevs;
    }
    
    public void persist () {
        PrintWriter writer = null;
        try {
            writer = new PrintWriter(file, "UTF-8");
            
            writer.write("[name = " + adevs.getName() + "]\n\n");
            writer.write("\n");
            writer.write("[state parameters]\n");
            
            for (String s : adevs.getParameters())
                writer.write(s + "\n");
            writer.write("\n");
            writer.write("\n[ports]\n");
            
            for (String s : adevs.getPorts())
                writer.write(s + "\n");
            
            writer.write("\n");
            writer.write("\n[states]\n");
            
            for (String s : adevs.getStates())
                writer.write(s + "\n");
            
            writer.write("\n");
            writer.write("\n[time advance]\n");
            
            for (ArrayList<String> a : adevs.getTAs()){
                writer.write(a.get(0) + " : {\n");
                for (int i = 1; i < a.size(); i++)
                    writer.write(a.get(i) + "\n");
                writer.write("}\n");
            }
            writer.write("\n");
            writer.write("\n[output function]\n");
            
            for (ArrayList<String> a : adevs.getOFs()){
                writer.write(a.get(0) + " : {\n");
                for (int i = 1; i < a.size(); i++)
                    writer.write(a.get(i) + "\n");
                writer.write("}\n");
            }
            writer.write("\n");
            writer.write("\n[internal transition]\n");
            
            /*if (!adevs.getITs().isEmpty()){
                writer.write(adevs.getITs().get(0).get(0) + "\n");
                writer.write(adevs.getITs().get(1).get(0) + "\n");

                for (int j = 2; j < adevs.getITs().size(); j++){
                    writer.write(adevs.getITs().get(j).get(0) + " : {\n");
                    for (int i = 1; i < adevs.getITs().get(j).size(); i++)
                        writer.write(adevs.getITs().get(j).get(i) + "\n");
                    writer.write("}\n");
                }
                
            }*/
            if (!adevs.getITs().isEmpty()){
                for (int j = 0; j < adevs.getITs().size(); j++){
                    if (j % 4 == 0){
                        writer.write(adevs.getITs().get(j).get(0) + "\n");
                    } else if (j % 4 == 1){
                        writer.write(adevs.getITs().get(j).get(0) + "\n");
                    } else {
                        writer.write(adevs.getITs().get(j).get(0) + " : {\n");
                        for (int i = 1; i < adevs.getITs().get(j).size(); i++)
                            writer.write(adevs.getITs().get(j).get(i) + "\n");
                        writer.write("}\n");
                    }
                }
            }
            
            writer.write("\n");
            writer.write("\n[external transition]\n");
            
            if (!adevs.getETs().isEmpty()){
                for (int j = 0; j < adevs.getETs().size(); j++){
                    if (j % 4 == 0){
                        writer.write(adevs.getETs().get(j).get(0) + "\n");
                    } else if (j % 4 == 1){
                        writer.write(adevs.getETs().get(j).get(0) + "\n");
                    } else {
                        writer.write(adevs.getETs().get(j).get(0) + " : {\n");
                        for (int i = 1; i < adevs.getETs().get(j).size(); i++)
                            writer.write(adevs.getETs().get(j).get(i) + "\n");
                        writer.write("}\n");
                    }
                }
            }
            
            writer.close();
        } catch (FileNotFoundException ex) {
            Logger.getLogger(MessagePersistence.class.getName()).log(Level.SEVERE, null, ex);
        } catch (UnsupportedEncodingException ex) {
            Logger.getLogger(MessagePersistence.class.getName()).log(Level.SEVERE, null, ex);
        } finally {
            writer.close();
        }
    
    }
    
    
}
