/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package mdeckers.thesis.uantwerp.model.persistence;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.io.UnsupportedEncodingException;
import java.util.ArrayList;
import java.util.logging.Level;
import java.util.logging.Logger;
import mdeckers.thesis.uantwerp.model.CoupledDEVS;

/**
 *
 * @author Michael
 */
public class CoupledDEVSPersistence {
    CoupledDEVS cdevs;
    File file;
    
    public CoupledDEVSPersistence(File file, CoupledDEVS cdevs){
        this.file = file;
        this.cdevs = cdevs;
    }
    
    public void persist () {
        PrintWriter writer = null;
        try {
            writer = new PrintWriter(file, "UTF-8");
            
            writer.write("[name = " + cdevs.getName() + "]\n\n");
            writer.write("\n");
            
            writer.write("[parameters]\n");
            for (String s : cdevs.getParameters())
                writer.write(s + "\n");
            writer.write("\n");
            
            writer.write("[components]\n");
            for (String s : cdevs.getComponents())
                writer.write(s + "\n");
            writer.write("\n");
            
            writer.write("[priorities]\n");
            for (String s : cdevs.getPriorities())
                writer.write(s + "\n");
            writer.write("\n");
            
            writer.write("\n[ports]\n");
            for (String s : cdevs.getPorts())
                writer.write(s + "\n");
            writer.write("\n");
            writer.write("\n[connections]\n");
            
            for (String s : cdevs.getConnections()){
                writer.write(s + "\n");
                if (!cdevs.getTransferFunctions().isEmpty()){
                    for (ArrayList<String> al : cdevs.getTransferFunctions()){
                        if (al.get(0).equals(s)){
                            writer.write("transfer function {\n");
                            for (int i = 1; i < al.size(); i++){
                                writer.write(al.get(i) + "\n");
                            }
                            writer.write("}\n");
                        }
                    }
                }
            }
            
            writer.close();
        } catch (FileNotFoundException ex) {
            Logger.getLogger(MessagePersistence.class.getName()).log(Level.SEVERE, null, ex);
        } catch (UnsupportedEncodingException ex) {
            Logger.getLogger(MessagePersistence.class.getName()).log(Level.SEVERE, null, ex);
        } finally {
            writer.close();
        }
    }
}
