from pypdevs.DEVS import *
from pypdevs.infinity import INFINITY

class PoliceMessage:
	def __init__(self, message=None):
		self.message = message


	def __str__(self):
		s = ""
		s += "state.message = " + str(self.message) + "\n"
		return s


class TrafficLightState:
	def __init__(self, name="", GreenTime=None, YellowTime=None, RedTime=None):
		self.name = name
		self.GreenTime = GreenTime
		self.YellowTime = YellowTime
		self.RedTime = RedTime


	def __str__(self):
		s = ""
		s += "state.name = " + str(self.name) + "\n"
		s += "state.GreenTime = " + str(self.GreenTime) + "\n"
		s += "state.YellowTime = " + str(self.YellowTime) + "\n"
		s += "state.RedTime = " + str(self.RedTime) + "\n"
		return s

class TrafficLight(AtomicDEVS):
	def __init__(self, name = "TrafficLight", GreenTime=6, YellowTime=2, RedTime=10):
		AtomicDEVS.__init__(self, name)

		self.my_ports = {}

		self.state = TrafficLightState(name="Green", GreenTime=GreenTime, YellowTime=YellowTime, RedTime=RedTime)

		self.my_ports = {"PoliceInterface": self.addInPort("PoliceInterface")}

	def timeAdvance(self):
		if self.state.name == "Red":
			return self.state.RedTime
			
		if self.state.name == "Yellow":
			return self.state.YellowTime
			
		if self.state.name == "Blinking":
			return INFINITY
			
		if self.state.name == "Green":
			return self.state.GreenTime
			
	def outputFnc(self):
		def subfunc(self):
			if self.state.name == "Red":
				return {}
				
			if self.state.name == "Yellow":
				return {}
				
			if self.state.name == "Blinking":
				return {}
				
			if self.state.name == "Green":
				return {}
				
		return {self.my_ports[k]: v for k, v in subfunc(self).iteritems()}
	def intTransition(self):
		def cond_int_Red_to_Green():
			return True
			
		def action_int_Red_to_Green():
			return {'RedTime' : self.state.RedTime, 'YellowTime' : self.state.YellowTime, 'GreenTime' : self.state.GreenTime}
			
		def cond_int_Yellow_to_Red():
			return True
			
		def action_int_Yellow_to_Red():
			return {'RedTime' : self.state.RedTime, 'YellowTime' : self.state.YellowTime, 'GreenTime' : self.state.GreenTime}
			
		def cond_int_Green_to_Yellow():
			return True
			
		def action_int_Green_to_Yellow():
			return {'RedTime' : self.state.RedTime, 'YellowTime' : self.state.YellowTime, 'GreenTime' : self.state.GreenTime}
			
		if self.state.name == "Red" and cond_int_Red_to_Green():
			return TrafficLightState(name="Green", **action_int_Red_to_Green())


		if self.state.name == "Yellow" and cond_int_Yellow_to_Red():
			return TrafficLightState(name="Red", **action_int_Yellow_to_Red())


		if self.state.name == "Green" and cond_int_Green_to_Yellow():
			return TrafficLightState(name="Yellow", **action_int_Green_to_Yellow())


		else:
			return AtomicDEVS.intTransition(self, my_inputs)

	def extTransition(self, my_inputs):
		inputs = {k.getPortName(): v for k, v in my_inputs.iteritems()}
		def cond_ext_Green_to_Blinking():
			if 'PoliceInterface' in inputs.keys():
				if isinstance(inputs['PoliceInterface'], PoliceMessage):
					if inputs['PoliceInterface'].message == "disable light":
						return True
			return False
			
		def action_ext_Green_to_Blinking():
			return {'RedTime' : self.state.RedTime, 'YellowTime' : self.state.YellowTime, 'GreenTime' : self.state.GreenTime}
			
		def cond_ext_Yellow_to_Blinking():
			if 'PoliceInterface' in inputs.keys():
				if isinstance(inputs['PoliceInterface'], PoliceMessage):
					if inputs['PoliceInterface'].message == "disable light":
						return True
			return False
			
		def action_ext_Yellow_to_Blinking():
			return {'RedTime' : self.state.RedTime, 'YellowTime' : self.state.YellowTime, 'GreenTime' : self.state.GreenTime}
			
		def cond_ext_Red_to_Blinking():
			if 'PoliceInterface' in inputs.keys():
				if isinstance(inputs['PoliceInterface'], PoliceMessage):
					if inputs['PoliceInterface'].message == "disable light":
						return True
			return False
			
		def action_ext_Red_to_Blinking():
			return {'RedTime' : self.state.RedTime, 'YellowTime' : self.state.YellowTime, 'GreenTime' : self.state.GreenTime}
			
		def cond_ext_Blinking_to_Red():
			if 'PoliceInterface' in inputs.keys():
				if isinstance(inputs['PoliceInterface'], PoliceMessage):
					if inputs['PoliceInterface'].message == "enable light":
						return True
			return False
			
		def action_ext_Blinking_to_Red():
			return {'RedTime' : self.state.RedTime, 'YellowTime' : self.state.YellowTime, 'GreenTime' : self.state.GreenTime}
			
		if self.state.name == "Green" and cond_ext_Green_to_Blinking():
			return TrafficLightState(name="Blinking", **action_ext_Green_to_Blinking())


		if self.state.name == "Yellow" and cond_ext_Yellow_to_Blinking():
			return TrafficLightState(name="Blinking", **action_ext_Yellow_to_Blinking())


		if self.state.name == "Red" and cond_ext_Red_to_Blinking():
			return TrafficLightState(name="Blinking", **action_ext_Red_to_Blinking())


		if self.state.name == "Blinking" and cond_ext_Blinking_to_Red():
			return TrafficLightState(name="Red", **action_ext_Blinking_to_Red())


		else:
			return AtomicDEVS.extTransition(self, my_inputs)


class PoliceOfficerState:
	def __init__(self, name=""):
		self.name = name


	def __str__(self):
		s = ""
		s += "state.name = " + str(self.name) + "\n"
		return s

class PoliceOfficer(AtomicDEVS):
	def __init__(self, name = "PoliceOfficer"):
		AtomicDEVS.__init__(self, name)

		self.my_ports = {}

		self.state = PoliceOfficerState(name="OutControl")

		self.my_ports = {"Command": self.addOutPort("Command")}

	def timeAdvance(self):
		if self.state.name == "OutControl":
			return 45
			
		if self.state.name == "InControl":
			return 15
			
	def outputFnc(self):
		def subfunc(self):
			if self.state.name == "OutControl":
				return {'Command' : PoliceMessage(message='disable light')}
				
			if self.state.name == "InControl":
				return {'Command' : PoliceMessage(message='disable light')}
				
		return {self.my_ports[k]: v for k, v in subfunc(self).iteritems()}
	def intTransition(self):
		def cond_int_OutControl_to_InControl():
			return True
			
		def action_int_OutControl_to_InControl():
			return {}
			
		def cond_int_InControl_to_OutControl():
			return True
			
		def action_int_InControl_to_OutControl():
			return {}
			
		if self.state.name == "OutControl" and cond_int_OutControl_to_InControl():
			return PoliceOfficerState(name="InControl", **action_int_OutControl_to_InControl())


		if self.state.name == "InControl" and cond_int_InControl_to_OutControl():
			return PoliceOfficerState(name="OutControl", **action_int_InControl_to_OutControl())


		else:
			return AtomicDEVS.intTransition(self, my_inputs)

	def extTransition(self, my_inputs):
		inputs = {k.getPortName(): v for k, v in my_inputs.iteritems()}
		return AtomicDEVS.extTransition(self, my_inputs)

class TrafficLightCoupled(CoupledDEVS):
	def __init__(self, name = "TrafficLightCoupled"):
		CoupledDEVS.__init__(self, name)

		self.my_ports = {}
		self.submodels = {}

		self.my_ports = {}

		self.submodels["light"] = self.addSubModel(TrafficLight(name = "light"))
		self.submodels["cop"] = self.addSubModel(PoliceOfficer(name = "cop"))
		self.connectPorts(self.submodels["cop"].my_ports["Command"], self.submodels["light"].my_ports["PoliceInterface"])

	def select(self, imm):
		for i, val in enumerate(imm):
			if isinstance(val, AtomicDEVS) or isinstance(val, CoupledDEVS):
				if val.getModelName() == "cop":
					return val
		for i, val in enumerate(imm):
			if isinstance(val, AtomicDEVS) or isinstance(val, CoupledDEVS):
				if val.getModelName() == "light":
					return val
		return imm[0]

